// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.CosEventComm.*;

class PullSupplier_impl extends _PullSupplierImplBase
{
    private ORB orb_; // The ORB
    private BOA boa_; // My BOA
    private boolean slow_; // Is this consumer slow?

    PullSupplier_impl(ORB orb, BOA boa, boolean slow)
    {
	orb_ = orb;
	boa_ = boa;
	slow_ = slow;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    disconnect_pull_supplier()
    {
	orb_.disconnect(this);
	boa_.deactivate_impl(null);
    }

    //
    // Supply date and time
    //
    public Any
    pull()
    {
	java.util.Date date = new java.util.Date();
	String s = "PullSupplier says: " + date.toString();

	Any any = orb_.create_any();
	any.insert_string(s);

	if(slow_)
	{
	    try
	    {
		Thread.sleep(2000);
	    }
	    catch(InterruptedException e)
	    {
	    }
	}

	return any;
    }

    public Any
    try_pull(BooleanHolder hasEvent)
    {
	hasEvent.value = true;
	return pull();
    }
}
