// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.CosEventComm.*;

class PushConsumer_impl extends _PushConsumerImplBase
{
    private ORB orb_; // The ORB
    private BOA boa_; // My BOA
    private boolean slow_; // Is this a slow consumer?

    PushConsumer_impl(ORB orb, BOA boa, boolean slow)
    {
	orb_ = orb;
	boa_ = boa;
	slow_ = slow;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    push(Any any)
    {
	//
	// Display event data if Any is a string
	//
	try
	{
	    String s = any.extract_string();
	    System.out.println(s);
	}
	catch(MARSHAL ex)
	{
	}
	if(slow_)
	{
	    try
	    {
		Thread.sleep(2000);
	    }
	    catch(InterruptedException e)
	    {
	    }
	}
    }

    public void
    disconnect_push_consumer()
    {
	orb_.disconnect(this);
	boa_.deactivate_impl(null);
    }
}
