// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin.impl;

import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

class AnyPusherThread extends PusherBaseThread
{
    public PushResult pushEvent(Event_impl event)
    {
	if(event == null)
	    throw new InternalError();
	if(consumer_ == null)
	    throw new InternalError();

        PushResult rc;

        try
        {
            consumer_.push(event.any());
            rc = PushResult.Success;
        }
        catch(COMM_FAILURE e)
        {
            rc = PushResult.Retry;
        }
	catch(TRANSIENT e)
	{
	    rc = PushResult.Retry;
	}
	catch(NO_RESPONSE e)
	{
	    rc = PushResult.Retry;
	}
        catch(Exception e)
        {
            rc = PushResult.Failed;
        }
        return rc;
    }

    AnyPusherThread(org.omg.CosEventComm.PushConsumer consumer,
                    org.omg.CosEventChannelAdmin.ProxyPushSupplier proxy,
                    long id,
                    long maxEvents,
                    long maxRetries,
                    long retryTimeout,
                    double retryMultiplier)
    {
        super("AnyPusherThread", consumer, proxy, id, maxEvents, maxRetries,
	      retryTimeout, retryMultiplier);
    }
}
