// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
package com.ooc.CosEventChannelAdmin.impl;

import java.util.*;
import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

class ConsumerAdmin
    extends org.omg.CosEventChannelAdmin._ConsumerAdminImplBase
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    // ------------------------------------------------------------------
    // ConsumerAdmin constructor
    // ------------------------------------------------------------------

    ConsumerAdmin(ORB orb, Reaper reaper, PipeSegment pipe)
    {
	adminImpl_ = new AdminBaseImpl(orb, reaper, pipe);
    }
                  
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushSupplier.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_push_supplier()
    {
        if(adminImpl_.destroyed())
            throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushSupplier p = new ProxyPushSupplier(info);
        adminImpl_.addProxy(p);

	return p;
    }

    //
    // Get ProxyPullSupplier.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPullSupplier
    obtain_pull_supplier()
    {
        if(adminImpl_.destroyed())
            throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPullSupplier p = new ProxyPullSupplier(info);
	adminImpl_.addProxy(p);

	return p;
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------

    public synchronized void disconnect()
    {
	adminImpl_.disconnect();
        adminImpl_.getOrb().disconnect(this);
    }

    public synchronized void discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
