// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin.impl;

import java.util.*;
import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

class SupplierAdmin
    extends org.omg.CosEventChannelAdmin._SupplierAdminImplBase
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;
    
    // ------------------------------------------------------------------
    // SupplierAdmin constructor
    // ------------------------------------------------------------------

    SupplierAdmin(ORB orb, Reaper reaper, PipeSegment pipe)
    {
	adminImpl_ = new AdminBaseImpl(orb, reaper, pipe);
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushConsumer.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPushConsumer
    obtain_push_consumer()
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushConsumer p = new ProxyPushConsumer(info);
	adminImpl_.addProxy(p);

	return p;
    }

    //
    // Get ProxyPullConsumer.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_pull_consumer()
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPullConsumer p = new ProxyPullConsumer(info);
	adminImpl_.addProxy(p);

	return p;
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------

    public synchronized void disconnect()
    {
	adminImpl_.disconnect();
        adminImpl_.getOrb().disconnect(this);
    }

    public synchronized void discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
