// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

package com.ooc.CosEventServer;

//
// Base class for all proxies
//
public interface ProxyBase
{
    //
    // Disconnect the servant from the ORB
    //
    public void deactivateObject();
    
    //
    // Called during disconnect
    //
    public void disconnectPeer();

    //
    // Disconnect the proxy
    //
    public void disconnect();

    //
    // Don't accept further requests
    //
    public void discardRequests();

    //
    // Has this proxy been destroyed?
    //
    public boolean destroyed();

    //
    // Can this proxy be reaperd?
    //
    public boolean canReap();

    //
    // What was the time of the last request?
    //
    public long lastRequestTime();

    //
    // Set the time of the last request
    //
    public void stampRequest();

    //
    // Get the name of the proxy
    //
    public String getName();
}
