// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTypedEventChannelAdmin.impl;

import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

//
// PipeSegment for the Typed ProxyPushSupplier
//
class PushPipeSegment extends PipeSegment
{
    //
    // The event pusher.
    //
    private PusherBaseThread pusher_;

    public PushPipeSegment(PusherBaseThread pusher)
    {
        pusher_ = pusher;
    }

    public boolean
    receive(Event_impl event)
    {
        if(destroy_)
            return false;

        pusher_.newEvent(event);

        return true;
    }

    public void
    destroy()
    {
        if(destroy_)
            return;

	if(pusher_ == null)
	    throw new InternalError();
        pusher_.halt();
        super.destroy();
    }
}
