// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
package com.ooc.CosTypedEventChannelAdmin.impl;

import java.util.*;
import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

class TypedConsumerAdmin
    extends org.omg.CosTypedEventChannelAdmin._TypedConsumerAdminImplBase
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    //
    // My channel type.
    //
    private ChannelType type_;

    // ------------------------------------------------------------------
    // TypedConsumerAdmin constructor
    // ------------------------------------------------------------------

    public TypedConsumerAdmin(ORB orb, Reaper reaper, PipeSegment pipe,
    			      ChannelType type)
    {
	adminImpl_ = new AdminBaseImpl(orb, reaper, pipe);
        type_ = type;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushSupplier.
    //
    public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_push_supplier()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get ProxyPullSupplier.
    //
    public org.omg.CosEventChannelAdmin.ProxyPullSupplier
    obtain_pull_supplier()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get TypedProxyPushSupplier.
    //
    synchronized
    public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_typed_push_supplier(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.NoSuchImplementation
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();
	
	//
	// Attempt to assign this type id to the channel.
	//
	if(!type_.assignTypeId(typeId))
	    throw new org.omg.CosTypedEventChannelAdmin.NoSuchImplementation();
	
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushSupplier p = new ProxyPushSupplier(info);
	adminImpl_.addProxy(p);
	
	return p;
    }
    
    //
    // Get TypedProxyPullSupplier.
    //
    synchronized
    public org.omg.CosTypedEventChannelAdmin.TypedProxyPullSupplier
    obtain_typed_pull_supplier(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.InterfaceNotSupported
    {
	throw new NO_IMPLEMENT();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------

    public synchronized void disconnect()
    {
	adminImpl_.disconnect();
        adminImpl_.getOrb().disconnect(this);
    }

    public synchronized void discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
