// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTypedEventChannelAdmin.impl;

import java.util.*;
import com.ooc.CosEventServer.*;
import org.omg.CORBA.*;

class TypedSupplierAdmin
    extends org.omg.CosTypedEventChannelAdmin._TypedSupplierAdminImplBase
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    //
    // The channel type
    //
    private ChannelType type_;

    // ------------------------------------------------------------------
    // TypedConsumerAdmin constructor
    // ------------------------------------------------------------------

    TypedSupplierAdmin(ORB orb, Reaper reaper, PipeSegment pipe,
    		       ChannelType type)
    {
	adminImpl_ = new AdminBaseImpl(orb, reaper, pipe);
	type_ = type;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushConsumer.
    //
    public org.omg.CosEventChannelAdmin.ProxyPushConsumer
    obtain_push_consumer()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get ProxyPullConsumer.
    //
    public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_pull_consumer()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get TypedProxyPushConsumer.
    //
    synchronized
    public org.omg.CosTypedEventChannelAdmin.TypedProxyPushConsumer
    obtain_typed_push_consumer(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.InterfaceNotSupported
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();

	//
	// Attempt to assign this type id to the channel.
	//
	if(!type_.assignTypeId(typeId))
	    throw new org.omg.CosTypedEventChannelAdmin.InterfaceNotSupported();
	
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	TypedProxyPushConsumer p = new TypedProxyPushConsumer(info, type_);
	adminImpl_.addProxy(p);

	return p;
    }

    //
    // Get TypedProxyPullConsumer.
    //
    synchronized
    public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_typed_pull_consumer(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.NoSuchImplementation
    {
	throw new NO_IMPLEMENT();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------

    public synchronized void disconnect()
    {
	adminImpl_.disconnect();
        adminImpl_.getOrb().disconnect(this);
    }

    public synchronized void discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
