#!/bin/perl
# **********************************************************************
#
# Copyright (c) 2000 
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

package Test_Control;

use Tests;
use strict;
use Exporter;

use vars qw(%tests
	    @ISA 
	    @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw(&testControlSetup
	     &executeTest);

#
# Set up the test hash to contain the correct function calls
#
sub testControlSetup()
{
    $tests{"Sending_Events"} = "SendEvents";
    $tests{"Sending_Typed_Events"} = "SendTypedEvents";
    $tests{"Multiple_Consumers_And_Suppliers"} = "MultipleProxies";
    $tests{"Multiple_Consumers_And_Suppliers_Typed"} = "MultipleTypedProxies";
}

#
# Parse a command line and call the appropriate test
#
sub executeTest($)
{
    my $command = shift;
    $command =~ s/\s+$//;
   
    #	
    # Split the command into words.  Use the first word to retreive
    # the appropriate command.  The rest of the words will be argumants
    # to the command.
    #
    my @tokens = split(" ", $command);
    my $exec = $tests{$tokens[0]};
    my $len = scalar(@tokens);
   
    $exec = $exec . " (\"$tokens[1]";
    for(my $i = 2 ; $i < $len - 1 ; $i++)
    {
	$exec = $exec . " $tokens[$i]";
    }
    if($len > 2) 
    {
    	$exec = $exec . " $tokens[$len - 1]\")";
    } 
    else
    {
    	$exec = $exec . "\")";
    }

    #
    # Make the appropriate function call
    #
    eval $exec;
}


