#!/usr/bin/perl
# **********************************************************************
#
# Copyright (c) 2000 
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

use Tests;
use Extraction;
use TestSuiteUtilities;
use Test_Control;

&extractionSetup();
&testControlSetup();

#
# The variable input will hold the unformatted command string.
#
my $arg = $ARGV[0];
my $arg2  = $ARGV[1];

my $input = &readCommands($arg, $arg2);
&initializeTools();

#
# Parse the command string into a hash
#
&parseInput($input);

#
# We now have a hash of the commands to be executed in the test.
# Examine each command and execute it accordingly.
#
if (&getCommandCount() eq 0)
{
    print "No tests were specified in the regression input file\n";
}
for (my $i=0; $i<&getCommandCount(); $i++) 
{
    my $com = &getCommand($i);
    executeTest($com);
    if (&getStatus() eq "0")
    {
        exit();	
    }
}

#
# Need to print last output message
#
&printLastMessage();


