# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= OBNaming.jar

!include $(top_srcdir)\config\Make.rules.mak

ALL_LIBS	= $(OB_LIB);$(OB_UTIL_LIB)

IDLDIR		= $(top_srcdir)\idl

all:: omg ooc console images

omg: $(top_srcdir)\lib generated
	$(JIDL) --package org.omg --output-dir generated \
	$(IDLDIR)\CosNaming.idl
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(OB_LIB);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\CosNaming\*.java \
	generated\org\omg\CosNaming\NamingContextPackage\*.java

ooc: $(top_srcdir)\lib generated
	$(JIDL) -I$(IDLDIR) -I. --auto-package --output-dir generated \
	--no-skeletons Types.idl
	$(JIDL) -I$(IDLDIR) --auto-package --output-dir generated \
	$(IDLDIR)/BindingListener.idl \
	$(IDLDIR)/OBNaming.idl
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(OB_LIB);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\CosNaming\*.java \
	generated\com\ooc\CosNaming\OBNamingContextPackage\*.java \
	generated\com\ooc\CosNaming\Database\*.java \
	com\ooc\CosNaming\*.java

console: $(top_srcdir)\lib
	set CLASSPATH=.;$(top_srcdir)\lib;$(ALL_LIBS);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\CosNamingConsole\Util\*.java \
	com\ooc\CosNamingConsole\GUI\*.java \
	com\ooc\CosNamingConsole\*.java

images: $(top_srcdir)\lib\com\ooc\CosNamingConsole\images
	copy com\ooc\CosNamingConsole\images\*.gif \
	$(top_srcdir)\lib\com\ooc\CosNamingConsole\images

$(top_srcdir)\lib\com\ooc\CosNamingConsole\images: $(top_srcdir)\lib
	mkdir $@

jar:
	cd $(top_srcdir)\lib
	if exist $(NAME) del $(NAME)
	$(JAR) $(JARFLAGS) $(NAME) org com

install:: jar
	copy $(top_srcdir)\lib\$(NAME) $(libdir)

clean::
	-rmdir /s /q $(top_srcdir)\lib
