// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.GUI;

import javax.swing.*;
import javax.swing.table.*;

final public class BindingTable extends JTable
{
    public BindingTable(TableModel model)
    {
	super(model);

	setAutoCreateColumnsFromModel(true);
	setColumnSelectionAllowed(false);
	getTableHeader().setUpdateTableInRealTime(false);
    }

    //
    // The ID column has an icon renderer of its own
    //
    public TableCellRenderer
    getCellRenderer(int row, int col)
    {
	if(col == getColumnModel().getColumnIndex("ID"))
	    return TableRenderer.instance();
	else
	    return super.getCellRenderer(row, col);
    }

    //
    // This workaround results in keyboard events like Ctrl-C not
    // calling the cell editor.
    //
    public boolean
    editCellAt(int row, int col, java.util.EventObject e)
    {
        if(e == null)
            return false;
        else if(e.getSource() instanceof JFrame)
            return super.editCellAt(row, col, null);
        else
            return super.editCellAt(row, col, e);
    }
}
