// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.GUI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.ooc.Util.GUI.*;
import com.ooc.Util.CORBA.GUI.*;

final public class EnterIORDialog extends JDialog implements ActionListener
{
    private IORInputPanel iorPanel_;
    private boolean valid_;
    private org.omg.CORBA.Object result_;

    public
    EnterIORDialog(Frame parent)
    {
	super(parent, AppStandards.getString("EnterIORTitleKey"), true);

	setResizable(true);

        //
        // Closing the dialog is the same as pressing the "Cancel" button
        //
        addWindowListener(
            new WindowAdapter()
            {
                public void
                windowClosing(WindowEvent evt)
                {
                    cancel();
                }
            }
        );

	Container content = getContentPane();
        content.setLayout(new GridBagLayout());

        iorPanel_ = new IORInputPanel(parent, "IORSourceKey");
        Constrain.constrain(content, iorPanel_, 0, 0, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST,
            1.0, 0.0, 10, 10, 0, 10);

        Constrain.constrain(content, Box.createGlue(), 0, 4, 1, 1,
            GridBagConstraints.BOTH, GridBagConstraints.CENTER,
            1.0, 1.0, 0, 0, 0, 0);
 
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1, 2, 5, 0));
        JButton button;
        button = AppStandards.createButton("OkButtonKey");
        button.setActionCommand("ok");
        button.addActionListener(this);
        buttonPanel.add(button);

        button = AppStandards.createButton("CancelButtonKey");
        button.setActionCommand("cancel");
        button.addActionListener(this);
        buttonPanel.add(button);
 
        Constrain.constrain(content, buttonPanel, 0, 1, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.EAST,
            0.0, 0.0, 10, 0, 5, 10);

	//
	// Pressing the Enter key means OK
	//
	JTextField textField = iorPanel_.getTextField();
	textField.setActionCommand("ok");
	textField.addActionListener(this);

        pack();

        Point p = parent.getLocation();
        setLocation(p.x + 20, p.y + 20); 
    }

    //
    // Ensure that textfield gets the focus
    //
    public void
    setVisible(boolean b)
    {
	if(b)
	    iorPanel_.getTextField().requestFocus();

	super.setVisible(b);
    }

    public void
    actionPerformed(ActionEvent e)
    {
        String command = e.getActionCommand();
        if(command.equals("ok"))
            ok();
        else if(command.equals("cancel"))
            cancel();
    }

    public boolean
    getResult()
    {
	return valid_;
    }

    public org.omg.CORBA.Object
    getObject()
    {
	return result_;
    }

    private void
    ok()
    {
	result_ = null;

	if(!iorPanel_.isNil())
	{
	    StringBuffer message = new StringBuffer();
	    result_ = iorPanel_.getObject(message);

	    if(result_ == null)
	    {
		MessageDialog.showError(this, message.toString());
		return;
	    }
	}

        setVisible(false);

	valid_ = true;
    }

    private void
    cancel()
    {
	result_ = null;
        setVisible(false);

	valid_ = false;
    }
}
