// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.GUI;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.ooc.CosNamingConsole.Util.*;
import com.ooc.Util.GUI.*;

public class LogWindow extends JFrame implements ActionListener
{
    //
    // The message area
    //
    private MessageArea messageArea_;

    public LogWindow(String title)
    {
	super(title);

	addWindowListener(new WindowAdapter()
	{
	    public void
	    windowClosing(WindowEvent e)
	    {
		close();
	    }
	});

	Container content = getContentPane();
        content.setLayout(new GridBagLayout());

	messageArea_ = new MessageArea(this);
        Constrain.constrain(content, messageArea_, 0, 0, 1, 1,
            GridBagConstraints.BOTH, GridBagConstraints.NORTH,
            1.0, 1.0, 0, 0, 0, 0);

        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(1, 2, 10, 0));

	addButtons(buttonPanel);

        Constrain.constrain(content, buttonPanel, 0, 1, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.EAST,
            0.0, 0.0, 10, 0, 5, 10);
 
	pack();
	setLocation(100, 200);
    }

    protected void
    addButtons(JPanel buttonPanel)
    {
	JButton button;

        button = AppStandards.createButton("CloseButtonKey");
        button.setActionCommand("close");
        button.addActionListener(this);
        buttonPanel.add(button);

        button = AppStandards.createButton("ClearButtonKey");
        button.setActionCommand("clear");
        button.addActionListener(this);
        buttonPanel.add(button);
    }

    public MessageLogger
    getLogger()
    {
	return messageArea_;
    }

    //
    // WIndow is being closed
    //
    protected void
    close()
    {
	// Do nothing here, window is automatically closed
    }

    public void
    actionPerformed(ActionEvent e)
    {
	String command = e.getActionCommand();

	if(command.equals("clear"))
	    messageArea_.clear();

	else if(command.equals("close"))
	    processWindowEvent(new WindowEvent(
		this, java.awt.event.WindowEvent.WINDOW_CLOSING));
    }
}
