// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.GUI;

import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import com.ooc.CosNamingConsole.*;

final public class TableRenderer extends DefaultTableCellRenderer
{
    //
    // The singleton TableRenderer
    //
    static private TableRenderer instance_;

    //
    // Default icons
    //
    static private Icon contextIcon_;
    static private Icon objectIcon_;

    public static TableRenderer
    instance()
    {
	if(instance_ == null)
	    instance_ = new TableRenderer();

	return instance_;
    }

    private TableRenderer()
    {
	java.net.URL url;

	url = getClass().getResource(
	    "/com/ooc/CosNamingConsole/images/binding.gif");
	objectIcon_ = new ImageIcon(url);

	setOpaque(true);
    }

    public static void
    setContextIcon(Icon contextIcon)
    {
	contextIcon_ = contextIcon;
    }

    public Component
    getTableCellRendererComponent(JTable table, Object value,
				  boolean isSelected, boolean hasFocus,
				  int row, int col)
    {
	if(value != null)
	{
	    BindingInfo info = (BindingInfo)table.getValueAt(row, -1);

	    setText(info.getID());

	    if(info.getContext() != null)
		setIcon(contextIcon_);
	    else
		setIcon(objectIcon_);
	}

	return super.getTableCellRendererComponent(table, value,
						   isSelected, hasFocus,
						   row, col);
    }
}

