// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.Util;

import java.util.*;

public class AppResources extends ListResourceBundle
{
    static final Object[][] contents_ =
    {
	// Buttons
        { "OkButtonKey",              "OK" },
        { "CancelButtonKey",          "Cancel" },
        { "CloseButtonKey",           "Close" },
	{ "StopButtonKey",            "Stop" },
	{ "ContButtonKey",            "Continue" },
	{ "ClearButtonKey",           "Clear" },
	{ "BrowseButtonKey",          "Browse..." },
	{ "NewIconButtonKey",         "New Type..." },
	{ "NewIconButtonMnemKey",     new Character('N') },
	{ "NewIconButtonAccelKey",    new Character((char)0) },
	{ "EditIconButtonKey",        "Edit..." },
	{ "EditIconButtonMnemKey",    new Character('E') },
	{ "EditIconButtonAccelKey",   new Character((char)0) },
        { "RemoveIconButtonKey",      "Remove" },
	{ "RemoveIconButtonMnemKey",  new Character('R') },
	{ "RemoveIconButtonAccelKey", new Character((char)0) },

	// Titles
	{ "TopWindowTitleKey",     "ORBacus Names Console" },
	{ "LoadContextTitleKey",   "Load Context" },
	{ "SaveContextTitleKey",   "Save Context" },
	{ "SaveIORTitleKey",       "Save IOR to File" },
	{ "EnterIORTitleKey",      "Enter IOR" },
	{ "IORFileTitleKey",       "Load IOR" },
	{ "TrimTitleKey",          "Name Conflict" },
        { "ErrorTitleKey",         "Error" },
        { "ConfirmTitleKey",       "Confirm" },

	// Toolbar tips
	{ "ToolbarUpKey",            "Up One Level" },
	{ "ToolbarCutKey",           "Cut" },
	{ "ToolbarCopyKey",          "Copy" },
	{ "ToolbarPasteKey",         "Paste" },
	{ "ToolbarDeleteKey",        "Delete" },
	{ "ToolbarShowListKey",      "Show Simple List" },
	{ "ToolbarShowDetailsKey",   "Show Details" },
	{ "ToolbarRefreshKey",       "Refresh" },

	// Table titles
	{ "TableIdKey",              "ID" },
	{ "TableKindKey",            "Kind" },
	{ "TableTimeKey",            "Modified" },

	// Information messages
	{ "AllContextsKey",        "All Contexts" },
	{ "ContentsOfKey",         "Contents of" },

	// Error messages
        { "InvalidObjectKey",    "Invalid object reference" },
	{ "FileNotFoundKey",     "File {0} does not exist." },
	{ "FileErrorKey",        "I/O error occurred accessing file {0}." },
	{ "FileExistsKey",       "File {0} already exists. Overwrite?"},
	{ "Trim1Key",            "This name has leading or trailing spaces." },
	{ "Trim2Key",            "Remove these spaces before proceeding?" },
	{ "NotEmptyKey",         "Are you sure you want to delete context\n" +
	  "{0} and all of its contents?" },
	{ "SwitchErrorKey",      "Cannot contact this NamingContext." },

	// Other messages
	{ "QuitKey",             "Do you really want to quit?" },

	// Menu items and accelerator characters
	{ "FileMenuKey",            "File" },
	{ "FileMenuMnemKey",        new Character('F') },
	{ "FileMenuAccelKey",       new Character((char)0) },
	{ "EditMenuKey",            "Edit" },
	{ "EditMenuMnemKey",        new Character('E') },
	{ "EditMenuAccelKey",       new Character((char)0) },
	{ "ViewMenuKey",            "View" },
	{ "ViewMenuMnemKey",        new Character('V') },
	{ "ViewMenuAccelKey",       new Character((char)0) },
	{ "ToolsMenuKey",           "Tools" },
	{ "ToolsMenuMnemKey",       new Character('T') },
	{ "ToolsMenuAccelKey",      new Character((char)0) },

	{ "NewWindowKey",           "New Window" },
	{ "NewWindowMnemKey",       new Character('N') },
	{ "NewWindowAccelKey",      new Character((char)0) },
	{ "SwitchRootKey",          "Switch Root Context..." },
	{ "SwitchRootMnemKey",      new Character('R') },
	{ "SwitchRootAccelKey",     new Character((char)0) },
	{ "LoadContextKey",         "Load Context..." },
	{ "LoadContextMnemKey",     new Character('L') },
	{ "LoadContextAccelKey",    new Character('L') },
	{ "SaveContextAsKey",       "Save Context As..." },
	{ "SaveContextAsMnemKey",   new Character('S') },
	{ "SaveContextAsAccelKey",  new Character('S') },
	{ "NewContextKey",          "New Context" },
	{ "NewContextMnemKey",      new Character('N') },
	{ "NewContextAccelKey",     new Character('N') },
	{ "NewBindingKey",          "New Binding" },
	{ "NewBindingMnemKey",      new Character('B') },
	{ "NewBindingAccelKey",     new Character('B') },
	{ "DeleteKey",              "Delete" },
        { "DeleteMnemKey",          new Character('D') },
        { "DeleteAccelKey",         new Character(
	    (char)java.awt.event.KeyEvent.VK_DELETE) },
	{ "LinkKey",                "Link" },
	{ "LinkMnemKey",            new Character('L') },
	{ "LinkAccelKey",           new Character((char)0) },
	{ "UnlinkKey",              "Unlink" },
	{ "UnlinkMnemKey",          new Character('U') },
	{ "UnlinkAccelKey",         new Character((char)0) },
	{ "ChangeIdKey",            "Change ID" },
	{ "ChangeIdMnemKey",        new Character('I') },
	{ "ChangeIdAccelKey",       new Character((char)0) },
	{ "ChangeKindKey",          "Change Kind" },
	{ "ChangeKindMnemKey",      new Character('K') },
	{ "ChangeKindAccelKey",     new Character((char)0) },
	{ "ChangeIORKey",           "Change IOR..." },
	{ "ChangeIORMnemKey",       new Character('O') },
	{ "ChangeIORAccelKey",      new Character((char)0) },
	{ "RenameKey",              "Rename" },
	{ "SaveIORKey",             "Save IOR to File..." },
	{ "SaveIORMnemKey",         new Character('F') },
	{ "SaveIORAccelKey",        new Character('F') },
	{ "CloseWindowKey",         "Close Window" },
	{ "CloseWindowMnemKey",     new Character((char)0) },
	{ "CloseWindowAccelKey",    new Character((char)0) },
	{ "ExitKey",                "Exit" },
	{ "ExitMnemKey",            new Character('x') },
	{ "ExitAccelKey",           new Character('Q') },

	{ "OpenKey",                "Open Context" },
        { "OpenMnemKey",            new Character('O') },

        { "CutKey",                 "Cut" },
        { "CutMnemKey",             new Character('t') },
        { "CutAccelKey",            new Character('X') },
        { "CopyKey",                "Copy" },
        { "CopyMnemKey",            new Character('C') },
        { "CopyAccelKey",           new Character('C') },
        { "PasteKey",               "Paste" },
        { "PasteMnemKey",           new Character('P') },
        { "PasteAccelKey",          new Character('V') },
        { "SelectAllKey",           "Select all" },
        { "SelectAllMnemKey",       new Character('A') },
        { "SelectAllAccelKey",      new Character('A') },
	{ "InvertSelectionKey",     "Invert Selection" },
	{ "InvertSelectionMnemKey", new Character('S') },
	{ "InvertSelectionAccelKey", new Character((char)0) },

	{ "ToggleToolBarKey",        "Toolbar" },
	{ "ToggleToolBarMnemKey",    new Character('T') },
	{ "ToggleToolBarAccelKey",   new Character((char)0) },
	{ "ToggleStatusBarKey",      "Statusbar" },
	{ "ToggleStatusBarMnemKey",  new Character('S') },
	{ "ToggleStatusBarAccelKey", new Character((char)0) },
	{ "ToggleErrorWindowKey",    "Error Window" },
	{ "ToggleErrorWindowMnemKey", new Character('E') },
	{ "ToggleErrorWindowAccelKey", new Character((char)0) },
	{ "ShowListKey",            "Simple List" },
	{ "ShowListMnemKey",        new Character('L') },
	{ "ShowListAccelKey",       new Character((char)0) },
	{ "ShowDetailsKey",         "Details" },
	{ "ShowDetailsMnemKey",     new Character('D') },
	{ "ShowDetailsAccelKey",    new Character((char)0) },
	{ "SortMenuKey",            "Sort" },
	{ "SortMenuMnemKey",        new Character('o') },
	{ "SortMenuAccelKey",       new Character((char)0) },
	{ "SortByIdKey",            "by ID" },
	{ "SortByIdMnemKey",        new Character('I') },
	{ "SortByIdAccelKey",       new Character((char)0) },
	{ "SortByKindKey",          "by Kind" },
	{ "SortByKindMnemKey",      new Character('K') },
	{ "SortByKindAccelKey",     new Character((char)0) },
	{ "SortByTimeKey",          "by Time" },
	{ "SortByTimeMnemKey",      new Character('T') },
	{ "SortByTimeAccelKey",     new Character((char)0) },
	{ "RefreshKey",             "Refresh" },
	{ "RefreshMnemKey",         new Character('R') },
	{ "RefreshAccelKey",        new Character('R') },

	{ "PingKey",                "Ping..." },
	{ "PingMnemKey",            new Character('P') },
	{ "PingAccelKey",           new Character('P') },
	{ "CleanupKey",             "Clean up" },
	{ "CleanupMnemKey",         new Character('C') },
	{ "CleanupAccelKey",        new Character((char)0) },

	// Dialog windows
	{ "ErrorWindowTitleKey",   "ORBacus Names Console Error Window" },
	{ "PingWindowTitleKey",    "ORBacus Names Console Ping Window" },

	// Enter IOR
	{ "IORSourceKey",          "Target IOR" },
	{ "IORFileKey",            "From File" },

        // Usage
	{ "UsageKey",
 
	  "Usage: java com.ooc.CosNamingConsole.Main [options]\n\n" +
	  "Options:\n" +
	  "-f, --file FILE   Read the NamingService IOR from file FILE.\n" +
	  "-i, --ior         Display NamingService IOR on standard output.\n" +
	  "-n, --no-updates  No automatic updates.\n" +
	  "--look CLASS      Specifies the Look & Feel CLASS.\n" +
	  "--windows         Shortcut for Windows Look & Feel " +
	  "(if available).\n" +
	  "--motif           Shortcut for Motif Look & Feel " +
	  "(if available).\n" +
	  "--mac             Shortcut for Macintosh Look & Feel " +
	  "(if available).\n" +
	  "-h, --help        Show this message.\n" +
	  "-v, --version     Show ORBacus Names Console version."}
    };

    public Object[][]
    getContents()
    {
        return contents_;
    }
}
