// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNamingConsole.Util;

import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

final public class Except
{
    private Except()
    {
    }

    //
    // Get exception string
    //
    public static String
    getException(Exception ex)
    {
	String except;

	if(ex instanceof AlreadyBound)
	    except = "Caught `AlreadyBound' exception";
	else if(ex instanceof CannotProceed)
	{
	    CannotProceed exc = (CannotProceed)ex;

	    except = "Caught `CannotProceed' exception: ";
	    for(int i = 0 ; i < exc.rest_of_name.length ; i++)
	    {
		if(i != 0)
		    except += "/";

		except += exc.rest_of_name[i].id;
		if(exc.rest_of_name[i].kind.length() != 0)
		    except += "." + exc.rest_of_name[i].kind;
	    }
	}
	else if(ex instanceof InvalidName)
	    except = "Caught `InvalidName' exception";
	else if(ex instanceof NotEmpty)
	    except = "Caught `NotEmpty' exception";
	else if(ex instanceof NotFound)
	{
	    NotFound exc = (NotFound)ex;

	    except = "Caught `NotFound' exception: ";
	    for(int i = 0 ; i < exc.rest_of_name.length ; i++)
	    {
		if(i != 0)
		    except += "/";

		except += exc.rest_of_name[i].id;
		if(exc.rest_of_name[i].kind.length() != 0)
		    except += "." + exc.rest_of_name[i].kind;
	    }
	}
	else if(ex instanceof COMM_FAILURE)
	    except = "Caught `COMM_FAILURE' exception";
	else if(ex instanceof NO_RESPONSE)
	    except = "Caught `NO_RESPONSE' exception";
	else if(ex instanceof OBJECT_NOT_EXIST)
	    except = "Caught `OBJECT_NOT_EXIST' exception";
	else
	    except = "";

	return except;
    }
}
