// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CORBA;

//
// This class provides some help for URL
// object-reference encodings.
//
class INS
{
    // 
    // Perform a string to object via a CorbaURL
    // 
    static protected org.omg.CORBA.Object
    stringToObject(ORB orb, String s)
    {
        CorbaURL url = new CorbaURL(s);
        return url.toObject(orb);
    }
 
    // 
    // create an object reference, with a null terminated key
    // 
    static protected org.omg.CORBA.Object
    getInetObject(ORB orb, String host, int port, String name, String id)
    {
	//
	// Makeup object key.
	//
	// I don't use string marshal functions here because I
	// don't want to have a string length encoded. That would
	// cause byte order dependencies.
	//
	byte key[] = new byte[name.length() + 1];
	for(int i = 0 ; i < name.length() ; i++)
	{
	    if(name.charAt(i) > 255)
		throw new org.omg.CORBA.BAD_PARAM(
		    "",  MinorBadParam.MinorBadSchemeSpecificPart,
		    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
	    key[i] = (byte)name.charAt(i);
	}
	key[name.length()] = (byte)0;

	return orb._OB_createObject(com.ooc.OCI.IIOP.impl.Util.
				    createIOR(host, port, key, id));
    }
}
