// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;

class TestConst extends TestBase
{
    TestConst()
    {
	{
	    final int constLong = -1234;
	    TEST(constLong == ConstLong.value);

	    final long constLongLong = constLong * constLong;
            TEST(constLongLong == ConstLongLong.value);

	    final long constLongLongMin = -9223372036854775807L - 1L;
            TEST(constLongLongMin == ConstLongLongMin.value);

	    final long constLongLongMax = 9223372036854775807L;
            TEST(constLongLongMax == ConstLongLongMax.value);

	    final int constULong = (5432 + constLong ) * 100 % 124;
	    TEST(constULong == ConstULong.value);

            final long constULongLong = constULong + (constULong << 20);
            TEST(constULongLong == ConstULongLong.value);

            //
            // 18446744073709551615 is represented as -1
            //
            final long constULongLongMax = -1L;
            TEST(constULongLongMax == ConstULongLongMax.value);
	    
	    final double constDouble = 50.23 - constLong * (constULong - 3.14);
	    TEST(constDouble == ConstDouble.value);

	    final float constFloat = (float)(constDouble * 1.11);
	    TEST(constFloat == ConstFloat.value);

	    final short constShort = -23 % 10;
	    TEST(constShort == ConstShort.value);

	    final boolean constBoolean = true;
	    TEST(constBoolean == ConstBoolean.value);

	    // This fails if I use VJ++ 1.1. Must be a bug.
	    final String constString = "This is ConstString";
	    //TEST(constString.equals(ConstString.value));
	}

	{
	    final int constLongI = (0xf | 0xf000) & 0xfffe;
	    TEST(constLongI == TestConstInterface.ConstLong);

	    final char constChar1 = 'c';
	    TEST(constChar1 == TestConstInterface.ConstChar1);

	    final char constChar2 = '\n';
	    TEST(constChar2 == TestConstInterface.ConstChar2);	    

	    final char constChar3 = '\377';
	    TEST(constChar3 == TestConstInterface.ConstChar3);

	    final char constChar4 = '\210';
	    TEST(constChar4 == TestConstInterface.ConstChar4);

	    final char constChar5 = '\'';
	    TEST(constChar5 == TestConstInterface.ConstChar5);
	    
	    // This fails if I use VJ++ 1.1. Must be a bug.
	    final String constStringI = "\n\t\013\b\r\f\007\\?\'\"\377\377\007";
	    //TEST(constStringI.equals(TestConstInterface.ConstString));
	}
    }
}

