// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;
import test.TestIntfPackage.*;
import test.TestIntf_LongLongPackage.*;

final class TestIntf_impl extends _TestIntf_LongLongImplBase
                          implements TestIntf_LongLongOperations
{
    private BOA boa_;

    private short aShort;
    private short aUShort;
    private int aLong;
    private int aULong;
    private float aFloat;
    private double aDouble;
    private boolean aBoolean;
    private char aChar;
    private byte aOctet;
    private String aString;
    private Any aAny;
    private test.TestIntfPackage.TestEnum aTestEnum;
    private TestIntf aTestIntf;
    private FixedStruct aFixedStruct;
    private VariableStruct aVariableStruct;
    private FixedUnion aFixedUnion;
    private VariableUnion aVariableUnion;
    private String[] aStringSequence;
    private short[][][] aFixedArray;
    private String[][] aVariableArray;
    private short[][][][] aFixedArraySequence;
    private String[][][] aVariableArraySequence;
    private short[][][][] aFixedArrayBoundSequence;
    private String[][][] aVariableArrayBoundSequence;

    //
    // Members needed for the TestIntf_LongLong tests
    //
    private long aLongLong;
    private long aULongLong;
    
    // ----------------------------------------------------------------------
    // Methods from TestIntf
    // ----------------------------------------------------------------------

    public
    TestIntf_impl(BOA boa)
    {
	boa_ = boa;
    }

    public synchronized int
    version()
    {
        return com.ooc.CORBA.Version.integer_version;
    }

    public synchronized boolean
    concurrentRequestExecution()
    {
	com.ooc.CORBA.BOA.ConcModel model =
	    ((com.ooc.CORBA.BOA)boa_).conc_model();

	if(model == com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPerRequest ||
	   model == com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPool)
	    return true;
	else
	    return false;
    }

    public synchronized void
    opVoid()
    {
    }

    public synchronized void
    opVoidEx()
        throws ExVoid
    {
	throw new ExVoid();
    }

    public synchronized String[]
    opContext(String pattern, Context ctx)
    {
	NVList values = ctx.get_values("", 0, pattern);
	
	int len = values.count();
	String[] result = new String[len * 2];
	for(int i = 0 ; i < len ; i++)
	{
	    try
	    {
		String s = values.item(i).value().extract_string();
		result[i * 2] = values.item(i).name();
		result[i * 2 + 1] = s;
	    }
	    catch(org.omg.CORBA.Bounds ex)
	    {
	    }
	}
	
	return result;
    }

    public synchronized short
    attrShort()
    {
	return aShort;
    }

    public synchronized void
    attrShort(short value)
    {
	aShort = value;
    }

    public synchronized short
    opShort(short a0,
            ShortHolder a1,
            ShortHolder a2)
    {
	aShort = (short)(a0 + a1.value);
	a1.value = a2.value = aShort;
	return aShort;
    }

    public synchronized short
    opShortEx(short a0,
	      ShortHolder a1,
	      ShortHolder a2)
        throws ExShort
    {
	aShort = (short)(a0 + a1.value);
	throw new ExShort(aShort);
    }

    public synchronized int
    attrLong()
    {
	return aLong;
    }

    public synchronized void
    attrLong(int value)
    {
	aLong = value;
    }

    public synchronized int
    opLong(int a0,
	   IntHolder a1,
	   IntHolder a2)
    {
	aLong = a0 + a1.value;
	a1.value = a2.value = aLong;
	return aLong;
    }

    public synchronized int
    opLongEx(int a0,
	     IntHolder a1,
	     IntHolder a2)
        throws ExLong
    {
	aLong = a0 + a1.value;
	throw new ExLong(aLong);
    }

    public synchronized short
    attrUShort()
    {
	return aUShort;
    }

    public synchronized void
    attrUShort(short value)
    {
	aUShort = value;
    }

    public synchronized short
    opUShort(short a0,
	     ShortHolder a1,
	     ShortHolder a2)
    {
	aUShort = (short)(a0 + a1.value);
	a1.value = a2.value = aUShort;
	return aUShort;
    }

    public synchronized short
    opUShortEx(short a0,
	       ShortHolder a1,
	       ShortHolder a2)
        throws ExUShort
    {
	aUShort = (short)(a0 + a1.value);
	throw new ExUShort(aUShort);
    }

    public synchronized int
    attrULong()
    {
	return aULong;
    }

    public synchronized void
    attrULong(int value)
    {
	aULong = value;
    }

    public synchronized int
    opULong(int a0,
	    IntHolder a1,
	    IntHolder a2)
    {
	aULong = a0 + a1.value;
	a1.value = a2.value = aULong;
	return aULong;
    }

    public synchronized int
    opULongEx(int a0,
	      IntHolder a1,
	      IntHolder a2)
        throws ExULong
    {
	aULong = a0 + a1.value;
	throw new ExULong(aULong);
    }

    public synchronized float
    attrFloat()
    {
	return aFloat;
    }

    public synchronized void
    attrFloat(float value)
    {
	aFloat = value;
    }

    public synchronized float
    opFloat(float a0,
            FloatHolder a1,
            FloatHolder a2)
    {
	aFloat = a0 + a1.value;
	a1.value = a2.value = aFloat;
	return aFloat;
    }

    public synchronized float
    opFloatEx(float a0,
	      FloatHolder a1,
	      FloatHolder a2)
        throws ExFloat
    {
	aFloat = a0 + a1.value;
	throw new ExFloat(aFloat);
    }

    public synchronized double
    attrDouble()
    {
	return aDouble;
    }

    public synchronized void
    attrDouble(double value)
    {
	aDouble = value;
    }

    public synchronized double
    opDouble(double a0,
	     DoubleHolder a1,
	     DoubleHolder a2)
    {
	aDouble = a0 + a1.value;
	a1.value = a2.value = aDouble;
	return aDouble;
    }

    public synchronized double
    opDoubleEx(double a0,
	       DoubleHolder a1,
	       DoubleHolder a2)
        throws ExDouble
    {
	aDouble = a0 + a1.value;
	throw new ExDouble(aDouble);
    }

    public synchronized boolean
    attrBoolean()
    {
	return aBoolean;
    }

    public synchronized void
    attrBoolean(boolean value)
    {
	aBoolean = value;
    }

    public synchronized boolean
    opBoolean(boolean a0,
              BooleanHolder a1,
              BooleanHolder a2)
    {
	aBoolean = a0 && a1.value;
	a1.value = a2.value = aBoolean;
	return aBoolean;
    }

    public synchronized boolean
    opBooleanEx(boolean a0,
		BooleanHolder a1,
		BooleanHolder a2)
	throws ExBoolean
    {
	aBoolean = a0 && a1.value;
	throw new ExBoolean(aBoolean);
    }

    public synchronized char
    attrChar()
    {
	return aChar;
    }

    public synchronized void
    attrChar(char value)
    {
	aChar = value;
    }

    public synchronized char
    opChar(char a0,
	   CharHolder a1,
	   CharHolder a2)
    {
	aChar = (char)(a0 + a1.value);
	a1.value = a2.value = aChar;
	return aChar;
    }

    public synchronized char
    opCharEx(char a0,
	     CharHolder a1,
	     CharHolder a2)
	throws ExChar
    {
	aChar = (char)(a0 + a1.value);
	throw new ExChar(aChar);
    }

    public synchronized byte
    attrOctet()
    {
	return aOctet;
    }

    public synchronized void
    attrOctet(byte value)
    {
	aOctet = value;
    }

    public synchronized byte
    opOctet(byte a0,
	    ByteHolder a1,
	    ByteHolder a2)
    {
	aOctet = (byte)(a0 + a1.value);
	a1.value = a2.value = aOctet;
	return aOctet;
    }

    public synchronized byte
    opOctetEx(byte a0,
	      ByteHolder a1,
	      ByteHolder a2)
	throws ExOctet
    {
	aOctet = (byte)(a0 + a1.value);
	throw new ExOctet(aOctet);
    }

    public synchronized String
    attrString()
    {
	return aString;
    }

    public synchronized void
    attrString(String value)
    {
	aString = value;
    }

    public synchronized String
    opString(String a0,
	     StringHolder a1,
	     StringHolder a2)
    {
	aString = a0 + a1.value;
	a1.value = a2.value = aString;
	return aString;
    }

    public synchronized String
    opStringEx(String a0,
	       StringHolder a1,
	       StringHolder a2)
	throws ExString
    {
	aString = a0 + a1.value;
	throw new ExString(aString);
    }

    public synchronized Any
    attrAny()
    {
	return aAny;
    }

    public synchronized void
    attrAny(Any value)
    {
	aAny = value;
    }

    public synchronized Any
    opAny(Any a0,
	  AnyHolder a1,
	  AnyHolder a2)
    {
	aAny = a0;
	a1.value = a2.value = aAny;
	return aAny;
    }

    public synchronized Any
    opAnyEx(Any a0,
	    AnyHolder a1,
	    AnyHolder a2)
	throws ExAny
    {
	aAny = a0;
	throw new ExAny(aAny);
    }

    public synchronized test.TestIntfPackage.TestEnum
    attrTestEnum()
    {
	return aTestEnum;
    }

    public synchronized void
    attrTestEnum(test.TestIntfPackage.TestEnum value)
    {
	aTestEnum = value;
    }

    public synchronized test.TestIntfPackage.TestEnum
    opTestEnum(test.TestIntfPackage.TestEnum a0,
	       test.TestIntfPackage.TestEnumHolder a1,
	       test.TestIntfPackage.TestEnumHolder a2)
    {
	aTestEnum = a0;
	a1.value = a2.value = aTestEnum;
	return aTestEnum;
    }

    public synchronized test.TestIntfPackage.TestEnum
    opTestEnumEx(test.TestIntfPackage.TestEnum a0,
		 test.TestIntfPackage.TestEnumHolder a1,
		 test.TestIntfPackage.TestEnumHolder a2)
	throws ExTestEnum
    {
	aTestEnum = a0;
	throw new ExTestEnum(aTestEnum);
    }

    public synchronized TestIntf
    attrTestIntf()
    {
	return aTestIntf;
    }

    public synchronized void
    attrTestIntf(TestIntf value)
    {
	aTestIntf = value;
    }

    public synchronized TestIntf
    opTestIntf(TestIntf a0,
		    TestIntfHolder a1,
		    TestIntfHolder a2)
    {
	aTestIntf = a0;
	a1.value = a2.value = aTestIntf;
	return aTestIntf;
    }

    public synchronized TestIntf
    opTestIntfEx(TestIntf a0,
		      TestIntfHolder a1,
		      TestIntfHolder a2)
	throws ExTestIntf
    {
	aTestIntf = a0;
	throw new ExTestIntf(aTestIntf);
    }

    public synchronized FixedStruct
    attrFixedStruct()
    {
	return aFixedStruct;
    }

    public synchronized void
    attrFixedStruct(FixedStruct value)
    {
	aFixedStruct = value;
    }

    public synchronized FixedStruct
    opFixedStruct(FixedStruct a0,
		  FixedStructHolder a1,
		  FixedStructHolder a2)
    {
	aFixedStruct = a0;
	a1.value = a2.value = aFixedStruct;
	return aFixedStruct;
    }

    public synchronized FixedStruct
    opFixedStructEx(FixedStruct a0,
		    FixedStructHolder a1,
		    FixedStructHolder a2)
	throws ExFixedStruct
    {
	aFixedStruct = a0;
	throw new ExFixedStruct(aFixedStruct);
    }

    public synchronized VariableStruct
    attrVariableStruct()
    {
	return aVariableStruct;
    }

    public synchronized void
    attrVariableStruct(VariableStruct value)
    {
	aVariableStruct = value;
    }

    public synchronized VariableStruct
    opVariableStruct(VariableStruct a0,
		     VariableStructHolder a1,
		     VariableStructHolder a2)
    {
	aVariableStruct = a0;
	a1.value = a2.value = aVariableStruct;
	return aVariableStruct;
    }

    public synchronized VariableStruct
    opVariableStructEx(VariableStruct a0,
		       VariableStructHolder a1,
		       VariableStructHolder a2)
	throws ExVariableStruct
    {
	aVariableStruct = a0;
	throw new ExVariableStruct(aVariableStruct);
    }

    public synchronized FixedUnion
    attrFixedUnion()
    {
	return aFixedUnion;
    }

    public synchronized void
    attrFixedUnion(FixedUnion value)
    {
	aFixedUnion = value;
    }

    public synchronized FixedUnion
    opFixedUnion(FixedUnion a0,
		 FixedUnionHolder a1,
		 FixedUnionHolder a2)
    {
	aFixedUnion = a0;
	a1.value = a2.value = aFixedUnion;
	return aFixedUnion;
    }

    public synchronized FixedUnion
    opFixedUnionEx(FixedUnion a0,
		   FixedUnionHolder a1,
		   FixedUnionHolder a2)
	throws ExFixedUnion
    {
	aFixedUnion = a0;
	throw new ExFixedUnion(aFixedUnion);
    }

    public synchronized VariableUnion
    attrVariableUnion()
    {
	return aVariableUnion;
    }

    public synchronized void
    attrVariableUnion(VariableUnion value)
    {
	aVariableUnion = value;
    }

    public synchronized VariableUnion
    opVariableUnion(VariableUnion a0,
		    VariableUnionHolder a1,
		    VariableUnionHolder a2)
    {
	aVariableUnion = a0;
	a1.value = a2.value = aVariableUnion;
	return aVariableUnion;
    }

    public synchronized VariableUnion
    opVariableUnionEx(VariableUnion a0,
		      VariableUnionHolder a1,
		      VariableUnionHolder a2)
	throws ExVariableUnion
    {
	aVariableUnion = a0;
	throw new ExVariableUnion(aVariableUnion);
    }


    public synchronized String[]
    attrStringSequence()
    {
	return aStringSequence;
    }

    public synchronized void
    attrStringSequence(String[] value)
    {
	aStringSequence = value;
    }

    public synchronized String[]
    opStringSequence(String[] a0,
                     StringSequenceHolder a1,
                     StringSequenceHolder a2)
    {
	aStringSequence = new String[a0.length + a1.value.length];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aStringSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aStringSequence[idx++] = a1.value[i];
	a1.value = a2.value = aStringSequence;
	return aStringSequence;
    }

    public synchronized String[]
    opStringSequenceEx(String[] a0,
		       StringSequenceHolder a1,
		       StringSequenceHolder a2)
	throws ExStringSequence
    {
	aStringSequence = new String[a0.length + a1.value.length];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aStringSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aStringSequence[idx++] = a1.value[i];
	throw new ExStringSequence(aStringSequence);
    }

    public synchronized short[][][]
    attrFixedArray()
    {
	return aFixedArray;
    }

    public synchronized void
    attrFixedArray(short[][][] value)
    {
	aFixedArray = value;
    }

    public synchronized short[][][]
    opFixedArray(short[][][] a0,
		 FixedArrayHolder a1,
		 FixedArrayHolder a2)
    {
	aFixedArray = a0;
	a1.value = a2.value = aFixedArray;
	return aFixedArray;
    }

    public synchronized short[][][]
    opFixedArrayEx(short[][][] a0,
		   FixedArrayHolder a1,
		   FixedArrayHolder a2)
	throws ExFixedArray
    {
	aFixedArray = a0;
	throw new ExFixedArray(aFixedArray);
    }

    public synchronized String[][]
    attrVariableArray()
    {
	return aVariableArray;
    }

    public synchronized void
    attrVariableArray(String[][] value)
    {
	aVariableArray = value;
    }

    public synchronized String[][]
    opVariableArray(String[][] a0,
		    VariableArrayHolder a1,
		    VariableArrayHolder a2)
    {
	aVariableArray = a0;
	a1.value = a2.value = aVariableArray;
	return aVariableArray;
    }

    public synchronized String[][]
    opVariableArrayEx(String[][] a0,
		      VariableArrayHolder a1,
		      VariableArrayHolder a2)
	throws ExVariableArray
    {
	aVariableArray = a0;
	throw new ExVariableArray(aVariableArray);
    }

    public synchronized short[][][][]
    attrFixedArraySequence()
    {
	return aFixedArraySequence;
    }

    public synchronized void
    attrFixedArraySequence(short[][][][] value)
    {
	aFixedArraySequence = value;
    }

    public synchronized short[][][][]
    opFixedArraySequence(short[][][][] a0,
			 FixedArraySequenceHolder a1,
			 FixedArraySequenceHolder a2)
    {
	aFixedArraySequence = new short[a0.length + a1.value.length][][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aFixedArraySequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aFixedArraySequence[idx++] = a1.value[i];
	a1.value = a2.value = aFixedArraySequence;
	return aFixedArraySequence;
    }

    public synchronized short[][][][]
    opFixedArraySequenceEx(short[][][][] a0,
			   FixedArraySequenceHolder a1,
			   FixedArraySequenceHolder a2)
	throws ExFixedArraySequence
    {
	aFixedArraySequence = new short[a0.length + a1.value.length][][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aFixedArraySequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aFixedArraySequence[idx++] = a1.value[i];
	throw new ExFixedArraySequence(aFixedArraySequence);
    }

    public synchronized String[][][]
    attrVariableArraySequence()
    {
	return aVariableArraySequence;
    }

    public synchronized void
    attrVariableArraySequence(String[][][] value)
    {
	aVariableArraySequence = value;
    }

    public synchronized String[][][]
    opVariableArraySequence(String[][][] a0,
			    VariableArraySequenceHolder a1,
			    VariableArraySequenceHolder a2)
    {
	aVariableArraySequence = new String[a0.length + a1.value.length][][];

	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aVariableArraySequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aVariableArraySequence[idx++] = a1.value[i];
	a1.value = a2.value = aVariableArraySequence;
	return aVariableArraySequence;
    }

    public synchronized String[][][]
    opVariableArraySequenceEx(String[][][] a0,
			      VariableArraySequenceHolder a1,
			      VariableArraySequenceHolder a2)
	throws ExVariableArraySequence
    {
	aVariableArraySequence = new String[a0.length + a1.value.length][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aVariableArraySequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aVariableArraySequence[idx++] = a1.value[i];
	throw new ExVariableArraySequence(aVariableArraySequence);
    }

    public synchronized short[][][][]
    attrFixedArrayBoundSequence()
    {
	return aFixedArrayBoundSequence;
    }

    public synchronized void
    attrFixedArrayBoundSequence(short[][][][] value)
    {
	aFixedArrayBoundSequence = value;
    }

    public synchronized short[][][][]
    opFixedArrayBoundSequence(short[][][][] a0,
			      FixedArrayBoundSequenceHolder a1,
			      FixedArrayBoundSequenceHolder a2)
    {
	aFixedArrayBoundSequence = new short[a0.length +
					    a1.value.length][][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aFixedArrayBoundSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aFixedArrayBoundSequence[idx++] = a1.value[i];
	a1.value = a2.value = aFixedArrayBoundSequence;
	return aFixedArrayBoundSequence;
    }

    public synchronized short[][][][]
    opFixedArrayBoundSequenceEx(short[][][][] a0,
			        FixedArrayBoundSequenceHolder a1,
			        FixedArrayBoundSequenceHolder a2)
	throws ExFixedArrayBoundSequence
    {
	aFixedArrayBoundSequence = 
	    new short[a0.length + a1.value.length][][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aFixedArrayBoundSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aFixedArrayBoundSequence[idx++] = a1.value[i];
	throw new ExFixedArrayBoundSequence(aFixedArrayBoundSequence);
    }

    public synchronized String[][][]
    attrVariableArrayBoundSequence()
    {
	return aVariableArrayBoundSequence;
    }

    public synchronized void
    attrVariableArrayBoundSequence(String[][][] value)
    {
	aVariableArrayBoundSequence = value;
    }

    public synchronized String[][][]
    opVariableArrayBoundSequence(String[][][] a0,
				 VariableArrayBoundSequenceHolder a1,
				 VariableArrayBoundSequenceHolder a2)
    {
	aVariableArrayBoundSequence = 
	    new String[a0.length + a1.value.length][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aVariableArrayBoundSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aVariableArrayBoundSequence[idx++] = a1.value[i];
	a1.value = a2.value = aVariableArrayBoundSequence;
	return aVariableArrayBoundSequence;
    }

    public synchronized String[][][]
    opVariableArrayBoundSequenceEx(String[][][] a0,
				   VariableArrayBoundSequenceHolder a1,
				   VariableArrayBoundSequenceHolder a2)
	throws ExVariableArrayBoundSequence
    {
	aVariableArrayBoundSequence = 
	    new String[a0.length + a1.value.length][][];
	int idx = 0;
	for(int i = 0 ; i < a0.length ; i++)
	    aVariableArrayBoundSequence[idx++] = a0[i];
	for(int i = 0 ; i < a1.value.length ; i++)
	    aVariableArrayBoundSequence[idx++] = a1.value[i];
	throw new ExVariableArrayBoundSequence(aVariableArraySequence);
    }

    public synchronized void
    deactivate()
    {
	boa_.deactivate_impl(null);
    }

    public synchronized void
    op_UNKNOWN_Ex()
    {
	throw new UNKNOWN(1, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_BAD_PARAM_Ex()
    {
	throw new BAD_PARAM(2, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_NO_MEMORY_Ex()
    {
	throw new NO_MEMORY(3, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_IMP_LIMIT_Ex()
    {
	throw new IMP_LIMIT(4, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_COMM_FAILURE_Ex()
    {
	throw new COMM_FAILURE(5, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_INV_OBJREF_Ex()
    {
	throw new INV_OBJREF(6, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_NO_PERMISSION_Ex()
    {
	throw new NO_PERMISSION(7, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_INTERNAL_Ex()
    {
	throw new INTERNAL(8, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_MARSHAL_Ex()
    {
	throw new MARSHAL(9, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_INITIALIZE_Ex()
    {
	throw new INITIALIZE(10, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_NO_IMPLEMENT_Ex()
    {
	throw new NO_IMPLEMENT(11, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_BAD_TYPECODE_Ex()
    {
	throw new BAD_TYPECODE(12, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_BAD_OPERATION_Ex()
    {
	throw new BAD_OPERATION(13, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_NO_RESOURCES_Ex()
    {
	throw new NO_RESOURCES(14, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_NO_RESPONSE_Ex()
    {
	throw new NO_RESPONSE(15, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_PERSIST_STORE_Ex()
    {
	throw new PERSIST_STORE(16, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_BAD_INV_ORDER_Ex()
    {
	throw new BAD_INV_ORDER(17, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_TRANSIENT_Ex()
    {
	throw new TRANSIENT(18, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_FREE_MEM_Ex()
    {
	throw new FREE_MEM(19, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_INV_IDENT_Ex()
    {
	throw new INV_IDENT(20, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_INV_FLAG_Ex()
    {
	throw new INV_FLAG(21, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_INTF_REPOS_Ex()
    {
	throw new INTF_REPOS(22, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_BAD_CONTEXT_Ex()
    {
	throw new BAD_CONTEXT(23, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_OBJ_ADAPTER_Ex()
    {
	throw new OBJ_ADAPTER(24, CompletionStatus.COMPLETED_MAYBE);
    }

    public synchronized void
    op_DATA_CONVERSION_Ex()
    {
	throw new DATA_CONVERSION(25, CompletionStatus.COMPLETED_YES);
    }

    public synchronized void
    op_OBJECT_NOT_EXIST_Ex()
    {
	throw new OBJECT_NOT_EXIST(26, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_TRANSACTION_REQUIRED_Ex()
    {
	throw new TRANSACTION_REQUIRED(27, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_TRANSACTION_ROLLEDBACK_Ex()
    {
	throw new TRANSACTION_ROLLEDBACK(28, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_INVALID_TRANSACTION_Ex()
    {
	throw new INVALID_TRANSACTION(29, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    op_INV_POLICY_Ex()
    {
	throw new INV_POLICY(30, CompletionStatus.COMPLETED_NO);
    }

    public synchronized void
    sleepOneway(int sec)
    {
	try
	{
	    Thread.currentThread().sleep(sec * 1000);
	}
	catch(java.lang.InterruptedException ex)
	{
	}
    }

    public synchronized void
    sleepTwoway(int sec)
    {
	try
	{
	    Thread.currentThread().sleep(sec * 1000);
	}
	catch(java.lang.InterruptedException ex)
	{
	}
    }
    
    // ----------------------------------------------------------------------
    // Methods from TestIntf_LongLong
    // ----------------------------------------------------------------------

    public synchronized long
    attrLongLong()
    {
	return aLongLong;
    }

    public synchronized void
    attrLongLong(long value)
    {
	aLongLong = value;
    }

    public synchronized long
    opLongLong(long a0,
	       LongHolder a1,
	       LongHolder a2)
    {
	aLongLong = a0 + a1.value;
	a1.value = a2.value = aLongLong;
	return aLongLong;
    }

    public synchronized long
    opLongLongEx(long a0,
		 LongHolder a1,
		 LongHolder a2)
        throws ExLongLong
    {
	aLongLong = a0 + a1.value;
	throw new ExLongLong(aLongLong);
    }

    public synchronized long
    attrULongLong()
    {
	return aULongLong;
    }

    public synchronized void
    attrULongLong(long value)
    {
	aULongLong = value;
    }

    public synchronized long
    opULongLong(long a0,
		LongHolder a1,
		LongHolder a2)
    {
	aULongLong = a0 + a1.value;
	a1.value = a2.value = aULongLong;
	return aULongLong;
    }

    public synchronized long
    opULongLongEx(long a0,
		  LongHolder a1,
		  LongHolder a2)
        throws ExULongLong
    {
	aULongLong = a0 + a1.value;
	throw new ExULongLong(aULongLong);
    }
}
