// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;
import test.TestIntfPackage.*;

class TestStubContext extends TestBase
{
    TestStubContext(ORB orb, TestIntf ti)
    {
	Context ctx;
	Context ctx2;

	{
	    ctx = orb.get_default_context();

	    String[] seq;

	    try
	    {
		seq = ti.opContext("*", ctx);
		TEST(false);
	    }
	    catch(BAD_CONTEXT ex)
	    {
		// Expected
	    }
	}

	{
	    Any any = orb.create_any();
	    int i;
	    String[] seq;

	    ctx = orb.get_default_context();

	    any.insert_string("A1");
	    ctx.set_one_value("A", any);

	    any.insert_string("A2");
	    ctx.set_one_value("AAA", any);

	    any.insert_string("B1");
	    ctx.set_one_value("B", any);

	    any.insert_string("B2");
	    ctx.set_one_value("BBB", any);

	    any.insert_string("X1");
	    ctx.set_one_value("X", any);

	    any.insert_string("X2");
	    ctx.set_one_value("XXX", any);

	    any.insert_string("Y1");
	    ctx.set_one_value("Y", any);

	    any.insert_string("Y2");
	    ctx.set_one_value("YYY", any);

	    seq = ti.opContext("*", ctx);
	    TEST(seq.length == 3 * 2);
            for(i = 0 ; i < seq.length ; i += 2)
            {
                if(seq[i].equals("A"))
                    TEST(seq[i + 1].equals("A1"));

                if(seq[i].equals("AAA"))
                    TEST(seq[i + 1].equals("A2"));

                if(seq[i].equals("X"))
                    TEST(seq[i + 1].equals("X1"));
            }

	    seq = ti.opContext("A*", ctx);
	    TEST(seq.length == 2 * 2);
            for(i = 0 ; i < seq.length ; i += 2)
            {
                if(seq[i].equals("A"))
                    TEST(seq[i + 1].equals("A1"));

                if(seq[i].equals("AAA"))
                    TEST(seq[i + 1].equals("A2"));
            }

	    seq = ti.opContext("AA*", ctx);
	    TEST(seq.length == 1 * 2);
	    TEST(seq[0].equals("AAA") &&
		 seq[1].equals("A2"));

	    seq = ti.opContext("A", ctx);
	    TEST(seq.length == 1 * 2);
	    TEST(seq[0].equals("A") &&
		 seq[1].equals("A1"));

	    ctx2 = ctx.create_child("child");

	    any.insert_string("C1");
	    ctx2.set_one_value("C", any);

	    any.insert_string("C2");
	    ctx2.set_one_value("CCC", any);

	    any.insert_string("X1-1");
	    ctx2.set_one_value("X", any);

	    seq = ti.opContext("*", ctx2);
	    TEST(seq.length == 5 * 2);
            for(i = 0 ; i < seq.length ; i += 2)
            {
                if(seq[i].equals("A"))
                    TEST(seq[i + 1].equals("A1"));

                if(seq[i].equals("AAA"))
                    TEST(seq[i + 1].equals("A2"));

                if(seq[i].equals("C"))
                    TEST(seq[i + 1].equals("C1"));

                if(seq[i].equals("CCC"))
                    TEST(seq[i + 1].equals("C2"));

                if(seq[i].equals("X"))
                    TEST(seq[i + 1].equals("X1-1"));
            }
	}
    }
}
