// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;

class TestStubTimeout extends TestBase
{
    TestStubTimeout(TestIntf tiOrig, org.omg.CORBA.ORB orb)
    {
        //
        // Create policy list containing new timeout policy
        //
        org.omg.CORBA.Policy[] pl = new org.omg.CORBA.Policy[1];
        org.omg.CORBA.Any any = orb.create_any();
        any.insert_long(2000);
        try
        {
	    //
	    // NOTE:  This can be changed to orb.create_policy when
	    //        2.3/Messaging is adopted.
	    //
            pl[0] = ((com.ooc.CORBA.ORB)orb).
		create_policy(com.ooc.OB.TIMEOUT_POLICY.value, any);
        }
        catch(org.omg.CORBA.PolicyError e)
        {
            TEST(false);
        }

        TestIntf ti = null;
        //
        // _set_policy_override returns new proxy, with this policy
        // applied
        //
        org.omg.CORBA.Object obj =
            tiOrig._set_policy_override(
                pl, org.omg.CORBA.SetOverrideType.ADD_OVERRIDE);
        //
        // _narrow to correct type
        //
        ti = TestIntfHelper.narrow(obj);

	ti.sleepOneway(3);
	
	try
	{
	    ti.sleepTwoway(0);
	    TEST(false);
	}
	catch(org.omg.CORBA.NO_RESPONSE ex)
	{
	}
	
	try
	{
	    Thread.currentThread().sleep(2000);
	}
	catch(InterruptedException ex)
	{
	}

	try
	{
	    ti.sleepTwoway(0);
	}
	catch(org.omg.CORBA.NO_RESPONSE ex)
	{
	    TEST(false);
	}
    }
}
