// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package time;

final public class StopWatch
{
    public static void
    main(String args[])
    {
	int status = 0;
	org.omg.CORBA.ORB orb = null;

 	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

        try
        {
            orb = org.omg.CORBA.ORB.init(args, null); 
	    com.ooc.CosTime.TimeService.init(orb, args);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
	    ex.printStackTrace();
            status = 1;
        }

        System.exit(status);
    }

    static int
    run(org.omg.CORBA.ORB orb, String args[])
    {
        //
        // Get time service
        //
        org.omg.CORBA.Object obj = null;
 
        try
        {
            obj = orb.resolve_initial_references("TimeService");
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            System.err.println("Can't resolve `TimeService'");
            return 1;
        }

        if(obj == null)
        {
            System.err.println("`TimeService' is a nil object reference");
            return 1;
        }
 
        org.omg.CosTime.TimeService ts = null;
	try
	{
	    ts = org.omg.CosTime.TimeServiceHelper.narrow(obj);
	}
	catch(org.omg.CORBA.BAD_PARAM ex)
	{
	}
 
        if(ts == null)
        {
            System.err.println("`TimeService' is not " +
                               "a TimeService object reference");
            return 1;
        }

	return stopWatch(ts);
    }

    static int
    stopWatch(org.omg.CosTime.TimeService ts)
    {
	org.omg.CosTime.UTO start = null;
	org.omg.CosTime.UTO stop = null;

	//
	// Get start and stop times
	//
	try
	{
	    System.out.print("Press Enter to start ");
	    try
	    {
		System.in.read();
		System.in.skip(System.in.available());
	    }
	    catch(java.io.IOException ex)
	    {
	    }
	    start = ts.universal_time();
	    System.out.print("Press Enter to stop ");
	    try
	    {
		System.in.read();
	    }
	    catch(java.io.IOException ex)
	    {
	    }
	    stop = ts.universal_time();
	}
	catch(org.omg.CosTime.TimeUnavailable ex)
	{
	    System.out.println("Time not available.");
	    return 1;
	}

	//
	// Display start and stop times
	//
	String str = com.ooc.CosTime.TimeHelper.toTimeString(start.utc_time());
	System.out.println("Start time:   " + str);

	str = com.ooc.CosTime.TimeHelper.toTimeString(stop.utc_time());
	System.out.println("Stop time:    " + str);

	//
	// Display elapsed time
	//
	long elapsed = stop.time() - start.time();
	System.out.println("Elapsed time: " + elapsed / 10000 + " ms");

	return 0;
    }
}
