// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTime;

import org.omg.CORBA.*;
import org.omg.TimeBase.*;

public final class TimeService
{
    // ------------------------------------------------------------------
    // TimeService initialization function
    // ------------------------------------------------------------------

    public static void
    init(ORB orb, String args[])
    {
	//
	// Get the set of properties
	//
	com.ooc.CORBA.Properties properties =
	    com.ooc.CORBA.Properties.instance();
	com.ooc.CORBA.MessageViewer viewer =
	    com.ooc.CORBA.MessageViewer.instance();

	for(int i = 0 ; i < args.length ; i++)
	{
	    if(args[i].equals("-TIMEinaccuracy"))
	    {
		if(i + 1 >= args.length)
		{
		    viewer.error("com.ooc.CosTime.TimeService.init: " +
		    		 "argument expected for -TIMEinaccuracy");
		    throw new INITIALIZE();
		}

		properties.setProperty("ooc.time.inaccuracy", args[++i]);
	    }
	    else if(args[i].startsWith("-TIME"))
	    {
		viewer.warning("com.ooc.CosTime.TimeService.init: " +
			       "unknown option: " + args[i]);
	    }
	}

	//
	// Process each property
	//
	long inaccuracy = 0;
	String[] keys = properties.getKeys("ooc.time.");
	int j;
	for(j = 0 ; j < keys.length ; ++j)
	{
	    String key = keys[j];
	    String value = properties.getProperty(key);

	    if(key.equals("ooc.time.inaccuracy"))
	    {
		inaccuracy = Long.valueOf(value).longValue();

		if(Unsigned.gt(inaccuracy, TimeHelper.MaxInaccuracyT))
		{
		    viewer.warning("com.ooc.CosTime.TimeService.init: " +
		    		   "inaccuracy greater than maximum");
		}
	    }
	    else
	    {
		viewer.warning("com.ooc.CosTime.TimeService.init: " +
			       "unknown property: " + key);
	    }
	}

	TimeService_impl service = new TimeService_impl(inaccuracy);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("TimeService", service);
    }
}

