// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

import org.omg.CORBA.*;
import com.ooc.CosTime.TimeHelper;

class TestUTO
{
    public static void
    test(org.omg.CosTime.TimeService ts)
        throws org.omg.CosTime.TimeUnavailable
    {
	org.omg.CosTime.ComparisonType intervalC =
	    org.omg.CosTime.ComparisonType.IntervalC;
	org.omg.CosTime.ComparisonType midC =
	    org.omg.CosTime.ComparisonType.MidC;
	org.omg.CosTime.TimeComparison tcEqualTo =
	    org.omg.CosTime.TimeComparison.TCEqualTo;
	org.omg.CosTime.TimeComparison tcLessThan =
	    org.omg.CosTime.TimeComparison.TCLessThan;
	org.omg.CosTime.TimeComparison tcGreaterThan =
	    org.omg.CosTime.TimeComparison.TCGreaterThan;
	org.omg.CosTime.TimeComparison tcIndeterminate =
	    org.omg.CosTime.TimeComparison.TCIndeterminate;

	org.omg.CosTime.UTO uto = null;
	org.omg.CosTime.UTO uto2 = null;
	org.omg.CosTime.UTO uto3 = null;
	org.omg.TimeBase.UtcT utc = null;

	//
	// TEST: CosTime::UTO creation
	//

	try
	{
	    uto = ts.new_universal_time(0, 0x1fffffffffffffffL, (short)0);
	    throw new RuntimeException();
	}
	catch(BAD_PARAM ex)
	{
	}
	try
	{
	    uto = ts.new_universal_time(0, 0x8fffffffffffffffL, (short)0);
	    throw new RuntimeException();
	}
	catch(BAD_PARAM ex)
	{
	}
	uto = ts.universal_time();

	//
	// Visually display uto2
	//
	String str = TimeHelper.toString(uto.utc_time());
	short tdf = uto.tdf();
	System.out.print("(" + str + ", " +
			 (double)tdf/60 +
	     		 ((tdf <= 0) ? " west" : " east") +
			 " of GMT)");

	//
	// TEST: readonly attribute TimeBase::TimeT time;
	//

	uto = ts.new_universal_time(TimeHelper.MaxTimeT,
				    TimeHelper.MaxInaccuracyT, (short)123);
	if(uto.time() != TimeHelper.MaxTimeT)
	    throw new RuntimeException();

	//
	// TEST: readonly attribute TimeBase::InaccuracyT inaccuracy;
	//

	if(uto.inaccuracy() != TimeHelper.MaxInaccuracyT)
	    throw new RuntimeException();

	//
	// TEST: readonly attribute TimeBase::TdfT tdf;
	//

	if(uto.tdf() != 123)
	    throw new RuntimeException();

	//
	// TEST: readonly attribute TimeBase::UtcT utc_time;
	//

	uto = ts.new_universal_time(0x8000000000000000L, 0x8f542393FF56L,
				    (short)0);
	utc = uto.utc_time();
	
	if(utc.time != uto.time())
	    throw new RuntimeException();
	if(utc.tdf != uto.tdf())
	    throw new RuntimeException();
	if(utc.inacchi != (short)0x8f54 || utc.inacclo != 0x2393FF56)
	    throw new RuntimeException();

	//
	// TEST: TimeComparison compare_time(in ComparisonType comparison_type,
	//                                   in UTO uto);
	//

	//
	// TCEqualTo
	//

	//
	// Times the same and inaccuracy zero
	//
	uto = ts.new_universal_time(0x8000000000000000L, 0L, (short)0);
	uto2 = ts.new_universal_time(uto.time(), 0L, uto.tdf());

	if(uto2.compare_time(intervalC, uto2) != tcEqualTo)
	    throw new RuntimeException();
	    
	if(uto2.compare_time(midC, uto2) != tcEqualTo)
	    throw new RuntimeException();

	//
	// Times and inaccuracy the same
	//
	uto2 = ts.new_universal_time(uto.time(), 10L, uto.tdf());

	if(uto2.compare_time(intervalC, uto2) != tcIndeterminate)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto2) != tcEqualTo)
	    throw new RuntimeException();
	
	//
	// Times the same, inaccuracy not the same
	//
	uto3 = ts.new_universal_time(uto.time(), 30L, uto.tdf());

	if(uto2.compare_time(intervalC, uto3) != tcIndeterminate)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto3) != tcEqualTo)
	    throw new RuntimeException();

	//
	// TCLessThan
	//

	//
	// Compare time less than, no inaccuracy overlap
	//
	uto2 = ts.new_universal_time(0x7fffffffffffffceL, 25, uto.tdf());
	uto3 = ts.new_universal_time(0x8000000000000032L, 25, uto.tdf());

	if(uto2.compare_time(intervalC, uto3) != tcLessThan)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto3) != tcLessThan)
	    throw new RuntimeException();

	//
	// Compare time less than, inaccuracy overlap
	//
	uto2 = ts.new_universal_time(0x7fffffffffffffceL, 75, uto.tdf());
	uto3 = ts.new_universal_time(0x8000000000000032L, 75, uto.tdf());

	if(uto2.compare_time(intervalC, uto3) != tcIndeterminate)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto3) != tcLessThan)
	    throw new RuntimeException();

	//
	// TCGreaterThan
	//

	//
	// Compare time greater than, no inaccuracy overlap
	//
	uto2 = ts.new_universal_time(0x8000000000000032L, 25, uto.tdf());
	uto3 = ts.new_universal_time(0x7fffffffffffffceL, 25, uto.tdf());

	if(uto2.compare_time(intervalC, uto3) != tcGreaterThan)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto3) != tcGreaterThan)
	    throw new RuntimeException();

	//
	// Compare time greater than, inaccuracy overlap
	//
	uto2 = ts.new_universal_time(0x8000000000000032L, 75, uto.tdf());
	uto3 = ts.new_universal_time(0x7fffffffffffffceL, 75, uto.tdf());

	if(uto2.compare_time(intervalC, uto3) != tcIndeterminate)
	    throw new RuntimeException();
	if(uto2.compare_time(midC, uto3) != tcGreaterThan)
	    throw new RuntimeException();

	//
	// TEST: UTO absolute_time()
	//

	//
	// Test that time returned is within a couple of seconds. Cannot
	// be exact since method uses utcNow()
	//
	uto2 = ts.new_universal_time(1000000000, 0, uto.tdf());
	utc = com.ooc.CosTime.TimeHelper.utcNow(0L);
	uto3 = uto2.absolute_time();
	org.omg.TimeBase.UtcT utc2 = uto3.utc_time();
	if(utc2.time < utc.time + 1000000000 ||
	   utc2.time >= utc.time + 1000000000 + 20000000)
	    throw new RuntimeException();

	//
	// Test overflow check
	//
	long offset = 0xffffffffffff0000L;
	uto2 = ts.new_universal_time(offset, 0, uto.tdf());

	try
	{
	    uto2.absolute_time();
	    throw new RuntimeException();
	}
	catch(DATA_CONVERSION ex)
	{
	}

	//
	// TEST: TIO time_to_interval(in UTO uto);
	//

	//
	// Times the same
	//
	uto2 = ts.new_universal_time(uto.time(), 0, uto.tdf());
	org.omg.CosTime.TIO tio = uto2.time_to_interval(uto2);
	org.omg.TimeBase.IntervalT interval = tio.time_interval();
	if(interval.lower_bound != uto.time() ||
	     interval.upper_bound != uto.time())
	    throw new RuntimeException();

	//
	// Interval UTO greater than
	//
	uto3 = ts.new_universal_time(0x8000000000000032L, 0, uto.tdf());
	tio = uto2.time_to_interval(uto3);
	interval = tio.time_interval();
	if(interval.lower_bound != uto.time() ||
	   interval.upper_bound != 0x8000000000000032L)
	    throw new RuntimeException();

	//
	// Interval UTO less than
	//
	uto3 = ts.new_universal_time(0x7fffffffffffffceL, 0, uto.tdf());
	tio = uto2.time_to_interval(uto3);
	interval = tio.time_interval();
	if(interval.lower_bound != 0x7fffffffffffffceL ||
	   interval.upper_bound != uto.time())
	    throw new RuntimeException();

	//
	// TEST: TIO interval();
	//

	uto2 = ts.new_universal_time(uto.time(), 50, uto.tdf());
	tio = uto2.interval();
	interval = tio.time_interval();
	if(interval.lower_bound != 0x7fffffffffffffceL ||
	   interval.upper_bound != 0x8000000000000032L)
	    throw new RuntimeException();
    }
}
