// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package loan.basic;

public class LenderImpl extends loan.LenderDemo._LenderImplBase
{
    private String company_;
    private java.util.Hashtable products_;
    private java.util.Random rand_;

    public LenderImpl(String company, java.util.Hashtable products)
    {
        company_ = company;
        products_ = products;
        rand_ = new java.util.Random();
    }

    // ------------------------------------------------------------------
    // LenderDemo::Lender IDL operations
    // ------------------------------------------------------------------

    public String
    company_name()
    {
        return company_;
    }

    public boolean
    request_loan(String product_id)
        throws loan.LenderDemo.UnknownProduct
    {
        //
        // Make sure we support this product
        //
        if(! products_.containsKey(product_id))
            throw new loan.LenderDemo.UnknownProduct(product_id);

        //
        // Give the client a 50% chance of being approved
        //
        return ((rand_.nextInt() % 2) == 0);
    }
}
