// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package loan.dynamic;

//
// RateEval is an implementation of CosTradingDynamic::DynamicPropEval.
// It chooses a value at random for the "rate" property.
//

public class RateEval
    extends org.omg.CosTradingDynamic._DynamicPropEvalImplBase
{
    private org.omg.CORBA.ORB orb_;
    private ProductInfo info_;
    private java.util.Random rand_;

    public RateEval(org.omg.CORBA.ORB orb, ProductInfo info)
    {
        orb_ = orb;
        info_ = info;
        rand_ = new java.util.Random();
    }

    public org.omg.CORBA.Any
    evalDP(String name,
           org.omg.CORBA.TypeCode returned_type,
           org.omg.CORBA.Any extra_info)
        throws org.omg.CosTradingDynamic.DPEvalFailure
    {
        org.omg.CORBA.Any result;

        if(! name.equals("rate"))
            throw new org.omg.CosTradingDynamic.DPEvalFailure(
                name, returned_type, extra_info);

        //
        // Compute a new rate somewhere between rateMin and rateMax
        //

        int intervals =
            (int)((info_.rateMax - info_.rateMin) / info_.rateIncrement);

        int n = Math.abs(rand_.nextInt()) % intervals;

        float newRate = info_.rateMin + (n * info_.rateIncrement);
        result = orb_.create_any();
        result.insert_float(newRate);

        return result;
    }
}
