# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= OBTrader.jar

!include $(top_srcdir)\config\Make.rules.mak

ALL_LIBS	= $(OB_LIB);$(OB_UTIL_LIB)

IDLDIR		= $(top_srcdir)\idl

all:: omg ooc console images

omg: $(top_srcdir)\lib generated
	$(JIDL) -I$(IDLDIR) --package org.omg --output-dir generated \
	$(IDLDIR)\CosTrading.idl
	$(JIDL) -I$(IDLDIR) --package org.omg --output-dir generated \
	$(IDLDIR)\CosTradingDynamic.idl
	$(JIDL) -I$(IDLDIR) --package org.omg --output-dir generated \
	$(IDLDIR)\CosTradingRepos.idl
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(ALL_LIBS);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\CosTrading\*.java \
	generated\org\omg\CosTrading\LookupPackage\*.java \
	generated\org\omg\CosTrading\RegisterPackage\*.java \
	generated\org\omg\CosTrading\LinkPackage\*.java \
	generated\org\omg\CosTrading\ProxyPackage\*.java \
	generated\org\omg\CosTrading\AdminPackage\*.java
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\org\omg\CosTradingDynamic\*.java \
	generated\org\omg\CosTradingRepos\*.java \
	generated\org\omg\CosTradingRepos\ServiceTypeRepositoryPackage\*.java

ooc: $(top_srcdir)\lib generated
	$(JIDL) -I$(IDLDIR) --auto-package --output-dir generated \
	com\ooc\CosTrading\DBTypes.idl
	set CLASSPATH=.;$(top_srcdir)\lib;$(ALL_LIBS);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	generated\com\ooc\OBCosTrading\*.java
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\CosTrading\*.java

console: $(top_srcdir)\lib generated
	set CLASSPATH=.;$(top_srcdir)\lib;$(ALL_LIBS);$(CLASSPATH)
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\CosTradingConsole\Util\*.java \
	com\ooc\CosTradingConsole\Tools\*.java
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\CosTradingConsole\Link\*.java \
	com\ooc\CosTradingConsole\Offer\*.java \
	com\ooc\CosTradingConsole\Proxy\*.java \
	com\ooc\CosTradingConsole\Type\*.java
	$(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	com\ooc\CosTradingConsole\*.java

images: $(top_srcdir)\lib\com\ooc\CosTradingConsole\images
	copy com\ooc\CosTradingConsole\images\*.gif \
	$(top_srcdir)\lib\com\ooc\CosTradingConsole\images

$(top_srcdir)\lib\com\ooc\CosTradingConsole\images: $(top_srcdir)\lib
	mkdir $@

jar:
	cd $(top_srcdir)\lib
	if exist $(NAME) del $(NAME)
	$(JAR) $(JARFLAGS) $(NAME) org com

install:: jar
	copy $(top_srcdir)\lib\$(NAME) $(libdir)

clean::
	-rmdir /s /q $(top_srcdir)\lib
