// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Things are just too ugly without this
//
import org.omg.CosTradingRepos.*;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;


//
// Implementation of CosTrading::Admin
//
final class AdminImpl extends org.omg.CosTrading._AdminImplBase
{
    private org.omg.CORBA.ORB orb_;
    private ServiceTypeRepository repos_;
    private org.omg.CosTrading.Register register_;
    private org.omg.CosTrading.Lookup lookup_;
    private org.omg.CosTrading.Proxy proxy_;
    private org.omg.CosTrading.Link link_;
    private DBManager dbMgr_;
    private OfferDB offerDB_;
    private AttributeDB attributeDB_;


    public
    AdminImpl(org.omg.CORBA.ORB orb,
              ServiceTypeRepository typeRepos,
              org.omg.CosTrading.Register reg,
              org.omg.CosTrading.Lookup lookup,
              org.omg.CosTrading.Proxy proxy,
              org.omg.CosTrading.Link link,
              DBManager dbMgr)
    {
        orb_ = orb;
        repos_ = typeRepos;
        register_ = reg;
        lookup_ = lookup;
        proxy_ = proxy;
        link_ = link;
        dbMgr_ = dbMgr;
        offerDB_ = dbMgr.getOfferDB();
        attributeDB_ = dbMgr.getAttributeDB();
    }


    //
    // operations inherited from CosTrading::TraderComponents
    //

    public org.omg.CosTrading.Lookup
    lookup_if()
    {
        return lookup_;
    }

    public org.omg.CosTrading.Register
    register_if()
    {
        return register_;
    }

    public org.omg.CosTrading.Link
    link_if()
    {
        return link_;
    }

    public org.omg.CosTrading.Proxy
    proxy_if()
    {
        if(supports_proxy_offers())
            return proxy_;
        else
            return null;
    }

    public org.omg.CosTrading.Admin
    admin_if()
    {
        return this;
    }


    //
    // operations inherited from CosTrading::SupportAttributes
    //

    public boolean
    supports_modifiable_properties()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.supports_modifiable_properties();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public boolean
    supports_dynamic_properties()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.supports_dynamic_properties();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public boolean
    supports_proxy_offers()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.supports_proxy_offers();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CORBA.Object
    type_repos()
    {
        return repos_;
    }


    //
    // operations inherited from CosTrading::ImportAttributes
    //

    public int
    def_search_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.def_search_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    max_search_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_search_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    def_match_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.def_match_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    max_match_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_match_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    def_return_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.def_return_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    max_return_card()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_return_card();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    max_list()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_list();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    def_hop_count()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.def_hop_count();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    max_hop_count()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_hop_count();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CosTrading.FollowOption
    def_follow_policy()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.def_follow_policy();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CosTrading.FollowOption
    max_follow_policy()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_follow_policy();
        }
        finally
        {
            attributeDB_.end();
        }
    }


    //
    // operations inherited from CosTrading::LinkAttributes
    //

    public org.omg.CosTrading.FollowOption
    max_link_follow_policy()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.max_link_follow_policy();
        }
        finally
        {
            attributeDB_.end();
        }
    }


    //
    // operations inherited from CosTrading::Admin
    //

    public byte[]
    request_id_stem()
    {
        try
        {
            attributeDB_.begin(AbstractDB.READ);
            return attributeDB_.request_id_stem();
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_def_search_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.def_search_card();
            attributeDB_.def_search_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_max_search_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.max_search_card();
            attributeDB_.max_search_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_def_match_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.def_match_card();
            attributeDB_.def_match_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_max_match_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.max_match_card();
            attributeDB_.max_match_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_def_return_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.def_return_card();
            attributeDB_.def_return_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_max_return_card(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.max_return_card();
            attributeDB_.max_return_card(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_max_list(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.max_list();
            attributeDB_.max_list(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public boolean
    set_supports_modifiable_properties(boolean value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            boolean result = attributeDB_.supports_modifiable_properties();
            attributeDB_.supports_modifiable_properties(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public boolean
    set_supports_dynamic_properties(boolean value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            boolean result = attributeDB_.supports_dynamic_properties();
            attributeDB_.supports_dynamic_properties(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public boolean
    set_supports_proxy_offers(boolean value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            boolean result = attributeDB_.supports_proxy_offers();
            attributeDB_.supports_proxy_offers(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_def_hop_count(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.def_hop_count();
            attributeDB_.def_hop_count(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public int
    set_max_hop_count(int value)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            int result = attributeDB_.max_hop_count();
            attributeDB_.max_hop_count(value);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CosTrading.FollowOption
    set_def_follow_policy(org.omg.CosTrading.FollowOption policy)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            org.omg.CosTrading.FollowOption result =
                attributeDB_.def_follow_policy();
            attributeDB_.def_follow_policy(policy);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CosTrading.FollowOption
    set_max_follow_policy(org.omg.CosTrading.FollowOption policy)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            org.omg.CosTrading.FollowOption result =
                attributeDB_.max_follow_policy();
            attributeDB_.max_follow_policy(policy);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CosTrading.FollowOption
    set_max_link_follow_policy(org.omg.CosTrading.FollowOption policy)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            org.omg.CosTrading.FollowOption result =
                attributeDB_.max_link_follow_policy();
            attributeDB_.max_link_follow_policy(policy);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public org.omg.CORBA.Object
    set_type_repos(org.omg.CORBA.Object repository)
    {
        org.omg.CORBA.Object result = repos_;

        ServiceTypeRepository repos =
            ServiceTypeRepositoryHelper.narrow(repository);

        repos_ = repos;

        return result;
    }

    public byte[]
    set_request_id_stem(byte[] stem)
    {
        try
        {
            attributeDB_.begin(AbstractDB.WRITE);
            byte[] result = attributeDB_.request_id_stem();
            attributeDB_.request_id_stem(stem);
            return result;
        }
        finally
        {
            attributeDB_.end();
        }
    }

    public void
    list_offers(int how_many,
                org.omg.CosTrading.OfferIdSeqHolder ids,
                org.omg.CosTrading.OfferIdIteratorHolder id_itr)
        throws org.omg.CosTrading.NotImplemented
    {
        //
        // obtain the list of all service type names
        //
        SpecifiedServiceTypes whichTypes = new SpecifiedServiceTypes();
        whichTypes._default(ListOption.all);

        org.omg.CORBA.Object obj = type_repos();
        ServiceTypeRepository repos = ServiceTypeRepositoryHelper.narrow(obj);

        String[] allNames = repos.list_types(whichTypes);

        try
        {
            offerDB_.begin(AbstractDB.READ);

            //
            // construct a Vector of all offers for all types
            //
            java.util.Vector vec = new java.util.Vector();
            for(int i = 0 ; i < allNames.length ; i++)
            {
                String[] seq = offerDB_.getOfferIds(allNames[i]);
                if(seq != null)
                    for(int n = 0 ; n < seq.length ; n++)
                        vec.addElement(seq[n]);
            }

            int offerCount = vec.size();
            int maxListCount = Math.min(max_list(), how_many);
            int seqCount = Math.min(offerCount, maxListCount);

            ids.value = new String[seqCount];
            int count = 0;
            java.util.Enumeration e = vec.elements();
            while(e.hasMoreElements() && count < seqCount)
            {
                String id = (String)e.nextElement();
                ids.value[count] = id;
                count++;
            }

            //
            // construct an iterator if necessary
            //
            if(seqCount < offerCount)
            {
                //
                // create a sequence holding the remaining offer IDs
                //
                int restCount = offerCount - seqCount;
                String[] rest = new String[restCount];

                int pos = 0;
                while(e.hasMoreElements() && pos < restCount)
                {
                    String id = (String)e.nextElement();
                    rest[pos] = id;
                    pos++;
                }

                OfferIdIteratorImpl iter =
                    new OfferIdIteratorImpl(orb_, rest, max_list());
                orb_.connect(iter);
                id_itr.value = iter;
            }
        }
        finally
        {
            offerDB_.end();
        }
    }

    public void
    list_proxies(int how_many,
                 org.omg.CosTrading.OfferIdSeqHolder ids,
                 org.omg.CosTrading.OfferIdIteratorHolder id_itr)
        throws org.omg.CosTrading.NotImplemented
    {
        //
        // obtain the list of all service type names
        //
        SpecifiedServiceTypes whichTypes = new SpecifiedServiceTypes();
        whichTypes._default(ListOption.all);

        org.omg.CORBA.Object obj = type_repos();
        ServiceTypeRepository repos = ServiceTypeRepositoryHelper.narrow(obj);

        String[] allNames = repos.list_types(whichTypes);

        try
        {
            offerDB_.begin(AbstractDB.READ);

            //
            // construct a Vector of all offers for all types
            //
            java.util.Vector vec = new java.util.Vector();
            for(int i = 0 ; i < allNames.length ; i++)
            {
                String[] seq = offerDB_.getProxyOfferIds(allNames[i]);
                if(seq != null)
                    for(int n = 0 ; n < seq.length ; n++)
                        vec.addElement(seq[n]);
            }

            int offerCount = vec.size();
            int maxListCount = Math.min(max_list(), how_many);
            int seqCount = Math.min(offerCount, maxListCount);

            ids.value = new String[seqCount];
            int count = 0;
            java.util.Enumeration e = vec.elements();
            while(e.hasMoreElements() && count < seqCount)
            {
                String id = (String)e.nextElement();
                ids.value[count] = id;
                count++;
            }

            //
            // construct an iterator if necessary
            //
            if(seqCount < offerCount)
            {
                //
                // create a sequence holding the remaining offer IDs
                //
                int restCount = offerCount - seqCount;
                String[] rest = new String[restCount];

                int pos = 0;
                while(e.hasMoreElements() && pos < restCount)
                {
                    String id = (String)e.nextElement();
                    rest[pos] = id;
                    pos++;
                }

                OfferIdIteratorImpl iter =
                    new OfferIdIteratorImpl(orb_, rest, max_list());
                orb_.connect(iter);
                id_itr.value = iter;
            }
        }
        finally
        {
            offerDB_.end();
        }
    }
}
