// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

import com.ooc.OBCosTrading.*;

final class AttributeDB_impl extends AbstractDB_impl implements AttributeDB
{
    private AttributeInfo attribs_; // The attributes

    AttributeDB_impl(org.omg.CORBA.ORB orb, String dbdir)
    {
        super(orb);

        //
        // Initialize the attributes to default values
        //
        attribs_ = new AttributeInfo();
        attribs_.request_id_stem = new byte[0];
        attribs_.def_search_card = Integer.MAX_VALUE;
        attribs_.max_search_card = Integer.MAX_VALUE;
        attribs_.def_match_card = Integer.MAX_VALUE;
        attribs_.max_match_card = Integer.MAX_VALUE;
        attribs_.def_return_card = Integer.MAX_VALUE;
        attribs_.max_return_card = Integer.MAX_VALUE;
        attribs_.max_list = Integer.MAX_VALUE;
        attribs_.supports_modifiable_properties = true;
        attribs_.supports_dynamic_properties = true;
        attribs_.supports_proxy_offers = true;
        attribs_.def_hop_count = Integer.MAX_VALUE;
        attribs_.max_hop_count = Integer.MAX_VALUE;
        attribs_.def_follow_policy =
            org.omg.CosTrading.FollowOption.always;
        attribs_.max_follow_policy =
            org.omg.CosTrading.FollowOption.always;
        attribs_.max_link_follow_policy =
            org.omg.CosTrading.FollowOption.always;

        if(dbdir != null)
            super.initDatabase(dbdir, "attribs");
    }

    //
    // Called by super to execute commands read from database
    // during initialization
    //
    protected void
    execute(org.omg.CORBA.Any any)
    {
        attribs_ = AttributeInfoHelper.extract(any);
    }

    //
    // Called by super to update the journal
    //
    protected void
    update()
        throws java.io.IOException
    {
        org.omg.CORBA.Any any = orb_.create_any();
        AttributeInfoHelper.insert(any, attribs_);
        writeLog(any);
    }

    public byte[]
    request_id_stem()
    {
        return attribs_.request_id_stem;
    }

    public void
    request_id_stem(byte[] stem)
    {
        attribs_.request_id_stem = stem;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    def_search_card()
    {
        return attribs_.def_search_card;
    }

    public void
    def_search_card(int card)
    {
        attribs_.def_search_card = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    max_search_card()
    {
        return attribs_.max_search_card;
    }

    public void
    max_search_card(int card)
    {
        attribs_.max_search_card = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    def_match_card()
    {
        return attribs_.def_match_card;
    }

    public void
    def_match_card(int card)
    {
        attribs_.def_match_card = card;;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    max_match_card()
    {
        return attribs_.max_match_card;
    }

    public void
    max_match_card(int card)
    {
        attribs_.max_match_card = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    def_return_card()
    {
        return attribs_.def_return_card;
    }

    public void
    def_return_card(int card)
    {
        attribs_.def_return_card = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    max_return_card()
    {
        return attribs_.max_return_card;
    }

    public void
    max_return_card(int card)
    {
        attribs_.max_return_card = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    max_list()
    {
        return attribs_.max_list;
    }

    public void
    max_list(int card)
    {
        attribs_.max_list = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public boolean
    supports_modifiable_properties()
    {
        return attribs_.supports_modifiable_properties;
    }

    public void
    supports_modifiable_properties(boolean b)
    {
        attribs_.supports_modifiable_properties = b;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public boolean
    supports_dynamic_properties()
    {
        return attribs_.supports_dynamic_properties;
    }

    public void
    supports_dynamic_properties(boolean b)
    {
        attribs_.supports_dynamic_properties = b;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public boolean
    supports_proxy_offers()
    {
        return attribs_.supports_proxy_offers;
    }

    public void
    supports_proxy_offers(boolean b)
    {
        attribs_.supports_proxy_offers = b;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    def_hop_count()
    {
        return attribs_.def_hop_count;
    }

    public void
    def_hop_count(int card)
    {
        attribs_.def_hop_count = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public int
    max_hop_count()
    {
        return attribs_.max_hop_count;
    }

    public void
    max_hop_count(int card)
    {
        attribs_.max_hop_count = card;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public org.omg.CosTrading.FollowOption
    def_follow_policy()
    {
        return attribs_.def_follow_policy;
    }

    public void
    def_follow_policy(org.omg.CosTrading.FollowOption f)
    {
        attribs_.def_follow_policy = f;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public org.omg.CosTrading.FollowOption
    max_follow_policy()
    {
        return attribs_.max_follow_policy;
    }

    public void
    max_follow_policy(org.omg.CosTrading.FollowOption f)
    {
        attribs_.max_follow_policy = f;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }

    public org.omg.CosTrading.FollowOption
    max_link_follow_policy()
    {
        return attribs_.max_link_follow_policy;
    }

    public void
    max_link_follow_policy(org.omg.CosTrading.FollowOption f)
    {
        attribs_.max_link_follow_policy = f;

        if(os_ != null)
        {
            org.omg.CORBA.Any any = orb_.create_any();
            AttributeInfoHelper.insert(any, attribs_);
            writeLog(any);
            update_ = true;
        }
    }
}
