// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

final class Constraint
{
    private org.omg.CORBA.ORB orb_;
    private Node node_;

    public
    Constraint(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
        node_ = null;
    }

    public boolean
    parse(String constraint)
    {
        Parser parser = new Parser(orb_);
        Scanner scan = new Scanner(constraint);
        Node node = parser.parse(scan);

        if(node != null && node.checkTypes() &&
           (node.type() == Node.TYPE_UNKNOWN ||
            node.type() == Node.TYPE_BOOLEAN))
        {
            node_ = node;
            return true;
        }

        return false;
    }

    public boolean
    evaluate(PropertyList list)
    {
        if(node_ == null)
            throw new RuntimeException();

        Value v = node_.evaluate(list);
        if(v != null)
        {
            if(v.kind() == Value.KIND_BOOLEAN)
            {
                if(v.get_boolean())
                    return true;
            }
        }

        return false;
    }
}
