// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// An abstract interface to the trader databases
//
abstract class DBManager
{
    private static DBManager instance_;

    static DBManager
    getManager()
    {
        return instance_;
    }

    static void
    setManager(DBManager instance)
    {
        instance_ = instance;
    }

    abstract boolean
    isPropertyTypeSupported(org.omg.CORBA.TypeCode type);

    abstract boolean
    isPolicyTypeSupported(org.omg.CORBA.TypeCode type);

    abstract boolean
    isPropertyNameValid(String name);

    abstract boolean
    isPolicyNameValid(String name);

    abstract boolean
    allowUnknownProperties();

    abstract OfferDB
    getOfferDB();

    abstract TypeDB
    getTypeDB();

    abstract LinkDB
    getLinkDB();

    abstract AttributeDB
    getAttributeDB();

    abstract void
    shutdown();
}
