// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// A stand-alone identifier appearing in a constraint language
// expression must be a property name.
//

final class IdentNode extends Node
{
    private String name_;

    IdentNode(org.omg.CORBA.ORB orb, String name)
    {
        name_ = name;
    }

    void
    print(java.io.PrintStream out)
    {
        out.println("IdentNode: " + name_);
    }

    Value
    evaluate(PropertyList props)
    {
        return props.getValue(name_);
    }

    boolean
    checkTypes()
    {
        return true;
    }

    int
    type()
    {
        return TYPE_UNKNOWN;
    }

    boolean
    exists(PropertyList props)
    {
        return props.exists(name_);
    }
}
