// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

interface LinkDB extends AbstractDB
{
    //
    // Returns true if the link with the given name exists
    //
    boolean
    exists(String name);

    //
    // Creates a new link
    //
    void
    create(String name,
           org.omg.CosTrading.Lookup target,
           org.omg.CosTrading.FollowOption passOnFollow,
           org.omg.CosTrading.FollowOption limitingFollow);

    //
    // Removes the link with the given name
    //
    void
    remove(String name);

    //
    // Returns a description of the link with the given name, or null if
    // the link wasn't found
    //
    org.omg.CosTrading.LinkPackage.LinkInfo
    describe(String name);

    //
    // Updates the link information
    //
    void
    modify(String name,
           org.omg.CosTrading.FollowOption passOnFollow,
           org.omg.CosTrading.FollowOption limitingFollow);

    //
    // Returns all link names
    //
    String[]
    getLinkNames();
}
