// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

final class LiteralNode extends Node
{
    private Value value_;

    LiteralNode(org.omg.CORBA.ORB orb, String value)
    {
        value_ = new Value(value);
    }

    LiteralNode(org.omg.CORBA.ORB orb, int value)
    {
        value_ = new Value(value);
    }

    LiteralNode(org.omg.CORBA.ORB orb, double value)
    {
        value_ = new Value(value);
    }

    LiteralNode(org.omg.CORBA.ORB orb, boolean value)
    {
        value_ = new Value(value);
    }

    void
    print(java.io.PrintStream out)
    {
        out.println("LiteralNode: " + value_);
    }

    Value
    evaluate(PropertyList props)
    {
        return value_;
    }

    boolean
    checkTypes()
    {
        return true;
    }

    int
    type()
    {
        if(value_.kind() == Value.KIND_BOOLEAN)
            return TYPE_BOOLEAN;
        else if(value_.kind() == Value.KIND_STRING)
        {
            //
            // If the string is a single character, then it could be used
            // as a string or a number, so we return TYPE_UNKNOWN
            if(value_.numeric())
                return TYPE_UNKNOWN;
            else
                return TYPE_STRING;
        }
        else if(value_.numeric())
            return TYPE_NUMBER;
        else
            return TYPE_UNKNOWN;
    }

    boolean
    numeric()
    {
        //
        // Overrides default implementation in Node
        //
        return value_.numeric();
    }
}
