// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// This class is used to update the database journals on a regular basis
//
final class Logger extends Thread
{
    private AbstractDB_impl[] databases_;

    private int interval_; // Timeout interval
    private boolean stop_;

    Logger(AbstractDB_impl[] databases, int interval)
    {
        databases_ = databases;
        interval_ = interval;
    }

    synchronized void
    halt()
    {
        stop_ = true;
        notify();
    }

    synchronized public void
    run()
    {
        while(!stop_)
        {
            try
            {
                wait(interval_ * 1000);
            }
            catch(InterruptedException ex)
            {
            }

            if(!stop_)
            {
                com.ooc.CORBA.MessageViewer.instance().trace(
                    2, "Compacting databases");

                for(int i = 0 ; i < databases_.length ; i++)
                {
                    try
                    {
                        databases_[i].begin(AbstractDB.WRITE);
                        databases_[i].updateJournal();
                    }
                    finally
                    {
                        databases_[i].end();
                    }
                }
            }
        }
    }
}
