// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Things are just too ugly without this
//
import org.omg.CosTradingRepos.*;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;

//
// Implementation of CosTrading::Lookup
//
final class LookupImpl extends org.omg.CosTrading._LookupImplBase
{
    private org.omg.CORBA.ORB orb_;
    private DBManager dbMgr_;
    private OfferDB db_;
    private RequestHistory requestHistory_;
    private org.omg.CosTrading.Admin admin_;

    public
    LookupImpl(org.omg.CORBA.ORB orb, DBManager dbMgr)
    {
        orb_ = orb;
        dbMgr_ = dbMgr;
        db_ = dbMgr.getOfferDB();
        requestHistory_ = new RequestHistory();
    }

    void
    setAdmin(org.omg.CosTrading.Admin admin)
    {
        admin_ = admin;
    }

    //
    // Operations inherited from CosTrading::TraderComponents
    //

    public org.omg.CosTrading.Lookup
    lookup_if()
    {
        return this;
    }

    public org.omg.CosTrading.Register
    register_if()
    {
        return admin_.register_if();
    }

    public org.omg.CosTrading.Link
    link_if()
    {
        return admin_.link_if();
    }

    public org.omg.CosTrading.Proxy
    proxy_if()
    {
        return admin_.proxy_if();
    }

    public org.omg.CosTrading.Admin
    admin_if()
    {
        return admin_;
    }

    //
    // Operations inherited from CosTrading::SupportAttributes
    //

    public boolean
    supports_modifiable_properties()
    {
        return admin_.supports_modifiable_properties();
    }

    public boolean
    supports_dynamic_properties()
    {
        return admin_.supports_dynamic_properties();
    }

    public boolean
    supports_proxy_offers()
    {
        return admin_.supports_proxy_offers();
    }

    public org.omg.CORBA.Object
    type_repos()
    {
        return admin_.type_repos();
    }

    //
    // Operations inherited from CosTrading::ImportAttributes
    //

    public int
    def_search_card()
    {
        return admin_.def_search_card();
    }

    public int
    max_search_card()
    {
        return admin_.max_search_card();
    }

    public int
    def_match_card()
    {
        return admin_.def_match_card();
    }

    public int
    max_match_card()
    {
        return admin_.max_match_card();
    }

    public int
    def_return_card()
    {
        return admin_.def_return_card();
    }

    public int
    max_return_card()
    {
        return admin_.max_return_card();
    }

    public int
    max_list()
    {
        return admin_.max_list();
    }

    public int
    def_hop_count()
    {
        return admin_.def_hop_count();
    }

    public int
    max_hop_count()
    {
        return admin_.max_hop_count();
    }

    public org.omg.CosTrading.FollowOption
    def_follow_policy()
    {
        return admin_.def_follow_policy();
    }

    public org.omg.CosTrading.FollowOption
    max_follow_policy()
    {
        return admin_.max_follow_policy();
    }

    //
    // Operations inherited from CosTrading::Lookup
    //

    public void
    query(String type,
          String constr,
          String pref,
          org.omg.CosTrading.Policy[] policies,
          org.omg.CosTrading.LookupPackage.SpecifiedProps desired_props,
          int how_many,
          org.omg.CosTrading.OfferSeqHolder offers,
          org.omg.CosTrading.OfferIteratorHolder offer_itr,
          org.omg.CosTrading.PolicyNameSeqHolder limits_applied)
        throws org.omg.CosTrading.IllegalServiceType,
               org.omg.CosTrading.UnknownServiceType,
               org.omg.CosTrading.IllegalConstraint,
               org.omg.CosTrading.LookupPackage.IllegalPreference,
               org.omg.CosTrading.LookupPackage.IllegalPolicyName,
               org.omg.CosTrading.LookupPackage.PolicyTypeMismatch,
               org.omg.CosTrading.LookupPackage.InvalidPolicyValue,
               org.omg.CosTrading.IllegalPropertyName,
               org.omg.CosTrading.DuplicatePropertyName,
               org.omg.CosTrading.DuplicatePolicyName
    {
        //
        // Build a hashtable of the policies
        //
        java.util.Hashtable policyTable = new java.util.Hashtable();
        for(int i = 0 ; i < policies.length ; i++)
        {
            if(!dbMgr_.isPolicyNameValid(policies[i].name))
                throw new org.omg.CosTrading.LookupPackage.
                          IllegalPolicyName(policies[i].name);
            if(policyTable.containsKey(policies[i].name))
                throw new org.omg.CosTrading.
                          DuplicatePolicyName(policies[i].name);

            policyTable.put(policies[i].name, policies[i].value);
        }

        //
        // Check the property names (if necessary)
        //
        org.omg.CosTrading.LookupPackage.HowManyProps whichProps =
            desired_props.discriminator();
        if(whichProps == org.omg.CosTrading.LookupPackage.HowManyProps.some)
        {
            //
            // Use a hashtable to check for duplicates
            //
            java.util.Hashtable propTable = new java.util.Hashtable();
            String[] propNames = desired_props.prop_names();

            for(int i = 0 ; i < propNames.length ; i++)
            {
                if(!dbMgr_.isPropertyNameValid(propNames[i]))
                    throw new org.omg.CosTrading.
                              IllegalPropertyName(propNames[i]);
                if(propTable.containsKey(propNames[i]))
                    throw new org.omg.CosTrading.
                              DuplicatePropertyName(propNames[i]);

                propTable.put(propNames[i], propNames[i]);
            }
        }

        //
        // Check for the presence of a starting trader policy
        //

        String startName = "starting_trader";
        if(policyTable.containsKey(startName))
        {
            org.omg.CORBA.Any value =
                (org.omg.CORBA.Any)policyTable.get(startName);

            org.omg.CosTrading.Policy p =
                new org.omg.CosTrading.Policy(startName, value);

            try
            {
                org.omg.CORBA.TypeCode tc =
                    org.omg.CosTrading.TraderNameHelper.type();

                if(!value.type().equal(tc))
                    throw new org.omg.CosTrading.LookupPackage.
                              PolicyTypeMismatch(p);

                String[] name =
                    org.omg.CosTrading.TraderNameHelper.extract(value);
                if(name.length > 0)
                {
                    org.omg.CosTrading.Link link = link_if();
                    if(link == null)
                        throw new org.omg.CosTrading.LookupPackage.
                                  InvalidPolicyValue(p);

                    org.omg.CosTrading.LinkPackage.LinkInfo info =
                        link.describe_link(name[0]);

                    //
                    // Remove the first component of the name
                    //
                    String[] newName = new String[name.length - 1];
                    System.arraycopy(name, 1, newName, 0, name.length - 1);
                    org.omg.CORBA.Any any = orb_.create_any();
                    org.omg.CosTrading.TraderNameHelper.insert(any, newName);

                    //
                    // Create a new set of policies to pass along to the
                    // next trader, placing the starting_trader policy first
                    //
                    org.omg.CosTrading.Policy[] newPolicies =
                        new org.omg.CosTrading.Policy[policies.length];
                    newPolicies[0].name = startName;
                    newPolicies[0].value = any;
                    int count = 1;
                    for(int i = 0 ; i < policies.length ; i++)
                        if(!startName.equals(policies[i].name))
                            newPolicies[count++] = policies[i];

                    info.target.query(type, constr, pref, newPolicies,
                                      desired_props, how_many, offers,
                                      offer_itr, limits_applied);
                    return;
                }
            }
            catch(org.omg.CosTrading.LinkPackage.IllegalLinkName e)
            {
                throw new org.omg.CosTrading.LookupPackage.
                    InvalidPolicyValue(p);
            }
            catch(org.omg.CosTrading.LinkPackage.UnknownLinkName e)
            {
                throw new org.omg.CosTrading.LookupPackage.
                    InvalidPolicyValue(p);
            }
            catch(org.omg.CORBA.BAD_OPERATION e)
            {
                throw new org.omg.CosTrading.LookupPackage.
                    InvalidPolicyValue(p);
            }
        }

        //
        // Check for the presence of the request_id policy
        //

        String reqName = "request_id";
        if(policyTable.containsKey(reqName))
        {
            org.omg.CORBA.Any value =
                (org.omg.CORBA.Any)policyTable.get(reqName);

            org.omg.CosTrading.Policy p =
                new org.omg.CosTrading.Policy(startName, value);

            try
            {
                org.omg.CORBA.TypeCode tc =
                    org.omg.CosTrading.AdminPackage.OctetSeqHelper.type();
                if(!value.type().equal(tc))
                    throw new org.omg.CosTrading.LookupPackage.
                        PolicyTypeMismatch(p);

                byte[] requestId = org.omg.CosTrading.AdminPackage.
                    OctetSeqHelper.extract(value);

                //
                // remember this request in case we see it again; if we've
                // already processed this request, then return now
                //
                if(!requestHistory_.add(requestId))
                {
                    offers.value = new org.omg.CosTrading.Offer[0];
                    limits_applied.value = new String[0];
                    return;
                }
            }
            catch(org.omg.CORBA.BAD_OPERATION e)
            {
                throw new org.omg.CosTrading.LookupPackage.
                    InvalidPolicyValue(p);
            }
        }

        org.omg.CORBA.Object obj = type_repos();
        ServiceTypeRepository repos = ServiceTypeRepositoryHelper.narrow(obj);

        //
        // Create a Query object to do the dirty work; we have to
        // pass it a truck-load of state information
        //

        Query q = new Query(orb_, this, repos, db_, requestHistory_,
                            type, constr, pref, policies, policyTable,
                            desired_props);

        q.query();

        q.getResults(how_many, offers, offer_itr, limits_applied);
    }
}
