// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Implementation of CosTrading::OfferIdIterator
//
final class OfferIdIteratorImpl
    extends org.omg.CosTrading._OfferIdIteratorImplBase
{
    private org.omg.CORBA.ORB orb_;
    private String[] offerIds_;
    private int maxList_;
    private int start_;

    OfferIdIteratorImpl(org.omg.CORBA.ORB orb, String[] offerIds, int maxList)
    {
        orb_ = orb;
        offerIds_ = offerIds;
        maxList_ = maxList;
        start_ = 0;
    }

    public int
    max_left()
        throws org.omg.CosTrading.UnknownMaxLeft
    {
        return (offerIds_.length - start_);
    }

    public boolean
    next_n(int n, org.omg.CosTrading.OfferIdSeqHolder offers)
    {
        boolean result;

        int count;
        if(n > (offerIds_.length - start_))
            count = offerIds_.length - start_;
        else
            count = n;

        if(count > maxList_)
            count = maxList_;

        offers.value = new String[count];
        for(int i = 0 ; i < count ; i++)
            offers.value[i] = offerIds_[start_ + i];

        start_ += count;
        result = (offerIds_.length - start_ > 0);  // any left?

        return result;
    }

    public void
    destroy()
    {
        orb_.disconnect(this);
    }
}
