// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Implementation of CosTrading::OfferIterator
//
final class OfferIteratorImpl
    extends org.omg.CosTrading._OfferIteratorImplBase
{
    private org.omg.CORBA.ORB orb_;
    private org.omg.CosTrading.Offer[] offers_;
    private int maxList_;
    private int start_;

    OfferIteratorImpl(org.omg.CORBA.ORB orb,
                      org.omg.CosTrading.Offer[] offers,
                      int maxList)
    {
        orb_ = orb;
        offers_ = offers;
        maxList_ = maxList;
        start_ = 0;
    }

    public int
    max_left()
        throws org.omg.CosTrading.UnknownMaxLeft
    {
        return (offers_.length - start_);
    }

    public boolean
    next_n(int n, org.omg.CosTrading.OfferSeqHolder offers)
    {
        boolean result;

        int count;
        if(n > (offers_.length - start_))
            count = offers_.length - start_;
        else
            count = n;

        if(count > maxList_)
            count = maxList_;

        offers.value = new org.omg.CosTrading.Offer[count];
        for(int i = 0 ; i < count ; i++)
            offers.value[i] = offers_[start_ + i];

        start_ += count;
        result = (offers_.length - start_ > 0);  // any left?

        return result;
    }

    public void
    destroy()
    {
        orb_.disconnect(this);
    }
}
