// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

final class PropUtil
{
    static org.omg.CORBA.Any
    getPropertyValue(org.omg.CosTrading.Property prop)
    {
        org.omg.CORBA.Any result = null;

        if(isDynamicProperty(prop.value.type()))
        {
            try
            {
                org.omg.CosTradingDynamic.DynamicProp dp =
                    org.omg.CosTradingDynamic.DynamicPropHelper.
                    extract(prop.value);

                //
                // evaluate dynamic property
                //
                result = dp.eval_if.evalDP(prop.name, dp.returned_type,
                                           dp.extra_info);
            }
            catch(org.omg.CosTradingDynamic.DPEvalFailure e)
            {
                // ignore
            }
            catch(org.omg.CORBA.SystemException e)
            {
                // ignore
            }
        }
        else
            result = prop.value;

        return result;
    }

    public static boolean
    hasDynamicProperties(org.omg.CosTrading.Property[] props)
    {
        boolean result = false;

        for(int i = 0 ; i < props.length && ! result ; i++)
            result = isDynamicProperty(props[i].value.type());

        return result;
    }

    public static boolean
    isDynamicProperty(org.omg.CORBA.TypeCode tc)
    {
        boolean result = false;

        result = tc.equal(org.omg.CosTradingDynamic.DynamicPropHelper.type());

        return result;
    }
}
