// **********************************************************************
// 
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
// 
// All Rights Reserved
// 
// **********************************************************************

package com.ooc.CosTrading;

class PropertyList
{
    private org.omg.CORBA.ORB orb_;
    private org.omg.CORBA.Object object_;
    private java.util.Hashtable propTable_;
    private java.util.Hashtable values_;
    private java.util.Hashtable propValues_;
    private org.omg.CosTrading.Property[] props_;

    PropertyList(org.omg.CORBA.ORB orb, org.omg.CORBA.Object object,
                  org.omg.CosTrading.Property[] props)
    {
        orb_ = orb;
        object_ = object;
        props_ = props;

        propTable_ = new java.util.Hashtable();

        //
        // Cache the Value objects we have produced
        //
        values_ = new java.util.Hashtable();

        //
        // Cache the property values we have retrieved
        //
        propValues_ = new java.util.Hashtable();

        //
        // Load the offer's properties into a hashtable for quicker lookup
        //
        for(int i = 0 ; i < props.length ; i++)
            propTable_.put(props[i].name, props[i]);
    }

    org.omg.CORBA.Object
    getObject()
    {
        return object_;
    }

    org.omg.CosTrading.Property[]
    getProperties()
    {
        return props_;
    }

    org.omg.CosTrading.Property[]
    getProperties(org.omg.CosTrading.LookupPackage.SpecifiedProps desired_props)
    {
        org.omg.CosTrading.Property[] result = null;

        if(desired_props.discriminator() ==
           org.omg.CosTrading.LookupPackage.HowManyProps.all)
        {
            java.util.Vector vec = new java.util.Vector();
            for(int i = 0 ; i < props_.length ; i++)
            {
                org.omg.CORBA.Any value = getPropertyValue(props_[i].name);
                if(value != null)
                    vec.addElement(
                        new org.omg.CosTrading.Property(props_[i].name, value));
            }
            result = new org.omg.CosTrading.Property[vec.size()];
            vec.copyInto((java.lang.Object[])result);
        }
        else if(desired_props.discriminator() ==
                org.omg.CosTrading.LookupPackage.HowManyProps.some)
        {
            String[] names = desired_props.prop_names();
            java.util.Vector vec = new java.util.Vector();
            for(int i = 0 ; i < names.length ; i++)
            {
                org.omg.CORBA.Any value = getPropertyValue(names[i]);
                if(value != null)
                    vec.addElement(
                        new org.omg.CosTrading.Property(names[i], value));
            }
            result = new org.omg.CosTrading.Property[vec.size()];
            vec.copyInto((java.lang.Object[])result);
        }
        else if(desired_props.discriminator() ==
                org.omg.CosTrading.LookupPackage.HowManyProps.none)
            result = new org.omg.CosTrading.Property[0];

        return result;
    }

    boolean
    exists(String property)
    {
        return propTable_.containsKey(property);
    }

    Value
    getValue(String property)
    {
        Value result = null;

        //
        // First see if we've already cached the value
        //
        java.lang.Object v = values_.get(property);

        if(v == null)
        {
            org.omg.CosTrading.Property p =
                (org.omg.CosTrading.Property)propTable_.get(property);

            if(p == null)
                return null;

            //
            // Next try to get the property's value
            // NOTE: this may cause dynamic property evaluation
            //
            org.omg.CORBA.Any val = getPropertyValue(property);

            if(val == null)
                return null;

            result = new Value(orb_, val);

            //
            // Cache the value object
            //
            values_.put(property, result);
        }
        else
        {
            //
            // Make sure we've got a Value (i.e. not a Value[])
            //
            if(v instanceof Value)
                result = (Value)v;
        }

        return result;
    }

    org.omg.CORBA.Any
    getPropertyValue(String property)
    {
        //
        // First see if we've already cached the value
        //
        org.omg.CORBA.Any result =
            (org.omg.CORBA.Any)propValues_.get(property);

        if(result == null)
        {
            org.omg.CosTrading.Property p =
                (org.omg.CosTrading.Property)propTable_.get(property);

            if(p == null)
                return null;

            //
            // NOTE: This may cause dynamic property evaluation
            //
            result = PropUtil.getPropertyValue(p);

            //
            // Cache the property value
            //
            if(result != null)
                propValues_.put(property, result);
        }

        return result;
    }
}
