// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Things are just too ugly without this
//
import org.omg.CosTradingRepos.*;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;

//
// Implementation of CosTrading::Register
//
final class RegisterImpl extends org.omg.CosTrading._RegisterImplBase
{
    private org.omg.CORBA.ORB orb_;
    private DBManager dbMgr_;
    private OfferDB db_;
    private org.omg.CosTrading.Admin admin_;
    private boolean useIR_;
    private boolean allowNil_;

    RegisterImpl(org.omg.CORBA.ORB orb, DBManager dbMgr, boolean useIR,
                 boolean allowNil)
    {
        orb_ = orb;
        dbMgr_ = dbMgr;
        db_ = dbMgr.getOfferDB();
        useIR_ = useIR;
        allowNil_ = allowNil;
    }

    void
    setAdmin(org.omg.CosTrading.Admin admin)
    {
        admin_ = admin;
    }

    //
    // Operations inherited from CosTrading::TraderComponents
    //

    public org.omg.CosTrading.Lookup
    lookup_if()
    {
        return admin_.lookup_if();
    }

    public org.omg.CosTrading.Register
    register_if()
    {
        return this;
    }

    public org.omg.CosTrading.Link
    link_if()
    {
        return admin_.link_if();
    }

    public org.omg.CosTrading.Proxy
    proxy_if()
    {
        return admin_.proxy_if();
    }

    public org.omg.CosTrading.Admin
    admin_if()
    {
        return admin_;
    }

    //
    // Operations inherited from CosTrading::SupportAttributes
    //

    public boolean
    supports_modifiable_properties()
    {
        return admin_.supports_modifiable_properties();
    }

    public boolean
    supports_dynamic_properties()
    {
        return admin_.supports_dynamic_properties();
    }

    public boolean
    supports_proxy_offers()
    {
        return admin_.supports_proxy_offers();
    }

    public org.omg.CORBA.Object
    type_repos()
    {
        return admin_.type_repos();
    }

    //
    // Operations inherited from CosTrading::Register
    //

    public String
    export(org.omg.CORBA.Object reference,
           String type,
           org.omg.CosTrading.Property[] properties)
        throws org.omg.CosTrading.RegisterPackage.InvalidObjectRef,
               org.omg.CosTrading.IllegalServiceType,
               org.omg.CosTrading.UnknownServiceType,
               org.omg.CosTrading.RegisterPackage.InterfaceTypeMismatch,
               org.omg.CosTrading.IllegalPropertyName,
               org.omg.CosTrading.PropertyTypeMismatch,
               org.omg.CosTrading.ReadonlyDynamicProperty,
               org.omg.CosTrading.MissingMandatoryProperty,
               org.omg.CosTrading.DuplicatePropertyName
    {
        String result = null;

        //
        // Check for a nil object reference
        //
        if(reference == null && !allowNil_)
            throw new org.omg.CosTrading.RegisterPackage.
                InvalidObjectRef(reference);

        org.omg.CORBA.Object obj = type_repos();
        ServiceTypeRepository repos = ServiceTypeRepositoryHelper.narrow(obj);

        //
        // Retrieve complete information about the service type from the
        // repository - may throw IllegalServiceType, UnknownServiceType
        //
        TypeStruct ts = repos.fully_describe_type(type);

        //
        // Do not allow exporting for a masked service type
        //
        if(ts.masked)
            throw new org.omg.CosTrading.UnknownServiceType(type);

        //
        // Validate the interface - may throw InterfaceTypeMismatch
        //
        if(reference != null)
            validateInterface(reference, type, ts.if_name);

        //
        // Validate the exported properties - may throw
        // IllegalPropertyName, PropertyTypeMismatch,
        // MissingMandatoryProperty, DuplicatePropertyName
        //
        OfferUtil.validateProperties(dbMgr_, properties, type, ts,
                                     supports_dynamic_properties());

        //
        // Save the offer in the database
        //

        db_.begin(AbstractDB.WRITE);

        try
        {
            result = db_.create(type, reference, properties);
        }
        finally
        {
            db_.end();
        }

        return result;
    }

    public void
    withdraw(String id)
        throws org.omg.CosTrading.IllegalOfferId,
               org.omg.CosTrading.UnknownOfferId,
               org.omg.CosTrading.RegisterPackage.ProxyOfferId
    {
        if(!db_.validateOfferId(id))
            throw new org.omg.CosTrading.IllegalOfferId(id);

        db_.begin(AbstractDB.WRITE);

        try
        {
            if(!db_.exists(id))
                throw new org.omg.CosTrading.UnknownOfferId(id);

            if(db_.isProxy(id))
                throw new org.omg.CosTrading.RegisterPackage.ProxyOfferId(id);

            db_.remove(id);
        }
        finally
        {
            db_.end();
        }
    }

    public org.omg.CosTrading.RegisterPackage.OfferInfo
    describe(String id)
        throws org.omg.CosTrading.IllegalOfferId,
               org.omg.CosTrading.UnknownOfferId,
               org.omg.CosTrading.RegisterPackage.ProxyOfferId
    {
        org.omg.CosTrading.RegisterPackage.OfferInfo result;

        if(!db_.validateOfferId(id))
            throw new org.omg.CosTrading.IllegalOfferId(id);


        db_.begin(AbstractDB.READ);

        try
        {
            if(!db_.exists(id))
                throw new org.omg.CosTrading.UnknownOfferId(id);

            if(db_.isProxy(id))
                throw new org.omg.CosTrading.RegisterPackage.ProxyOfferId(id);

            result = db_.describe(id);
        }
        finally
        {
            db_.end();
        }

        return result;
    }

    public void
    modify(String id,
           String[] del_list,
           org.omg.CosTrading.Property[] modify_list)
        throws org.omg.CosTrading.NotImplemented,
               org.omg.CosTrading.IllegalOfferId,
               org.omg.CosTrading.UnknownOfferId,
               org.omg.CosTrading.RegisterPackage.ProxyOfferId,
               org.omg.CosTrading.IllegalPropertyName,
               org.omg.CosTrading.RegisterPackage.UnknownPropertyName,
               org.omg.CosTrading.PropertyTypeMismatch,
               org.omg.CosTrading.ReadonlyDynamicProperty,
               org.omg.CosTrading.RegisterPackage.MandatoryProperty,
               org.omg.CosTrading.RegisterPackage.ReadonlyProperty,
               org.omg.CosTrading.DuplicatePropertyName
    {
        if(!supports_modifiable_properties())
            throw new org.omg.CosTrading.NotImplemented();

        if(!db_.validateOfferId(id))
            throw new org.omg.CosTrading.IllegalOfferId(id);

        try
        {
            db_.begin(AbstractDB.WRITE);

            if(!db_.exists(id))
                throw new org.omg.CosTrading.UnknownOfferId(id);

            if(db_.isProxy(id))
                throw new org.omg.CosTrading.RegisterPackage.ProxyOfferId(id);

            String type = db_.whichService(id);

            org.omg.CORBA.Object obj = type_repos();
            ServiceTypeRepository repos =
                ServiceTypeRepositoryHelper.narrow(obj);

            //
            // Retrieve complete information about the service type from the
            // repository - may throw IllegalServiceType, UnknownServiceType
            //
            TypeStruct ts = repos.fully_describe_type(type);

            org.omg.CosTrading.RegisterPackage.OfferInfo info =
                db_.describe(id);

            //
            // Check the proposed deletion list - may throw several
            // exceptions
            //
            checkDelete(del_list, type, ts, info);

            //
            // Check the proposed modification list - may throw several
            // exceptions
            //
            checkModify(modify_list, type, ts, info);

            //
            // Build a vector of the offer's new properties
            //
            // Algorithm:
            //     copy in the modify_list
            //     for each property in info.properties
            //         if not already in vector, and not in del_list, add
            //             to vector
            //

            java.util.Vector props = new java.util.Vector();
            for(int i = 0 ; i < modify_list.length ; i++)
                props.addElement(modify_list[i]);

            for(int i = 0 ; i < info.properties.length ; i++)
            {
                boolean found = false;

                // Check del_list to see if property is to be deleted
                for(int d = 0 ; d < del_list.length && !found ; d++)
                    if(info.properties[i].name.equals(del_list[d]))
                        found = true;

                // Check props to see if we already have this property
                java.util.Enumeration e = props.elements();
                while(e.hasMoreElements() && !found)
                {
                    org.omg.CosTrading.Property p =
                        (org.omg.CosTrading.Property)e.nextElement();
                    if(info.properties[i].name.equals(p.name))
                        found = true;
                }

                //
                // If we didn't find it in del_list, and it's not already
                // in props, then add it now
                //
                if(!found)
                    props.addElement(info.properties[i]);
            }

            //
            // Create an array from the vector
            //
            org.omg.CosTrading.Property[] arr =
                new org.omg.CosTrading.Property[props.size()];
            props.copyInto((java.lang.Object[])arr);

            //
            // Make the changes
            //
            db_.modify(id, arr);
        }
        catch(org.omg.CosTrading.IllegalServiceType e)
        {
            throw new org.omg.CosTrading.UnknownOfferId(id);
        }
        catch(org.omg.CosTrading.UnknownServiceType e)
        {
            throw new org.omg.CosTrading.UnknownOfferId(id);
        }
        finally
        {
            db_.end();
        }
    }

    public void
    withdraw_using_constraint(String type, String constr)
        throws org.omg.CosTrading.IllegalServiceType,
               org.omg.CosTrading.UnknownServiceType,
               org.omg.CosTrading.IllegalConstraint,
               org.omg.CosTrading.RegisterPackage.NoMatchingOffers
    {
        org.omg.CORBA.Object obj = type_repos();
        ServiceTypeRepository repos = ServiceTypeRepositoryHelper.narrow(obj);

        //
        // Retrieve complete information about the service type from the
        // repository - may throw IllegalServiceType, UnknownServiceType
        //
        TypeStruct ts = repos.fully_describe_type(type);

        Constraint c = new Constraint(orb_);
        if(!c.parse(constr))
            throw new org.omg.CosTrading.IllegalConstraint(constr);

        int count = 0;

        try
        {
            db_.begin(AbstractDB.WRITE);

            //
            // Retrieve all of the offers of this type and process them;
            // we get a Hashtable whose keys are offer IDs and whose values
            // are OfferInfo structs
            //
            java.util.Hashtable offers = db_.getOffers(type);

            if(offers != null)
            {
                java.util.Enumeration e = offers.keys();
                while(e.hasMoreElements())
                {
                    String id = (String)e.nextElement();
                    java.lang.Object o = offers.get(id);
                    org.omg.CosTrading.RegisterPackage.OfferInfo info =
                        (org.omg.CosTrading.RegisterPackage.OfferInfo)o;

                    PropertyList pl = new PropertyList(orb_,
                                                       info.reference,
                                                       info.properties);

                    // NOTE: dynamic properties will be evaluated

                    if(c.evaluate(pl))
                    {
                        db_.remove(id);
                        count++;
                    }
                }
            }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            db_.end();
        }

        if(count == 0)
            throw new org.omg.CosTrading.RegisterPackage.
                NoMatchingOffers(constr);
    }

    public org.omg.CosTrading.Register
    resolve(String[] name)
        throws org.omg.CosTrading.RegisterPackage.IllegalTraderName,
               org.omg.CosTrading.RegisterPackage.UnknownTraderName,
               org.omg.CosTrading.RegisterPackage.RegisterNotSupported
    {
        org.omg.CosTrading.Register result = null;

        org.omg.CosTrading.Link link = link_if();
        if(link == null)
            throw new org.omg.CosTrading.RegisterPackage.
                UnknownTraderName(name);

        try
        {
            org.omg.CosTrading.LinkPackage.LinkInfo info =
                link.describe_link(name[0]);

            if(info.target_reg == null)
                throw new org.omg.CosTrading.RegisterPackage.
                    RegisterNotSupported(name);

            if(name.length == 1)
                result = info.target_reg;    // we're done
            else
            {
                //
                // Strip off the first component and pass on the remainder
                //
                String[] newName = new String[name.length - 1];
                System.arraycopy(name, 1, newName, 0, newName.length);
                result = info.target_reg.resolve(newName);
            }
        }
        catch(org.omg.CosTrading.LinkPackage.IllegalLinkName e)
        {
            throw new org.omg.CosTrading.RegisterPackage.
                IllegalTraderName(name);
        }
        catch(org.omg.CosTrading.LinkPackage.UnknownLinkName e)
        {
            throw new org.omg.CosTrading.RegisterPackage.
                UnknownTraderName(name);
        }

        return result;
    }

    private void
    validateInterface(org.omg.CORBA.Object ref,
                      String typeName,
                      String interfaceName)
        throws org.omg.CosTrading.RegisterPackage.InterfaceTypeMismatch
    {
        //
        // Verify that the given object is compatible with the interface
        // specified by the service type
        //
        // To validate an interface, we must check that the object reference
        // supplied is the same as the interface specified in the service
        // type, or is a subtype of the interface
        //

        if(useIR_)
        {
            //
            // Retrieve the InterfaceDef object for the interface
            //
            try
            {
                org.omg.CORBA.Object obj = ref._get_interface_def();
                if(obj != null)
                {
                    org.omg.CORBA.InterfaceDef def =
                        org.omg.CORBA.InterfaceDefHelper.narrow(obj);

                    if(!IRUtil.validate(def, interfaceName))
                        throw new org.omg.CosTrading.RegisterPackage.
                            InterfaceTypeMismatch(typeName, ref);
                }
            }
            catch(org.omg.CORBA.SystemException e)
            {
                // ignore
            }
        }
    }

    private void
    checkDelete(String[] del_list,
                String typeName,
                TypeStruct type,
                org.omg.CosTrading.RegisterPackage.OfferInfo info)
        throws org.omg.CosTrading.IllegalPropertyName,
               org.omg.CosTrading.RegisterPackage.UnknownPropertyName,
               org.omg.CosTrading.RegisterPackage.MandatoryProperty,
               org.omg.CosTrading.RegisterPackage.ReadonlyProperty,
               org.omg.CosTrading.DuplicatePropertyName
    {
        //
        // Create a hashtable of the offer's properties
        //
        java.util.Hashtable offerProps = new java.util.Hashtable();
        for(int i = 0 ; i < info.properties.length ; i++)
            offerProps.put(info.properties[i].name, info.properties[i]);

        //
        // Create a hashtable of the service type's properties
        //
        java.util.Hashtable typeProps = new java.util.Hashtable();
        for(int i = 0 ; i < type.props.length ; i++)
            typeProps.put(type.props[i].name, type.props[i]);

        //
        // Also create a hashtable of the deleted property names
        // we've processed
        //
        java.util.Hashtable deletedProps = new java.util.Hashtable();

        //
        // For each property name in del_list, check to see that the
        // name is legal, verify that the offer contains the property,
        // make sure it isn't mandatory, and make sure there aren't
        // duplicate names in del_list
        //
        for(int i = 0 ; i < del_list.length ; i++)
        {
            String propName = del_list[i];

            if(!dbMgr_.isPropertyNameValid(propName))
                throw new org.omg.CosTrading.IllegalPropertyName(propName);

            //
            // Check for a duplicate
            //
            if(deletedProps.containsKey(propName))
                throw new org.omg.CosTrading.DuplicatePropertyName(propName);

            deletedProps.put(propName, propName);

            //
            // Find the property with the matching name
            //
            org.omg.CosTrading.Property prop =
                (org.omg.CosTrading.Property)offerProps.get(propName);

            if(prop != null)
            {
                PropStruct ps = (PropStruct)typeProps.get(propName);
                if(ps != null)
                {
                    if(OfferUtil.isMandatory(ps.mode))
                        throw new org.omg.CosTrading.RegisterPackage.
                                  MandatoryProperty(typeName, propName);
                }
            }
            else
                throw new org.omg.CosTrading.RegisterPackage.
                          UnknownPropertyName(propName);
        }
    }

    private void
    checkModify(org.omg.CosTrading.Property[] modify_list,
                String typeName,
                TypeStruct type,
                org.omg.CosTrading.RegisterPackage.OfferInfo info)
        throws org.omg.CosTrading.IllegalPropertyName,
               org.omg.CosTrading.RegisterPackage.UnknownPropertyName,
               org.omg.CosTrading.PropertyTypeMismatch,
               org.omg.CosTrading.ReadonlyDynamicProperty,
               org.omg.CosTrading.RegisterPackage.ReadonlyProperty,
               org.omg.CosTrading.DuplicatePropertyName
    {
        //
        // Create a hashtable of the modified properties
        //
        java.util.Hashtable modProps = new java.util.Hashtable();
        for(int i = 0 ; i < modify_list.length ; i++)
        {
            if(modProps.containsKey(modify_list[i].name))
                throw new org.omg.CosTrading.
                          DuplicatePropertyName(modify_list[i].name);

            modProps.put(modify_list[i].name, modify_list[i]);
        }

        //
        // Create a hashtable of the offer's properties
        //
        java.util.Hashtable offerProps = new java.util.Hashtable();
        for(int i = 0 ; i < info.properties.length ; i++)
            offerProps.put(info.properties[i].name, info.properties[i]);

        //
        // Create a hashtable of the service type's properties
        //
        java.util.Hashtable typeProps = new java.util.Hashtable();
        for(int i = 0 ; i < type.props.length ; i++)
            typeProps.put(type.props[i].name, type.props[i]);

        //
        // Check the modification list for readonly properties, type
        // mismatches and duplicates
        //

        boolean allowDynamic = supports_dynamic_properties();
        java.util.Enumeration e = modProps.elements();
        while(e.hasMoreElements())
        {
            org.omg.CosTrading.Property prop =
                (org.omg.CosTrading.Property)e.nextElement();

            //
            // Lookup the property information in the service type
            // (may be null if the property has no definition)
            //
            PropStruct ps = (PropStruct)typeProps.get(prop.name);

            //
            // If the property is present in the offer, and the service
            // type says the property mode is read-only, then it's an error
            //
            if(offerProps.containsKey(prop.name) && ps != null &&
               OfferUtil.isReadonly(ps.mode))
                throw new org.omg.CosTrading.RegisterPackage.
                    ReadonlyProperty(typeName, prop.name);

            OfferUtil.checkProperty(dbMgr_, typeName, prop, ps, allowDynamic);
        }
    }
}
