// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTrading;

//
// Things are just too ugly without this
//
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;

interface TypeDB extends AbstractDB
{
    //
    // Returns the TypeStruct for the type, or null if the
    // the type doesn't exist
    //
    TypeStruct
    describeType(String name);

    //
    // Returns true if the type was found, false otherwise
    //
    boolean
    maskType(String name);

    //
    // Returns true if the type was found, false otherwise
    //
    boolean
    unmaskType(String name);

    //
    // Returns the names of all of the service types
    //
    String[]
    getTypes();

    //
    // Returns the names of all of the service types whose incarnation
    // is the same or greater than the given one
    //
    String[]
    getTypesSince(IncarnationNumber inc);

    //
    // Returns the current incarnation number (the one that will be
    // assigned to the next service type)
    //
    IncarnationNumber
    getIncarnation();

    //
    // Creates a new service type
    //
    IncarnationNumber
    createType(String name,
               String interfaceName,
               PropStruct[] props,
               String[] superTypes);

    //
    // Returns true if the type was found, false otherwise
    //
    boolean
    removeType(String name);

    //
    // Returns the name of a subtype of the given type, or null if
    // no subtypes were found
    //
    String
    findSubType(String name);

    //
    // Returns the names of all supertypes of the given type,
    // or null if the type wasn't found
    //
    String[]
    getAllSuperTypes(String name);
}
