// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole;

import com.ooc.CosTradingConsole.Util.*;
import com.ooc.Util.*;
import com.ooc.Util.GUI.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

class Summary extends JPanel
{
    private JLabel title_;
    private JTextArea text_;
    private JScrollPane scroll_;

    private BaseController controller_ = null;
    private Object value_ = null;

    public
    Summary()
    {
        setLayout(new BorderLayout());

        title_ = new JLabel("");
        title_.setHorizontalAlignment(title_.LEFT);
        title_.setBorder(
            BorderFactory.createCompoundBorder(
                BorderFactory.createLoweredBevelBorder(),
                BorderFactory.createEmptyBorder(2, 2, 2, 2)));
        title_.setMinimumSize(new Dimension(50, 25));
        title_.setPreferredSize(new Dimension(50, 25));
        add("North", title_);

        text_ = new JTextArea();
        text_.setEditable(false);
        text_.setBorder(null);
        scroll_ = AppStandards.createScrollPane(text_);
        scroll_.setMinimumSize(new Dimension(150, 25));
        add("Center", scroll_);
    }

    void
    clear()
    {
        title_.setText("");
        text_.setText("");
        controller_ = null;
        value_ = null;
    }

    void
    setValue(BaseController controller, Object value)
    {
        if(controller != controller_ || ! value.equals(value_))
        {
            controller_ = controller;
            value_ = value;
            refresh();
        }
    }

    void
    refresh()
    {
        title_.setText(
            AppStandards.getFormattedString("DescriptionOfKey",
                                            value_.toString()));
        updateText();
    }

    private void
    updateText()
    {
        FormattedText text = new FormattedText();
        StringBuffer msg = new StringBuffer();
        boolean status = controller_.describeItem(value_, text, msg);
        if(status)
        {
            text_.setText(text.toString());
            // none of these work - I want to make sure the top
            // of the text area is visible after setting the text
            //JScrollBar sb = scroll_.getVerticalScrollBar();
            //sb.setValue(sb.getMinimum());
            //OR
            //text_.scrollRectToVisible(new Rectangle(0, 0, 0, 0));
        }
        else
            text_.setText("");
    }
}
