// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Tools;

import com.ooc.CosTradingConsole.Util.*;
import com.ooc.Util.*;
import com.ooc.Util.CORBA.GUI.*;
import com.ooc.Util.GUI.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import org.omg.CosTrading.*;

public class QueryPoliciesDialog extends JDialog implements ActionListener
{
    private TraderModel model_;

    private JCheckBox exactTypeCheck_;
    private JComboBox exactType_;
    private JCheckBox modPropCheck_;
    private JComboBox modProp_;
    private JCheckBox dynPropCheck_;
    private JComboBox dynProp_;
    private JCheckBox proxyCheck_;
    private JComboBox proxy_;
    private JCheckBox searchCardCheck_;
    private JTextField searchCard_;
    private JCheckBox matchCardCheck_;
    private JTextField matchCard_;
    private JCheckBox returnCardCheck_;
    private JTextField returnCard_;
    private JCheckBox linkFollowCheck_;
    private JComboBox linkFollow_;
    private JCheckBox hopCountCheck_;
    private JTextField hopCount_;
    private Vector policies_ = new
    Vector();
    private StatusBar status_;

    public
    QueryPoliciesDialog(Frame parent, TraderModel model)
    {
        super(parent, AppStandards.getString("QueryPoliciesTitleKey"));
        model_ = model;
        setResizable(true);

        Container content = getContentPane();
        content.setLayout(new GridBagLayout());

        exactTypeCheck_ = AppStandards.createCheckBox("ExactTypeMatchKey");
        exactType_ = AppStandards.createComboBox();
        exactType_.addItem(AppStandards.getString("NoKey"));
        exactType_.addItem(AppStandards.getString("YesKey"));
        Constrain.constrain(content, exactTypeCheck_, 0, 0, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, exactType_, 1, 0, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10, 10, 5);

        modPropCheck_ = AppStandards.createCheckBox("UseModifiableKey");
        modProp_ = AppStandards.createComboBox();
        modProp_.addItem(AppStandards.getString("NoKey"));
        modProp_.addItem(AppStandards.getString("YesKey"));
        Constrain.constrain(content, modPropCheck_, 0, 1, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, modProp_, 1, 1, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10, 10, 5);

        dynPropCheck_ = AppStandards.createCheckBox("UseDynamicKey");
        dynProp_ = AppStandards.createComboBox();
        dynProp_.addItem(AppStandards.getString("NoKey"));
        dynProp_.addItem(AppStandards.getString("YesKey"));
        Constrain.constrain(content, dynPropCheck_, 0, 2, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, dynProp_, 1, 2, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10, 10, 5);

        proxyCheck_ = AppStandards.createCheckBox("UseProxyKey");
        proxy_ = AppStandards.createComboBox();
        proxy_.addItem(AppStandards.getString("NoKey"));
        proxy_.addItem(AppStandards.getString("YesKey"));
        Constrain.constrain(content, proxyCheck_, 0, 3, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, proxy_, 1, 3, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10, 10, 5);

        searchCardCheck_ = AppStandards.createCheckBox("SearchCardKey");
        searchCard_ = AppStandards.createTextField(10);
        Constrain.constrain(content, searchCardCheck_, 0, 4, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, searchCard_, 1, 4, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10);

        matchCardCheck_ = AppStandards.createCheckBox("MatchCardKey");
        matchCard_ = AppStandards.createTextField(10);
        Constrain.constrain(content, matchCardCheck_, 0, 5, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, matchCard_, 1, 5, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10);

        returnCardCheck_ = AppStandards.createCheckBox("ReturnCardKey");
        returnCard_ = AppStandards.createTextField(10);
        Constrain.constrain(content, returnCardCheck_, 0, 6, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, returnCard_, 1, 6, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10);

        linkFollowCheck_ = AppStandards.createCheckBox("LinkFollowPolicyKey");
        linkFollow_ = AppStandards.createComboBox();
        linkFollow_.addItem(AppStandards.getString("LocalOnlyKey"));
        linkFollow_.addItem(AppStandards.getString("IfNoneLocalKey"));
        linkFollow_.addItem(AppStandards.getString("AlwaysKey"));
        Constrain.constrain(content, linkFollowCheck_, 0, 7, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, linkFollow_, 1, 7, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10, 2, 5);

        hopCountCheck_ = AppStandards.createCheckBox("LinkHopCountKey");
        hopCount_ = AppStandards.createTextField(10);
        Constrain.constrain(content, hopCountCheck_, 0, 8, 1, 1,
            GridBagConstraints.NONE, GridBagConstraints.WEST,
            0.0, 0.0, 10, 10, 0, 0);
        Constrain.constrain(content, hopCount_, 1, 8, 1, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.WEST,
            1.0, 0.0, 10, 10, 0, 10);

        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new GridLayout(4, 1, 5, 5));
        JButton button;

        button = AppStandards.createButton("OkButtonKey");
        button.setActionCommand("ok");
        button.addActionListener(this);
        buttonPanel.add(button);

        button = AppStandards.createButton("CancelButtonKey");
        button.setActionCommand("cancel");
        button.addActionListener(this);
        buttonPanel.add(button);

        buttonPanel.add(Box.createVerticalGlue());

        button = AppStandards.createButton("DefaultsButtonKey");
        button.setActionCommand("defaults");
        button.addActionListener(this);
        buttonPanel.add(button);

        Constrain.constrain(content, buttonPanel, 2, 0, 1, 8,
            GridBagConstraints.NONE, GridBagConstraints.NORTHWEST,
            0.0, 0.0, 10, 10, 0, 10);


        status_ = new StatusBar(false);
        Constrain.constrain(content, status_, 0, 9, 3, 1,
            GridBagConstraints.HORIZONTAL, GridBagConstraints.NORTHWEST,
            1.0, 0.0, 5, 10, 0, 10);

        pack();

        Point p = parent.getLocation();
        setLocation(p.x + 40, p.y + 40);
    }

    //
    // Override setVisible() so that we initialize the dialog's fields
    // when made visible
    //
    public void
    setVisible(boolean visible)
    {
        if(visible && ! isVisible())
            initDialog();

        super.setVisible(visible);
    }

    public void
    actionPerformed(ActionEvent e)
    {
        String command = e.getActionCommand();
        if(command.equals("defaults"))
            loadDefaults();
        else if(command.equals("ok"))
            ok();
        else if(command.equals("cancel"))
            cancel();
    }

    //
    // Collect the policies to be used for a query
    //
    public org.omg.CosTrading.Policy[]
    getPolicies()
    {
        org.omg.CosTrading.Policy[] result =
            new org.omg.CosTrading.Policy[policies_.size()];
        policies_.copyInto((java.lang.Object[])result);
        return result;
    }

    protected void
    initDialog()
    {
        status_.clear();
    }

    protected void
    ok()
    {
        Vector vec = new Vector();
        org.omg.CosTrading.Policy policy;

        //
        // We only collect values for those policies whose checkboxes are
        // checked
        //

        if(exactTypeCheck_.isSelected())
            vec.addElement(getBooleanPolicy("exact_type_match", exactType_));
        if(modPropCheck_.isSelected())
            vec.addElement(getBooleanPolicy("use_modifiable_properties",
                                            modProp_));
        if(dynPropCheck_.isSelected())
            vec.addElement(getBooleanPolicy("use_dynamic_properties",
                                            dynProp_));
        if(proxyCheck_.isSelected())
            vec.addElement(getBooleanPolicy("use_proxy_offers", proxy_));

        //
        // Check the values in selected text fields
        //
        if(searchCardCheck_.isSelected())
        {
            policy = getULongPolicy(AppStandards.getString("SearchCardKey"),
                "search_card", searchCard_);
            if(policy == null)
                return;
            vec.addElement(policy);
        }

        if(matchCardCheck_.isSelected())
        {
            policy =getULongPolicy(AppStandards.getString("MatchCardKey"),
                "match_card", matchCard_);
            if(policy == null)
                return;
            vec.addElement(policy);
        }

        if(returnCardCheck_.isSelected())
        {
            policy = getULongPolicy(AppStandards.getString("ReturnCardKey"),
                "return_card", returnCard_);
            if(policy == null)
                return;
            vec.addElement(policy);
        }

        if(linkFollowCheck_.isSelected())
        {
            policy = getFollowPolicy("link_follow_rule", linkFollow_);
            if(policy == null)
                return;
            vec.addElement(policy);
        }

        if(hopCountCheck_.isSelected())
        {
            policy = getULongPolicy(AppStandards.getString("LinkHopCountKey"),
                "hop_count", hopCount_);
            if(policy == null)
                return;
            vec.addElement(policy);
        }

        policies_ = vec;
        setVisible(false);
    }

    protected void
    cancel()
    {
        setVisible(false);
    }

    protected synchronized void
    loadDefaults()
    {
        try
        {
            status_.setText(AppStandards.getString("LoadingDefAttribKey"));

            Lookup lookup = model_.getLookup();
            boolean exactType = false;
            boolean useModProps = lookup.supports_modifiable_properties();
            boolean useDynProps = lookup.supports_dynamic_properties();
            boolean useProxyOffers = lookup.supports_proxy_offers();
            int searchCard = lookup.def_search_card();
            int matchCard = lookup.def_match_card();
            int returnCard = lookup.def_return_card();
            FollowOption followPolicy = lookup.def_follow_policy();
            int hopCount = lookup.def_hop_count();

            exactType_.setSelectedIndex((exactType ? 1 : 0));
            modProp_.setSelectedIndex((useModProps ? 1 : 0));
            dynProp_.setSelectedIndex((useDynProps ? 1 : 0));
            proxy_.setSelectedIndex((useProxyOffers ? 1 : 0));
            searchCard_.setText("" + searchCard);
            matchCard_.setText("" + matchCard);
            returnCard_.setText("" + returnCard);
            linkFollow_.setSelectedIndex(followPolicy.value());
            hopCount_.setText("" + hopCount);

            status_.clear();
        }
        catch(org.omg.CORBA.SystemException e)
        {
            MessageDialog.showSystemError(this, e);
        }
    }

    protected org.omg.CosTrading.Policy
    getBooleanPolicy(String name, JComboBox combo)
    {
        org.omg.CosTrading.Policy result;

        org.omg.CORBA.ORB orb = com.ooc.Util.CORBA.ORBManager.ORB();
        org.omg.CORBA.Any any = orb.create_any();
        any.insert_boolean(combo.getSelectedIndex() == 1);
        result = new org.omg.CosTrading.Policy(name, any);

        return result;
    }

    protected org.omg.CosTrading.Policy
    getFollowPolicy(String name, JComboBox combo)
    {
        org.omg.CosTrading.Policy result;

        org.omg.CORBA.ORB orb = com.ooc.Util.CORBA.ORBManager.ORB();
        org.omg.CORBA.Any any = orb.create_any();
        FollowOption follow = FollowOption.from_int(combo.getSelectedIndex());
        FollowOptionHelper.insert(any, follow);
        result = new org.omg.CosTrading.Policy(name, any);

        return result;
    }

    protected org.omg.CosTrading.Policy
    getULongPolicy(String desc, String name, JTextField text)
    {
        org.omg.CosTrading.Policy result = null;

        Integer i = validateNumber(desc, text.getText());
        if(i != null)
        {
            org.omg.CORBA.ORB orb = com.ooc.Util.CORBA.ORBManager.ORB();
            org.omg.CORBA.Any any = orb.create_any();
            any.insert_ulong(i.intValue());
            result = new org.omg.CosTrading.Policy(name, any);
        }

        return result;
    }

    protected Integer
    validateNumber(String desc, String val)
    {
        Integer result = null;

        String s = val.trim();
        if(s.length() == 0)
            MessageDialog.showError(this,
                AppStandards.getFormattedString("NoValueForKey", desc));
        else
        {
            try
            {
                Integer i = Integer.valueOf(s);
                if(i.intValue() < 0)
                    MessageDialog.showError(this,
                        AppStandards.getFormattedString("InvalidValueForKey",
                                                        desc));
                else
                    result = i;
            }
            catch(NumberFormatException e)
            {
                MessageDialog.showError(this,
                    AppStandards.getFormattedString("InvalidValueForKey",
                                                    desc));
            }
        }

        return result;
    }
}
