// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Util;

import java.util.*;

public class AppResources extends ListResourceBundle
{
    public Object[][]
    getContents()
    {
        return contents_;
    }


    // Parameterized messages use the format expected by the
    // java.text.MessageFormat class

    static final Object[][] contents_ =
    {
        // LOCALIZE THIS

        // Buttons
        {"OkButtonKey",           "OK"},
        {"CancelButtonKey",       "Cancel"},
        {"CloseButtonKey",        "Close"},
        {"AddButtonKey",          "Add..."},
        {"EditButtonKey",         "Edit..."},
        {"DeleteButtonKey",       "Delete"},
        {"NewButtonKey",          "New"},
        {"DynamicButtonKey",      "Dynamic..."},
        {"ResetButtonKey",        "Reset"},
        {"QueryButtonKey",        "Query"},
        {"PoliciesButtonKey",     "Policies..."},
        {"DefaultsButtonKey",     "Defaults"},
        {"BrowseButtonKey",       "Browse..."},
        {"IORFileTitleKey",       "Load"},

        // Titles
        {"ConsoleTitleKey",       "ORBacus Trader Console"},
        {"PropertiesTitleKey",    "Properties"},
        {"ErrorTitleKey",         "Error"},
        {"ConfirmTitleKey",       "Confirm"},
        {"QueryPoliciesTitleKey", "Query Policies"},
        {"NewOfferTitleKey",      "New Offer"},
        {"EditOfferTitleKey",     "Edit Offer - {0}"},
        {"NewProxyTitleKey",      "New Proxy Offer"},
        {"NewLinkTitleKey",       "New Link"},
        {"EditLinkTitleKey",      "Edit Link - {0}"},
        {"AttributesTitleKey",    "Attributes"},
        {"NewTypeTitleKey",       "New Service Type"},
        {"PropertyTitleKey",      "Property"},
        {"SuperTypeTitleKey",     "Super Types"},
        {"DynPropTitleKey",       "Dynamic Property - {0}"},
        {"QueryTitleKey",         "Query"},
        {"QueryResultsTitleKey",  "Query Results"},
        {"WithdrawTitleKey",      "Withdraw Offers"},
        {"PolicyTitleKey",        "Policy"},
        {"ConnectTitleKey",       "Connect"},
        {"IRTitleKey",            "Interface Repository Browser"},
        {"AddPropTitleKey",       "Add Property"},

        // Error messages
        {"FileNotFoundKey",       "File {0} does not exist"},
        {"FileErrorKey",          "I/O error occurred reading file {0}"},
        {"NotFileKey",            "{0} is not a file"},
        {"InvalidInitialRefKey",  "Invalid initial reference `{0}''"},
        {"SystemErrorKey",        "System error occurred"},
        {"NothingSelectedKey",    "Nothing is selected"},
        {"NoValueKey",            "No value provided"},
        {"NoValueForKey",         "No value provided for {0}"},
        {"InvalidValueForKey",    "Invalid value for {0}"},
        {"InvalidBooleanKey",     "Invalid boolean value `{0}''"},
        {"InvalidShortKey",       "Invalid short value `{0}''"},
        {"ShortRangeKey",         "Short value {0} is out of range"},
        {"InvalidUShortKey",      "Invalid unsigned short value `{0}''"},
        {"UShortRangeKey",        "Unsigned short value {0} is out of range"},
        {"InvalidLongKey",        "Invalid long value `{0}''"},
        {"LongRangeKey",          "Long value {0} is out of range"},
        {"InvalidULongKey",       "Invalid unsigned long value `{0}''"},
        {"ULongRangeKey",         "Unsigned long value {0} is out of range"},
        {"InvalidDoubleKey",      "Invalid double value `{0}''"},
        {"InvalidOctetKey",       "Invalid octet value `{0}''"},
        {"OctetRangeKey",         "Octet value {0} is out of range"},
        {"InvalidFloatKey",       "Invalid float value `{0}''"},
        {"InvalidDoubleKey",      "Invalid double value `{0}''"},
        {"InvalidNumberKey",      "Invalid numeric value `{0}''"},
        {"MissingQuoteKey",       "Missing closing quote"},
        {"IllegalTypeNameKey",    "Illegal service type name `{0}''"},
        {"UnknownTypeNameKey",    "Unknown service type `{0}''"},
        {"TypeExistsKey",         "Another type exists with the name `{0}''"},
        {"IntTypeMismatchKey",    "Interface type mismatch with {0}"},
        {"IllegalPropNameKey",    "Illegal property name `{0}''"},
        {"DuplicatePropNameKey",  "Duplicate property name `{0}''"},
        {"UnknownPropNameKey",    "Unknown property `{0}''"},
        {"PropRedefinedKey",      "Invalid redefinition of property `{0}''"},
        {"UnknownSuperTypeKey",   "Unknown super type `{0}''"},
        {"DuplicateSuperTypeKey", "Duplicate super type `{0}''"},
        {"TypeNotMaskedKey",      "Service type `{0}'' is not masked"},
        {"TypeAlreadyMaskedKey",  "Service type `{0}'' is already masked"},
        {"TypeHasSubtypesKey",    "Service type `{0}'' has subtypes"},
        {"UnknownSuperTypeKey",   "Unknown super type `{0}''"},
        {"InvalidObjectKey",      "Invalid object reference"},
        {"PropTypeMismatchKey",   "Property type mismatch for `{0}''"},
        {"ReadonlyDynamicKey",    "Read-only property `{0}'' cannot be dynamic"},
        {"MissingMandatoryKey",   "No value supplied for mandatory property `{0}''"},
        {"OfferImplKey",          "This trader does not allow offers to be modified"},
        {"IllegalOfferIdKey",     "Offer ID `{0}'' is illegal"},
        {"UnknownOfferIdKey",     "Unknown offer `{0}''"},
        {"ProxyOfferKey",         "Offer `{0}'' is a proxy offer"},
        {"NotProxyOfferKey",      "Offer `{0}'' is not a proxy offer"},
        {"MandatoryPropertyKey",  "Mandatory property `{0}'' cannot be deleted"},
        {"ReadonlyPropertyKey",   "Read-only property `{0}'' cannot be modified"},
        {"IllegalConstraintKey",  "Illegal constraint statement"},
        {"IllegalPrefKey",        "Illegal preference"},
        {"NoOffersKey",           "No matching offers were found"},
        {"InvalidLookupKey",      "Invalid reference for Lookup object"},
        {"IllegalRecipeKey",      "Constraint recipe is illegal"},
        {"IllegalPolicyKey",      "Illegal policy name `{0}''"},
        {"DuplicatePolicyKey",    "Duplicate policy `{0}''"},
        {"PolicyTypeMismatchKey", "Policy type mismatch for `{0}''"},
        {"InvalidPolicyValueKey", "Invalid policy value for `{0}''"},
        {"IllegalLinkNameKey",    "Illegal link name `{0}''"},
        {"UnknownLinkNameKey",    "Unknown link `{0}''"},
        {"LinkExistsKey",         "Another link exists with the name `{0}''"},
        {"DefaultFollowPermKey",  "Default follow rule is too permissive for `{0}''"},
        {"LimitingFollowPermKey", "Limiting follow rule is too permissive for `{0}''"},
        {"ClipboardEmptyKey",     "Clipboard is empty"},
        {"CannotCopyKey",         "Unable to copy `{0}'' - operation aborted"},
        {"CannotPasteTraderKey",  "Cannot paste clipboard data to this trader"},
        {"CannotPasteKey",        "Unable to paste: {0}"},
        {"CannotDeleteKey",       "Unable to delete: {0}"},
        {"CannotEditKey",         "Editing not supported for {0}"},
        {"CannotCloneKey",        "Clone not supported for {0}"},
        {"ListOfferImplKey",      "Admin::list_offers not implemented"},
        {"ListProxyImplKey",      "Admin::list_proxies not implemented"},
        {"EmptyNameKey",          "Name cannot be empty"},
        {"NoTypeKey",             "No service type is selected"},
        {"NoTypeCodeKey",         "No type is selected"},
        {"CannotConnectKey",      "Cannot connect to trader"},
        {"NoIntRepKey",           "No Interface Repository is available"},
        {"InvalidSTReposKey",     "Invalid reference for Service Type Repository"},

        // Prompts
        {"CannotPasteContKey",    "Unable to paste: {0}.  Continue with paste?"},
        {"CannotDeleteContKey",   "Unable to delete: {0}.  Continue with delete?"},
        {"ConfirmDeleteKey",      "Are you sure you want to delete `{0}''?"},
        {"ConfirmMultDeleteKey",  "Are you sure you want to delete these {0} selected items?"},

        // Labels
        {"ExactTypeMatchKey",     "Exact type match"},
        {"UseModifiableKey",      "Use modifiable properties"},
        {"UseDynamicKey",         "Use dynamic properties"},
        {"UseProxyKey",           "Use proxy offers"},
        {"SearchCardKey",         "Search cardinality"},
        {"MatchCardKey",          "Match cardinality"},
        {"ReturnCardKey",         "Return cardinality"},
        {"LinkFollowPolicyKey",   "Link follow policy"},
        {"LinkHopCountKey",       "Link hop count"},
        {"DescriptionOfKey",      "Description of `{0}'':"},
        {"MandatoryDescKey",      "mandatory"},
        {"ReadonlyDescKey",       "read-only"},
        {"NullValueKey",          "<no value>"},
        {"DynamicValueKey",       "<dynamic>"},
        {"NoneKey",               "None"},
        {"NilKey",                "<Nil>"},
        {"YesKey",                "Yes"},
        {"NoKey",                 "No"},
        {"InvalidKey",            "<Invalid>"},
        {"InterfaceDescKey",      "Interface:"},
        {"SuperTypesDescKey",     "Super types:"},
        {"PropertiesDescKey",     "Properties:"},
        {"MaskedDescKey",         "Masked:"},
        {"IncarnationDescKey",    "Incarnation:"},
        {"LocalOnlyKey",          "Local Only"},
        {"IfNoneLocalKey",        "If None Local"},
        {"AlwaysKey",             "Always"},
        {"TargetDescKey",         "Target:"},
        {"DefPassOnDescKey",      "Default pass-on follow rule:"},
        {"LimitPassOnDescKey",    "Limiting follow rule:"},
        {"TypeDescKey",           "Service type:"},
        {"ObjectDescKey",         "Object:"},
        {"IfMatchAllDescKey",     "If match all:"},
        {"RecipeDescKey",         "Constraint recipe:"},
        {"PoliciesDescKey",       "Policies to pass on:"},
        {"IORDescKey",            "IOR:"},
        {"DefFollowRuleKey",      "Default follow rule"},
        {"LimitFollowRuleKey",    "Limiting follow rule"},
        {"SupportTabKey",         "Support"},
        {"SupportModPropKey",     "Supports modifiable properties"},
        {"SupportDynPropKey",     "Supports dynamic properties"},
        {"SupportProxyKey",       "Supports proxy offers"},
        {"ServiceTypeReposKey",   "Service Type Repository"},
        {"ImportTabKey",          "Import"},
        {"DefaultKey",            "Default"},
        {"MaximumKey",            "Maximum"},
        {"MaxListCountKey",       "Maximum list count"},
        {"LinkTabKey",            "Link"},
        {"MaxLinkPolicyKey",      "Maximum link follow policy"},
        {"AdminTabKey",           "Admin"},
        {"RequestIdStemKey",      "Request identifier stem"},
        {"DefSearchCardKey",      "Default search cardinality"},
        {"MaxSearchCardKey",      "Maximum search cardinality"},
        {"DefMatchCardKey",       "Default match cardinality"},
        {"MaxMatchCardKey",       "Maximum match cardinality"},
        {"DefReturnCardKey",      "Default return cardinality"},
        {"MaxReturnCardKey",      "Maximum return cardinality"},
        {"DefHopCountKey",        "Default hop count"},
        {"MaxHopCountKey",        "Maximum hop count"},
        {"TypeNameKey",           "Service type name:"},
        {"TypeInterfaceKey",      "Interface:"},
        {"SuperTypesKey",         "Super types"},
        {"TypePropsKey",          "Properties"},
        {"PropNameKey",           "Name:"},
        {"PropTypeKey",           "Type:"},
        {"PropModeKey",           "Mode"},
        {"PropValueKey",          "Value:"},
        {"MandatoryKey",          "Mandatory"},
        {"ReadonlyKey",           "Read-only"},
        {"SelectSuperTypeKey",    "Select super types:"},
        {"NameKey",               "Name"},
        {"PropertiesKey",         "Properties"},
        {"PropertyKey",           "Property"},
        {"ValueKey",              "Value"},
        {"IORKey",                "IOR"},
        {"IORFileKey",            "From file"},
        {"ExtraInfoKey",          "Extra information:"},
        {"ExtraValueKey",         "Value:"},
        {"LinkNameKey",           "Name:"},
        {"LinkTargetKey",         "Target Lookup IOR"},
        {"QueryTypeKey",          "Service type:"},
        {"ConstraintKey",         "Constraint:"},
        {"PreferenceKey",         "Preference:"},
        {"DesiredPropsKey",       "Desired properties:"},
        {"OfferNumKey",           "Offer"},
        {"OfferTotalKey",         "of {0}"},
        {"OfferRefKey",           "Object reference:"},
        {"OfferPropsKey",         "Properties:"},
        {"OfferPropNameKey",      "Name"},
        {"OfferPropValueKey",     "Value"},
        {"WithdrawTypeKey",       "Service type:"},
        {"ProxyTargetKey",        "Target Lookup IOR"},
        {"ProxyRecipeKey",        "Constraint recipe:"},
        {"IfMatchAllKey",         "If match all"},
        {"ProxyPoliciesKey",      "Policies to pass on"},
        {"PolicyNameKey",         "Name:"},
        {"PolicyTypeKey",         "Type:"},
        {"PolicyValueKey",        "Value:"},
        {"ConnectIORKey",         "Trader IOR"},
        {"ConnectFileKey",        "IOR from file"},
        {"ConnectLinkKey",        "Link"},
        {"IntRepNameKey",         "Interface Repository"},
        {"SelectInterfaceKey",    "Select an interface:"},
        {"InterfaceIDKey",        "ID:"},

        // Menu items and accelerator characters
        {"ConsoleMenuKey",        "Console"},
        {"ConsoleMnemKey",        new Character('C')},
        {"NewWindowKey",          "New Window"},
        {"NewWindowMnemKey",      new Character('N')},
        {"ConnectKey",            "Connect"},
        {"ConnectMnemKey",        new Character('o')},
        {"CloseKey",              "Close"},
        {"CloseMnemKey",          new Character('C')},
        {"ExitKey",               "Exit"},
        {"ExitMnemKey",           new Character('x')},
        {"EditMenuKey",           "Edit"},
        {"EditMnemKey",           new Character('E')},
        {"CutKey",                "Cut"},
        {"CutMnemKey",            new Character('t')},
        {"CopyKey",               "Copy"},
        {"CopyMnemKey",           new Character('C')},
        {"PasteKey",              "Paste"},
        {"PasteMnemKey",          new Character('P')},
        {"SelectAllKey",          "Select All"},
        {"SelectAllMnemKey",      new Character('S')},
        {"CloneKey",              "Clone"},
        {"CloneMnemKey",          new Character('l')},
        {"ModifyKey",             "Modify"},
        {"ModifyMnemKey",         new Character('M')},
        {"DeleteKey",             "Delete"},
        {"DeleteMnemKey",         new Character('D')},
        {"ViewMenuKey",           "View"},
        {"ViewMnemKey",           new Character('V')},
        {"ViewTypesKey",          "Service Types"},
        {"ViewTypesMnemKey",      new Character('S')},
        {"ViewOffersKey",         "Offers"},
        {"ViewOffersMnemKey",     new Character('O')},
        {"ViewProxiesKey",        "Proxy Offers"},
        {"ViewProxiesMnemKey",    new Character('P')},
        {"ViewLinksKey",          "Links"},
        {"ViewLinksMnemKey",      new Character('L')},
        {"RefreshKey",            "Refresh"},
        {"RefreshMnemKey",        new Character('R')},
        {"InsertMenuKey",         "Insert"},
        {"InsertMnemKey",         new Character('I')},
        {"InsertTypeKey",         "Service Type"},
        {"InsertTypeMnemKey",     new Character('S')},
        {"InsertOfferKey",        "Offer"},
        {"InsertOfferMnemKey",    new Character('O')},
        {"InsertProxyKey",        "Proxy Offer"},
        {"InsertProxyMnemKey",    new Character('P')},
        {"InsertLinkKey",         "Link"},
        {"InsertLinkMnemKey",     new Character('L')},
        {"ToolsMenuKey",          "Tools"},
        {"ToolsMnemKey",          new Character('T')},
        {"QueryKey",              "Query"},
        {"QueryMnemKey",          new Character('Q')},
        {"AttributesKey",         "Attributes"},
        {"AttributesMnemKey",     new Character('A')},
        {"WithdrawKey",           "Withdraw Offers"},
        {"WithdrawMnemKey",       new Character('W')},
        {"MaskKey",               "Mask Type"},
        {"MaskMnemKey",           new Character('M')},
        {"UnmaskKey",             "Unmask Type"},
        {"UnmaskMnemKey",         new Character('U')},

        // ToolBar items
        {"ToolBarNewKey",         "New"},
        {"ToolBarCutKey",         "Cut"},
        {"ToolBarCopyKey",        "Copy"},
        {"ToolBarPasteKey",       "Paste"},
        {"ToolBarModifyKey",      "Modify"},
        {"ToolBarDeleteKey",      "Delete"},
        {"ToolBarQueryKey",       "Query"},
        {"ToolBarRefreshKey",     "Refresh"},

        // Status messages
        {"ReadyKey",              "Ready"},
        {"WaitKey",               "Wait"},
        {"LoadingDefAttribKey",   "Loading default trader attributes..."},
        {"LoadingAttribKey",      "Loading trader attributes..."},
        {"ExportingOfferKey",     "Exporting service offer..."},
        {"UpdatingOfferKey",      "Updating service offer..."},
        {"ExportingProxyKey",     "Exporting proxy offer..."},
        {"CopyingKey",            "Copying {0} of {1}"},
        {"AddingKey",             "Adding {0} of {1}"},
        {"DeletingKey",           "Deleting {0} of {1}"},
        {"MaskingKey",            "Masking type {0} of {1}"},
        {"UnmaskingKey",          "Unmasking type {0} of {1}"},
        {"LoadingTypesKey",       "Retrieving service types..."},
        {"LoadingLinksKey",       "Retrieving links..."},
        {"LoadingOffersKey",      "Retrieving service offers..."},
        {"RecvOffersKey",         "Received {0} offers..."},
        {"LoadingProxiesKey",     "Retrieving proxy offers..."},
        {"RecvProxiesKey",        "Received {0} proxy offers..."},
        {"InitPropsKey",          "Initializing properties..."},
        {"UpdatingLinkKey",       "Updating link..."},
        {"CollectSettingsKey",    "Collecting settings..."},
        {"CreatingTypeKey",       "Creating service type..."},
        {"CreatingLinkKey",       "Creating link..."},
        {"QueryingKey",           "Performing query..."},
        {"DisplayingResultsKey",  "Displaying results..."},
        {"LoadingMoreOffersKey",  "Retrieving more offers..."},
        {"WithdrawingOffersKey",  "Withdrawing offers..."},

        // Usage
        {"UsageKey",

            "Usage: java com.ooc.CosTradingConsole.Main [options]\n" +
            "\n" +
            "Options:\n" +
            "\n" +
            "  --windows       Use the Windows Look & Feel\n" +
            "  --motif         Use the Motif Look & Feel\n" +
            "  --look class    Use the specified JFC Look & Feel class\n" +
            "  -h,--help       Display this help message\n" +
            "\n"
        }

        // END OF MATERIAL TO LOCALIZE
    };
}
