// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Util;

import com.ooc.Util.GUI.*;
import javax.swing.*;

public abstract class BaseController extends TraderModelAdapter
{
    public static final Integer TYPE_ITEM    = new Integer(0);
    public static final Integer OFFER_ITEM = new Integer(1);
    public static final Integer PROXY_ITEM = new Integer(2);
    public static final Integer LINK_ITEM    = new Integer(3);


    public
    BaseController()
    {
    }

    public void
    refresh()
    {
        reload();
    }

    public abstract ListModel
    getListModel();

    public abstract boolean
    isEditable();

    public abstract Object
    getItemType();

    public abstract void
    clear();

    public abstract void
    newItem();

    public boolean
    cloneItem(Object item, StringBuffer message)
    {
        message.append(
            AppStandards.getFormattedString("CannotCloneKey",
                                            item.toString()));
        return false;
    }

    public boolean
    editItem(Object item, StringBuffer message)
    {
        message.append(
            AppStandards.getFormattedString("CannotEditKey", item.toString()));
        return false;
    }

    public abstract Object
    findItem(String name);

    public abstract boolean
    describeItem(Object item, FormattedText text, StringBuffer message);

    public abstract Object
    getItemData(Object item, StringBuffer message);

    public abstract boolean
    destroyItem(Object item, boolean notify, StringBuffer message);

    public abstract void
    fireItemsDestroyed();

    public abstract boolean
    addItem(String name,
            Object itemData,
            boolean notify,
            StringBuffer message);

    public abstract void
    fireItemsAdded();

    public abstract String
    toString();

    protected abstract void
    reload();
}
