// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Util;

import com.ooc.Util.*;
import com.ooc.Util.GUI.*;
import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;

public class PropertyTable extends JTable
{
    public
    PropertyTable(PropertyTableModel model)
    {
        super(model);

        TableColumn col;

        this.setColumnSelectionAllowed(false);
        this.setAutoCreateColumnsFromModel(false);
        this.setAutoResizeMode(this.AUTO_RESIZE_LAST_COLUMN);
        this.getTableHeader().setReorderingAllowed(false);
        col = this.getColumnModel().getColumn(0);
        col.setResizable(false);
        col.setCellRenderer(new IncludePropRenderer(model));
        col.setWidth(20);
        col.setMaxWidth(20);
        col.setMinWidth(20);
        col = this.getColumnModel().getColumn(1);
        col.setWidth(75);
        col.setMinWidth(75);
        col = this.getColumnModel().getColumn(2);
        JTextField textField = new JTextField();
        textField.setBorder(null);
        DefaultCellEditor editor = new DefaultCellEditor(textField);
        col.setCellEditor(editor);
        col.setWidth(50);
    }


    static class IncludePropRenderer implements TableCellRenderer
    {
        private PropertyTableModel model_;
        private JCheckBox check_;

        public
        IncludePropRenderer(PropertyTableModel model)
        {
            model_ = model;
            check_ = new JCheckBox("");
            check_.setHorizontalTextPosition(check_.CENTER);
            check_.setHorizontalAlignment(check_.CENTER);
            check_.setFocusPainted(false);
        }

        public Component
        getTableCellRendererComponent(JTable table,
                                      Object value,
                                      boolean isSelected,
                                      boolean hasFocus,
                                      int row,
                                      int column)
        {
            Prop prop = model_.getProperty(row);
            if (value != null)
                check_.setSelected(((Boolean)value).booleanValue());
            check_.setEnabled(! prop.isMandatory());
            return check_;
        }
    }
}
