// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Util;

import com.ooc.Util.*;
import com.ooc.Util.GUI.*;
import javax.swing.*;
import javax.swing.text.*;
import java.awt.Font;

public class TextUtil
{
    public static Style headerStyle;
    public static Style valueStyle;
    public static Style subValueStyle;

    private static StyleContext styleContext_;

    private
    TextUtil()
    {
    }

    public static void
    addBlankLine(StyledDocument doc)
    {
        addLine(doc, "", headerStyle);
    }

    public static void
    addLine(StyledDocument doc, String line, Style style)
    {
        if(line.length() == 0)
            line = " ";

        try
        {
            int pos = doc.getLength();
            doc.insertString(doc.getLength(), line, style);
            doc.setLogicalStyle(doc.getLength() - 1, style);
            doc.insertString(doc.getLength(), "\n", null);
        }
        catch(BadLocationException e)
        {
        }
    }

    // set up the document styles
    static
    {
        styleContext_ = new StyleContext();
        Style def = styleContext_.getStyle(StyleContext.DEFAULT_STYLE);

        headerStyle = styleContext_.addStyle("header", def);
        StyleConstants.setBold(headerStyle, true);
        StyleConstants.setItalic(headerStyle, false);

        valueStyle = styleContext_.addStyle("value", def);
        StyleConstants.setFirstLineIndent(valueStyle, 10);
        StyleConstants.setLeftIndent(valueStyle, 10);
        StyleConstants.setBold(valueStyle, false);
        StyleConstants.setItalic(valueStyle, false);

        subValueStyle = styleContext_.addStyle("subValue", valueStyle);
        StyleConstants.setLeftIndent(subValueStyle, 20);
    }
}
