// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTradingConsole.Util;

import com.ooc.Util.*;
import javax.swing.AbstractListModel;
import javax.swing.ComboBoxModel;
import org.omg.CosTradingRepos.*;
import org.omg.CosTradingRepos.ServiceTypeRepositoryPackage.*;

public class TypeComboBoxModel
    extends AbstractListModel
    implements ComboBoxModel
{
    private TraderModel model_;
    private String[] types_ = new String[0];
    private String selected_;

    public
    TypeComboBoxModel(TraderModel model)
    {
        model_ = model;
    }

    public int
    getSize()
    {
        return types_.length;
    }

    public Object
    getElementAt(int index)
    {
        return types_[index];
    }

    // From ComboBoxModel
    public void
    setSelectedItem(Object anItem)
    {
        selected_ = (String)anItem;
        fireContentsChanged(this, -1, -1);
    }

    public Object
    getSelectedItem()
    {
        return selected_;
    }

    public void
    reload()
    {
        selected_ = null;
        if(types_.length > 0)
            fireIntervalRemoved(this, 0, types_.length - 1);

        SpecifiedServiceTypes whichTypes = new SpecifiedServiceTypes();
        whichTypes._default(ListOption.all);

        StringBuffer msg = new StringBuffer();
        String[] arr = model_.listTypes(msg);
        QuickSort.sort(arr);
        types_ = arr;

        if(types_.length > 0)
            fireIntervalAdded(this, 0, types_.length - 1);
    }
}
