// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test;

public class Client extends TestBase implements Runnable
{
    org.omg.CORBA.ORB orb_;
    org.omg.CosTrading.Lookup trader_;

    public Client(org.omg.CORBA.ORB orb, org.omg.CORBA.BOA boa)
    {
        orb_ = orb;

        trader_ = connect(orb);
        TEST(trader_ != null);

        try
        {
            //
            // Run the tests in a separate thread
            //
            Thread t = new Thread(this);
            t.setPriority(Thread.NORM_PRIORITY - 1);
            t.start();

            boa.impl_is_ready(null);
        }
        catch(org.omg.CORBA.SystemException ex)
        {
            handleException(ex);
        }

        System.exit(1);
    }

    public void
    run()
    {
        try
        {
            System.out.print("Testing Admin interface... ");
            new TestAdmin(orb_, trader_);
            System.out.println("OK!");

            System.out.print("Testing Link interface... ");
            new TestLink(orb_, trader_);
            System.out.println("OK!");

            System.out.print("Testing Lookup interface... ");
            new TestLookup(orb_, trader_);
            System.out.println("OK!");

            System.out.print("Testing Proxy interface... ");
            new TestProxy(orb_, trader_);
            System.out.println("OK!");

            System.out.print("Testing Register interface... ");
            new TestRegister(orb_, trader_);
            System.out.println("OK!");

            System.out.print("Testing ServiceTypeRepository interface... ");
            new TestRepos(orb_, trader_);
            System.out.println("OK!");
        }
        catch(Exception ex)
        {
            handleException(ex);
        }

        System.exit(0);
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, props);
        org.omg.CORBA.BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);

        new Client(orb, boa);
    }
}
