// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util;

import java.util.*;
import java.text.*;

public class AppHelper
{
    static ResourceBundle resources_;

    protected
    AppHelper()
    {
    }

    public static void
    init(String bundle)
    {
	try
        {
            resources_ = ResourceBundle.getBundle(bundle);
        }
        catch(MissingResourceException e)
        {
            System.err.println("Unable to find resource bundle '" +
                               bundle + "'");
            System.exit(1);
        }
    }

    // returns a resource string
    public static String
    getString(String key)
    {
        return (String)getObject(key);
    }

    // returns a character resource
    public static char
    getChar(String key)
    {
        Character ch = (Character)getObject(key);
        return ch.charValue();
    }

    // returns a resource object
    public static Object
    getObject(String key)
    {
        Object result = null;

        try
        {
            result = resources_.getObject(key);
        }
        catch(MissingResourceException e)
        {
            System.err.println("No value found for resource '" + key + "'");
        }

        return result;
    }

    // returns a formatted resource string
    public static String
    getFormattedString(String key, Object arg)
    {
        Object[] args = { arg };
        return getFormattedString(key, args);
    }

    // The key should refer to a resource string that is a valid
    // pattern for use with the class java.text.MessageFormat
    public static String
    getFormattedString(String key, Object[] args)
    {
        String fmt = getString(key);
        return MessageFormat.format(fmt, args);
    }
}
