// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util;

public class BinarySearch
{
    private
    BinarySearch()
    {
    }

    public static int
    find(String[] vec, String key)
    {
        int result = -1;

        if(vec.length > 0)
        {
            int top = vec.length - 1;
            int bottom = 0;
            int pos, match;

            while(top > bottom)
            {
                pos = (top + bottom) >> 1;
                match = vec[pos].compareTo(key);
                if(match == 0)
                    return pos;
                else if(match > 0)
                    top = (pos > 0) ? (pos - 1) : 0;
                else
                    bottom = pos + 1;
            }

            pos = bottom;
            if(vec[pos].compareTo(key) == 0)
                result = pos;
        }

        return result;
    }

    public static int
    getInsertPosition(String[] vec, String key)
    {
        int result = 0;

        if(vec.length > 0)
        {
            int top = vec.length - 1;
            int bottom = 0;
            int pos, match;

            while(top > bottom)
            {
                pos = (top + bottom) >> 1;
                match = vec[pos].compareTo(key);
                if(match == 0)
                    return pos;
                else if(match > 0)
                    top = (pos > 0) ? (pos - 1) : 0;
                else
                    bottom = pos + 1;
            }

            pos = bottom;
            match = vec[pos].compareTo(key);
            if(match >= 0)
                result = pos;
            else
                result = pos + 1;
        }

        return result;
    }

    public static int
    find(Sortable[] vec, Sortable key, Object rock)
    {
        int result = -1;

        if(vec.length > 0)
        {
            int top = vec.length - 1;
            int bottom = 0;
            int pos, match;

            while(top > bottom)
            {
                pos = (top + bottom) >> 1;
                match = vec[pos].compareTo(key, rock);
                if(match == 0)
                    return pos;
                else if(match > 0)
                    top = (pos > 0) ? (pos - 1) : 0;
                else
                    bottom = pos + 1;
            }

            pos = bottom;
            if(vec[pos].compareTo(key, rock) == 0)
                result = pos;
        }

        return result;
    }

    public static int
    getInsertPosition(Sortable[] vec, Sortable key, Object rock)
    {
        int result = 0;

        if(vec.length > 0)
        {
            int top = vec.length - 1;
            int bottom = 0;
            int pos, match;

            while(top > bottom)
            {
                pos = (top + bottom) >> 1;
                match = vec[pos].compareTo(key, rock);
                if(match == 0)
                    return pos;
                else if(match > 0)
                    top = (pos > 0) ? (pos - 1) : 0;
                else
                    bottom = pos + 1;
            }

            pos = bottom;
            match = vec[pos].compareTo(key, rock);
            if(match >= 0)
                result = pos;
            else
                result = pos + 1;
        }

        return result;
    }
}
