// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.GUI;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

final public class FileChooserFilter extends FileFilter
{
    //
    // This filter's description
    //
    String description_;

    //
    // Extension handled by this filter
    //
    String extension_;

    public FileChooserFilter(String description, String extension)
    {
	description_ = description;
	extension_ = extension;
    }

    public boolean
    accept(File file)
    {
	if(file.isDirectory())
	    return true;

	String extension = "";

        String s = file.getName();
	int i = s.lastIndexOf('.');
        if(i > 0 && i < s.length() - 1)
            extension = s.substring(i + 1).toLowerCase();

	if(extension.equals(extension_))
	    return true;
	else
	    return false;
    }
    
    public String
    getDescription()
    {
        return description_;
    }
}
