// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.GUI;

import com.ooc.Util.*;
import com.ooc.Util.GUI.*;
import javax.swing.*;
import java.awt.*;

// Convenience methods that wrap JOptionPane
public class MessageDialog
{
    public static final int YES = 0;
    public static final int NO = 1;
    public static final int OK = 0;
    public static final int CANCEL = 1;

    private
    MessageDialog()
    {
    }

    public static void
    showError(Component comp, String message)
    {
        JOptionPane.showMessageDialog(comp, message,
                                      AppStandards.getString("ErrorTitleKey"),
                                      JOptionPane.ERROR_MESSAGE);
    }

    public static void
    showSystemError(Component comp, org.omg.CORBA.SystemException e)
    {
        e.printStackTrace();
        JOptionPane.showMessageDialog(comp,
            AppStandards.getString("SystemErrorKey"),
            AppStandards.getString("ErrorTitleKey"),
            JOptionPane.ERROR_MESSAGE);
    }

    public static int
    showConfirm(Component comp, String message)
    {
        int result;

        int i = JOptionPane.showConfirmDialog(comp, message,
            AppStandards.getString("ConfirmTitleKey"),
            JOptionPane.YES_NO_OPTION);

        if(i == JOptionPane.YES_OPTION)
            result = YES;
        else
            result = NO;

        return result;
    }
}
