// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IOP;

import org.omg.CORBA.*;

final public class IORAnalyzer
{
    private IORAnalyzer()
    {
    }

    public static org.omg.IOP.IOR
    getIOR(org.omg.CORBA.Object obj)
    {
	if(obj == null)
	    return null;

	ORB orb = ORB.init();
	String s = orb.object_to_string(obj);
	if(!s.startsWith("IOR:"))
	    return null;

	byte[] buf = com.ooc.CORBA.HexConverter.asciiToOctets(s, 4);
	if(buf == null)
	    return null;

	com.ooc.CORBA.InputStream in = new com.ooc.CORBA.InputStream(buf);
        in._OB_readEndian();
	return org.omg.IOP.IORHelper.read(in);
    }

    public static String
    dumpIOR(org.omg.CORBA.Object obj)
    {
	org.omg.IOP.IOR ior = getIOR(obj);
	if(ior == null)
	    return "Illegal object type\n";

	String result = "  type_id: " + ior.type_id + "\n";

	for(int i = 0 ; i < ior.profiles.length ; i++)
	{
	    ProfileTagAnalyzer a =
		ProfileTagAnalyzer.getAnalyzer(ior.profiles[i]);
	    if(a != null)
		result += a.analyze();
	    else
		result += "  Unknown profile tag\n";
	}

	return result;
    }
}
