// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IOP;

//
// This class analyzes profiles with the TAG_INTERNET_IOP (0) tag.
//

final class ProfileTag0 extends ProfileTagAnalyzer
{
    public String
    analyze()
    {
	String result;

	org.omg.IIOP.ProfileBody body =
	    org.omg.IIOP.ProfileBodyHelper.read(in_);

	result = "  iiop_version: " + body.iiop_version.major + "." +
	    body.iiop_version.minor + "\n";
	result += "  host: " + body.host + "\n";
 
	int port = body.port;
	if(port < 0)
	    port += 65536;
	result += "  port: " + port + "\n";
    
	return result;
    }

    public String
    getIORInfo()
    {
        in_._OB_readEndian();
	org.omg.IIOP.ProfileBody body =
	    org.omg.IIOP.ProfileBodyHelper.read(in_);

	int port = body.port;
	if(port < 0)
	    port += 65536;
    
	return "Host: " + body.host + ", Port: " + port;
    }
}
