// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IOP;

//
// ProfileTagAnalyzer and its derived classes analyze an IOR profile.
// For each profile tag TAG a class of the type 'ProfileTagTAG'
// is instantiated, if available. This classes returns a string
// describing the particular profile.
//

public abstract class ProfileTagAnalyzer
{
    public abstract String analyze();

    public abstract String getIORInfo();

    protected com.ooc.CORBA.InputStream in_;

    void setInputStream(com.ooc.CORBA.InputStream in)
    {
	in_ = in;
    }

    //
    // Get profile analyzer for a particular profile
    //
    public static ProfileTagAnalyzer
    getAnalyzer(org.omg.IOP.TaggedProfile profile)
    {
	String analyzer = "com.ooc.Util.CORBA.IOP.ProfileTag" +
	    profile.tag;
	try
	{
	    Class c = Class.forName(analyzer);

	    ProfileTagAnalyzer a = (ProfileTagAnalyzer)c.newInstance();
	    a.setInputStream(
                new com.ooc.CORBA.InputStream(profile.profile_data));
	    return a;
	}
	catch(ClassNotFoundException ex)
	{
	}
	catch(InstantiationException ex)
	{
	}
	catch(IllegalAccessException ex)
	{
	}

	return null;
    }
}
