// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA;

import com.ooc.Util.*;
import java.io.*;

public class IORUtil
{
    public static org.omg.CORBA.Object
    getObject(String ref, StringBuffer message)
    {
        org.omg.CORBA.Object result = null;
        org.omg.CORBA.ORB orb = ORBManager.ORB();

        message.setLength(0);

        try
        {
            result = orb.string_to_object(ref);
            if(result == null)
                message.append(AppHelper.getString("InvalidObjectKey"));
        }
        catch(org.omg.CORBA.SystemException e)
        {
            message.append(AppHelper.getString("InvalidObjectKey"));
        }

        return result;
    }

    public static org.omg.CORBA.Object
    getObject(File file, StringBuffer message)
    {
        org.omg.CORBA.Object result = null;
        org.omg.CORBA.ORB orb = ORBManager.ORB();

        message.setLength(0);

        try
        {
            if(! file.exists())
            {
                message.append(
                    AppHelper.getFormattedString("FileNotFoundKey",
                        file.getAbsolutePath()));
            }
            else
            {
                try
                {
                    FileReader reader = new FileReader(file);
                    BufferedReader in = new BufferedReader(reader);
                    String ref = in.readLine();
                    reader.close();
                    result = orb.string_to_object(ref);
                    if(result == null)
                        message.append(
                            AppHelper.getString("InvalidObjectKey"));
                }
                catch(IOException e)
                {
                    message.append(
                        AppHelper.getFormattedString("FileErrorKey",
                            file.getAbsolutePath()));
                }
            }
        }
        catch(org.omg.CORBA.SystemException e)
        {
            message.append(AppHelper.getString("InvalidObjectKey"));
        }

        return result;
    }
}
