// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public abstract class IRComponent
{
    private IRComponent parent_;

    public
    IRComponent(IRComponent parent)
    {
        parent_ = parent;
    }

    public IRComponent
    getParent()
    {
        return parent_;
    }

    //
    // Gets the repository ID - some components may not have an ID
    // (e.g., operation parameters)
    //
    public abstract String
    getID();

    public abstract String
    getName();

    //
    // Gets the definition kind - some components may not have a kind
    // (e.g., operation parameters)
    //
    public abstract org.omg.CORBA.DefinitionKind
    getKind();

    public boolean
    isContainer()
    {
        return false;
    }

    public IRComponent[]
    getContents()
    {
        return null;
    }
}
