// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public class IRComponentFactory
{
    public static IRComponent
    create(IRComponent parent,
           org.omg.CORBA.DefinitionKind kind,
           org.omg.CORBA.Any value,
           org.omg.CORBA.IRObject object)
    {
        IRComponent result = null;

        switch(kind.value())
        {
            case org.omg.CORBA.DefinitionKind._dk_Interface:
                result = new IRInterface(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Module:
                result = new IRModule(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Alias:
                result = new IRAlias(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Attribute:
                result = new IRAttribute(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Constant:
                result = new IRConstant(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Enum:
                result = new IREnum(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Operation:
                result = new IROperation(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Struct:
                result = new IRStruct(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Exception:
                result = new IRException(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Union:
                result = new IRUnion(parent, object, value);
                break;

            case org.omg.CORBA.DefinitionKind._dk_Typedef:
            case org.omg.CORBA.DefinitionKind._dk_Primitive:
            case org.omg.CORBA.DefinitionKind._dk_String:
            case org.omg.CORBA.DefinitionKind._dk_Sequence:
            case org.omg.CORBA.DefinitionKind._dk_Array:
            default:
                throw new RuntimeException("Unexpected DefinitionKind");
        }

        return result;
    }

    private
    IRComponentFactory()
    {
    }
}
