// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public abstract class IRContainer extends IRComponent
{
    private org.omg.CORBA.Container container_;
    private IRComponent[] children_ = null;

    public
    IRContainer(IRComponent parent, org.omg.CORBA.IRObject object)
    {
        super(parent);

        container_ = org.omg.CORBA.ContainerHelper.narrow(object);
    }

    public boolean
    isContainer()
    {
        return true;
    }

    public IRComponent[]
    getContents()
    {
        if(children_ == null)
            loadChildren();

        return children_;
    }

    protected void
    loadChildren()
    {
        org.omg.CORBA.ContainerPackage.Description[] desc =
            container_.describe_contents(
                org.omg.CORBA.DefinitionKind.dk_all, true, -1);

        children_ = new IRComponent[desc.length];

        for(int i = 0 ; i < desc.length ; i++)
        {
            children_[i] =
                IRComponentFactory.create(this, desc[i].kind, desc[i].value,
                                          desc[i].contained_object);
        }
    }
}
