// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public class IREnum extends IRComponent
{
    private org.omg.CORBA.IRObject object_;
    private org.omg.CORBA.TypeDescription desc_;
    private IRComponent[] children_ = null;

    public
    IREnum(IRComponent parent,
           org.omg.CORBA.IRObject object,
           org.omg.CORBA.Any value)
    {
        super(parent);
        object_ = object;
        desc_ = org.omg.CORBA.TypeDescriptionHelper.extract(value);
    }

    public String
    getID()
    {
        return desc_.id;
    }

    public String
    getName()
    {
        return desc_.name;
    }

    public org.omg.CORBA.DefinitionKind
    getKind()
    {
        return org.omg.CORBA.DefinitionKind.dk_Enum;
    }

    public boolean
    isContainer()
    {
        return true;
    }

    public IRComponent[]
    getContents()
    {
        if(children_ == null)
            loadChildren();

        return children_;
    }

    protected void
    loadChildren()
    {
        org.omg.CORBA.EnumDef e = org.omg.CORBA.EnumDefHelper.narrow(object_);
        String[] members = e.members();
        
        children_ = new IRComponent[members.length];

        for(int i = 0 ; i < members.length ; i++)
            children_[i] = new IREnumValue(this, desc_.type, members[i]);
    }
}
