// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public class IRException extends IRComponent
{
    private org.omg.CORBA.IRObject object_;
    private org.omg.CORBA.ExceptionDescription desc_;
    private IRComponent[] children_ = null;

    public
    IRException(IRComponent parent,
                org.omg.CORBA.IRObject object,
                org.omg.CORBA.Any value)
    {
        super(parent);
        object_ = object;
        desc_ = org.omg.CORBA.ExceptionDescriptionHelper.extract(value);
    }

    public String
    getID()
    {
        return desc_.id;
    }

    public String
    getName()
    {
        return desc_.name;
    }

    public org.omg.CORBA.DefinitionKind
    getKind()
    {
        return org.omg.CORBA.DefinitionKind.dk_Exception;
    }

    public boolean
    isContainer()
    {
        return true;
    }

    public IRComponent[]
    getContents()
    {
        if(children_ == null)
            loadChildren();

        return children_;
    }

    protected void
    loadChildren()
    {
        org.omg.CORBA.ExceptionDef e =
            org.omg.CORBA.ExceptionDefHelper.narrow(object_);

        org.omg.CORBA.StructMember[] members = e.members();

        children_ = new IRComponent[members.length];
        for(int i = 0 ; i < members.length ; i++)
            children_[i] = new IRStructMember(this, members[i]);
    }
}
