// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IntRep;

public class IROperation extends IRComponent
{
    private org.omg.CORBA.IRObject object_;
    private org.omg.CORBA.OperationDescription desc_;
    private IRComponent[] children_ = null;

    public
    IROperation(IRComponent parent,
                org.omg.CORBA.IRObject object,
                org.omg.CORBA.Any value)
    {
        super(parent);
        object_ = object;
        desc_ = org.omg.CORBA.OperationDescriptionHelper.extract(value);
    }

    public String
    getID()
    {
        return desc_.id;
    }

    public String
    getName()
    {
        return desc_.name;
    }

    public org.omg.CORBA.DefinitionKind
    getKind()
    {
        return org.omg.CORBA.DefinitionKind.dk_Operation;
    }

    public boolean
    isContainer()
    {
        return true;
    }

    public IRComponent[]
    getContents()
    {
        if(children_ == null)
            loadChildren();

        return children_;
    }

    protected void
    loadChildren()
    {
        java.util.Vector vec = new java.util.Vector();

        for(int i = 0 ; i < desc_.parameters.length ; i++)
            vec.addElement(new IROpParameter(this, desc_.parameters[i]));

        for(int i = 0 ; i < desc_.contexts.length ; i++)
            vec.addElement(new IROpContext(this, desc_.contexts[i]));

        for(int i = 0 ; i < desc_.exceptions.length ; i++)
            vec.addElement(new IROpException(this, desc_.exceptions[i]));

        children_ = new IRComponent[vec.size()];
        vec.copyInto(children_);
    }
}
