// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util;

import java.util.*;

public class Clipboard
{
    private Vector listeners_ = new Vector();
    private ClipboardData data_;
    private static Clipboard instance_ = null;

    protected
    Clipboard()
    {
    }

    public synchronized static Clipboard
    instance()
    {
        if(instance_ == null)
            instance_ = new Clipboard();
        return instance_;
    }

    public synchronized void
    setData(ClipboardData data)
    {
        data_ = data;
        Enumeration e = listeners_.elements();
        while(e.hasMoreElements())
        {
            ClipboardListener l = (ClipboardListener)e.nextElement();
            l.clipboardChanged(data);
        }
    }

    public synchronized ClipboardData
    getData()
    {
        return data_;
    }

    public synchronized void
    addClipboardListener(ClipboardListener l)
    {
        listeners_.addElement(l);
    }

    public synchronized void
    removeClipboardListener(ClipboardListener l)
    {
        listeners_.removeElement(l);
    }
}
