// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util;

public class QuickSort
{
    private
    QuickSort()
    {
    }

    public static void
    sort(String[] arr)
    {
        sortImpl(arr, 0, arr.length - 1);
    }

    public static void
    sort(Sortable[] arr, Object rock)
    {
        sortImpl(arr, 0, arr.length - 1, rock);
    }

    protected static void
    sortImpl(String[] arr, int l, int h)
    {
        int low = l;
        int hi = h;
        String mid;

        if(h > l)
        {
            mid = arr[(l + h) / 2];

            while(low <= hi)
            {
                while(low < h && arr[low].compareTo(mid) < 0)
                    low += 1;

                while(hi > l && arr[hi].compareTo(mid) > 0)
                    hi -= 1;

                if(low <= hi)
                {
                    String tmp = arr[low];
                    arr[low] = arr[hi];
                    arr[hi] = tmp;

                    low += 1;
                    hi -= 1;
                }
            }

            if(l < hi)
                sortImpl(arr, l, hi);

            if(low < h)
                sortImpl(arr, low, h);
        }
    }

    static void
    sortImpl(Sortable[] arr, int l, int h, Object rock)
    {
        int low = l;
        int hi = h;
        Sortable mid;

        if(h > l)
        {
            mid = arr[(l + h) / 2];

            while(low <= hi)
            {
                while(low < h && arr[low].compareTo(mid, rock) < 0)
                    low += 1;

                while(hi > l && arr[hi].compareTo(mid, rock) > 0)
                    hi -= 1;

                if(low <= hi)
                {
                    Sortable tmp = arr[low];
                    arr[low] = arr[hi];
                    arr[hi] = tmp;

                    low += 1;
                    hi -= 1;
                }
            }

            if(l < hi)
                sortImpl(arr, l, hi, rock);

            if(low < h)
                sortImpl(arr, low, h, rock);
        }
    }
}
