// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.IIOP.impl;

public class ConFactoryInfo extends com.ooc.CORBA.LocalObject
    implements com.ooc.OCI.IIOP.ConFactoryInfo
{
    //
    // All connect callback objects
    //
    private java.util.Vector connectCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public int tag()
    {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public synchronized void
    add_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0; i < length; ++i)
            if(connectCBVec_.elementAt(i) == cb)
                return; // Already registered
        connectCBVec_.addElement(cb);
    }

    public synchronized void
    remove_connect_cb(com.ooc.OCI.ConnectCB cb)
    {
        int length = connectCBVec_.size();
        for(int i = 0; i < length; ++i)
            if(connectCBVec_.elementAt(i) == cb)
            {
                connectCBVec_.removeElementAt(i);
                return;
            }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    synchronized com.ooc.OCI.ConnectCB[]
    _OB_getConnectCBSeq()
    {
        int length = connectCBVec_.size();
        com.ooc.OCI.ConnectCB[] cbs = new com.ooc.OCI.ConnectCB[length];
        for(int i = 0; i < length; ++i)
        {
            com.ooc.OCI.ConnectCB cb =
                (com.ooc.OCI.ConnectCB)connectCBVec_.elementAt(i);
            cbs[i] = cb;
        }
        return cbs;
    }
}
