// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.impl;
import com.ooc.OCI.*;

final public class Current extends com.ooc.CORBA.LocalObject
    implements com.ooc.OCI.Current
{
    // Map thread -> transport info
    private java.util.Hashtable table_ = new java.util.Hashtable();

    private boolean hasNull_ = true;
    
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public com.ooc.OCI.TransportInfo
    get_oci_transport_info()
    {
        if(hasNull_)
            return null;

        return (com.ooc.OCI.TransportInfo)table_.get(Thread.currentThread());
    }

    public com.ooc.OCI.AcceptorInfo
    get_oci_acceptor_info()
    {
        com.ooc.OCI.TransportInfo info = get_oci_transport_info();
        if(info != null)
            return info.acceptor_info();
        else
            return null;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public com.ooc.OCI.TransportInfo
    _OB_setOCITransportInfo(com.ooc.OCI.TransportInfo info)
    {
        com.ooc.OCI.TransportInfo save;

        if(hasNull_)
        {
            save = null;
        }
        else
        {
            //
            // Need to hash on the current thread id.
            //
            save = (com.ooc.OCI.TransportInfo)
                table_.get(Thread.currentThread());
        }

        if(info == null)
        {
            hasNull_ = true;
            table_.remove(Thread.currentThread());
        }
        else
        {
            table_.put(Thread.currentThread(), info);
            hasNull_ = false;
        }

        return save;
    }
}

