// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTime;

import org.omg.CORBA.*;
import org.omg.TimeBase.*;

final class TimeService_impl
    extends com.ooc.CORBA.LocalObject
    implements org.omg.CosTime.TimeService
{
    //
    // Inaccuracy in 100 ns units as defined by the user
    //
    private long inaccuracy_;

    // ------------------------------------------------------------------
    // TimeService_impl constructor
    // ------------------------------------------------------------------

    public TimeService_impl(long inaccuracy)
    {
	if(Unsigned.gt(inaccuracy, TimeHelper.MaxInaccuracyT))
	    throw new BAD_PARAM();

	inaccuracy_ = inaccuracy;
    }
 
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public org.omg.CosTime.UTO
    universal_time()
	throws org.omg.CosTime.TimeUnavailable
    {
	return new UTO_impl(TimeHelper.utcNow(inaccuracy_));
    }

    public org.omg.CosTime.UTO
    secure_universal_time()
	throws org.omg.CosTime.TimeUnavailable
    {
	throw new org.omg.CosTime.TimeUnavailable();
    }

    public org.omg.CosTime.UTO
    new_universal_time(long time, long inaccuracy, short tdf)
    {
	if(Unsigned.gt(inaccuracy, TimeHelper.MaxInaccuracyT))
	    throw new BAD_PARAM();

	return new UTO_impl(time, inaccuracy, tdf);
    }

    public org.omg.CosTime.UTO
    uto_from_utc(UtcT utc)
    {
	return new UTO_impl(utc);
    }

    public org.omg.CosTime.TIO
    new_interval(long lower, long upper)
    {
	if(Unsigned.gt(lower, upper))
	    throw new BAD_PARAM();

	return new TIO_impl(lower, upper);
    }
}

